/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fjsproyect;

import java.util.HashMap;
import java.util.Map;
import java.io.*;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
//import org.math.plot.FrameView;
//import org.math.plot.Plot3DPanel;
import java.util.Date;
import javax.swing.JOptionPane;
//C:\Users\Andres_Garcia\Desktop\prueba1

/**
 *
 * @author Andres_Garcia
 */
public class FJSProyect {

    //The set of jobs
    static HashMap<Integer, Job> jobs;
    //This the set of the operations for jobs
    static HashMap<String, Operation> operations;
    //This set contains the dummy phi-nodes, start and *
    static HashMap<String, Operation> exclusiveOperations;

    static int totalJobs;
    static Machine[] machines;
    //Operations to evaluate the moves for the neighborhood N1. 
    static LinkedList<String> operationsTomove1;
    //Operations to evaluate the moves for the neighborhood N2.
    static LinkedList<String> operationsTomove2;
    //Operations to evaluate for the neighborhood N1-N2

    static int criterionValue;
    //This is the value of the makespan
    static int criterionMk;
    //This is the value for the maximmum tardiness
    static int criterionTmax;
    //This is the value of Total flow time
    static int criterionTFT;
    //This is the value for Total weighted flow time
    static int criterionTWFT;
    //This is the value for the total weighted tardiness
    static int criterionTWT;
    //This is the value for the total weighted tardy jobs
    static int criterionTWU;
    //This set represent the feasible insertions which estimatiion is less tahn the current one.

    static int[] orderOfJobs;
    static int maxOperationPerJob;

    static LinkedList<Insertion> insertions;
    static LinkedList<Insertion> insertionsReal;
    static LinkedList<LinkedList<String>> bellmanOrder;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here

        //Ask for a folder to read according to the Hurink format. 
        String folder = JOptionPane.showInputDialog("write the address of the folder to read");
        String chosenCriterion = JOptionPane.showInputDialog("write the criterion makespan, tmax, tc, twt");
        File directorio = new File(folder);
        String[] listaDirectorio = directorio.list();
        if (listaDirectorio == null) {
            System.out.println("There are not files in the folder to read");
        } else {
            for (int xyz = 0; xyz < listaDirectorio.length; xyz++) {
                File finalResults = new File(folder + File.separator + "(" + listaDirectorio[xyz] + "-" + chosenCriterion + ")");
                finalResults.mkdir();
                for (int neigh = 1; neigh < 2; neigh++) {

                    int totalMachines = 0;
                    float flexibility = 0;
                    int maximumNumberOperation;
                    int totalOperationPerMachine;
                    double averageTimeOperation;
                    double averageTimeJob;
                    double sumOperation;
                    double sumJob;

                    //Vectors for definning the order of jobs for initial solution
                    int[] orderOfJobs;
                    int[] duedateVector;
                    double[] averageTimeVector;
                    int[] weigthvector;
                    int[] numbOperationVector;

                    int maxOperationPerJob;
                    String criterion1;
                    String criterion2;
                    String criterion3;
                    String criterion4;
                    String criterion5;
                    String criterion6;
                    String type;
                    int control;

                    Machine[] machines = null;

                    HashMap<String, Operation> exclusiveOperations = new HashMap<>();
                    HashMap<String, Operation> operations = new HashMap<>();
                    HashMap<String, Operation> operationsToMove2 = new HashMap<>();
                    HashMap<String, Operation> operationsToMove3 = new HashMap<>();
                    HashMap<Integer, Job> jobs = new HashMap<>();
                    LinkedList<String> operationsTomove1 = new LinkedList<>();
                    LinkedList<String> operationsTomove2 = new LinkedList<>();
                    LinkedList<String> operationsTomove3 = new LinkedList<>();
                    LinkedList<Insertion> insertions = new LinkedList<>();
                    LinkedList<Insertion> insertionsReal = new LinkedList<>();
                    LinkedList<Schedule> schedules = new LinkedList<>();
                    LinkedList<Schedule> schedules2 = new LinkedList<>();
                    LinkedList<Schedule> schedules3 = new LinkedList<>();
                    LinkedList<Schedule> schedulesFinal = new LinkedList<>();
                    LinkedList<LinkedList<String>> bellmanOrder = new LinkedList<>();

                    //----------------
                    try {
                        FileReader r = new FileReader(folder + File.separator + listaDirectorio[xyz]);
                        BufferedReader buffer = new BufferedReader(r);
                        String firstInformation = buffer.readLine();
                        //The line is divided to form an array
                        String[] arrayFirstInformation = firstInformation.split(" ");
                        // With the array, it is possible to obtain the variables. 
                        totalJobs = Integer.parseInt(arrayFirstInformation[0]);
                        totalMachines = Integer.parseInt(arrayFirstInformation[1]);
                        //Start represents the node 0. 
                        Operation start = new Operation();
                        start.setId("start");
                        exclusiveOperations.put(start.getId(), start);
                        machines = new Machine[totalMachines];
                        for (int i = 0; i < totalMachines; i++) {
                            Machine newMachine = new Machine();
                            newMachine.setId(i + 1);
                            newMachine.addNewOperation("start");
                            machines[i] = newMachine;
                        }

                        flexibility = Float.parseFloat(arrayFirstInformation[2]);
                        // Node endMachine represents the node *

                        Operation endMachine = new Operation();
                        endMachine.setId("endMachine");
                        exclusiveOperations.put(endMachine.getId(), endMachine);
                        //Due-date vector saves increasing order of jobs according to its due date
                        duedateVector = new int[totalJobs];
                        // average time vector increasing order
                        averageTimeVector = new double[totalJobs];
                        // w vector decreasing order
                        weigthvector = new int[totalJobs];
                        maxOperationPerJob = 0;
                        numbOperationVector = new int[totalJobs];
                        //This cicle creates the w-values for the jobs according to Singer & Pinedo's approach
                        for (int i = 0; i < totalJobs; i++) {
                            sumJob = 0;
                            Job newJob = new Job();
                            newJob.setId(i + 1);
                            if (i < 0.2 * totalJobs) {
                                newJob.setWeigthValue(1);
                                weigthvector[i] = newJob.getWeigthValue();
                            }
                            if (i >= 0.2 * totalJobs && i < 0.8 * totalJobs) {
                                newJob.setWeigthValue(1);
                                weigthvector[i] = newJob.getWeigthValue();
                            }
                            if (i >= 0.8 * totalJobs) {
                                weigthvector[i] = 1;
                            }

                            String jobInformation = buffer.readLine().trim();
                            String[] arrayJobInformation;
                            int position = 0;
                            arrayJobInformation = jobInformation.split(" ");
                            int operationPerJob = Integer.parseInt(arrayJobInformation[position]);
                            numbOperationVector[i] = operationPerJob;
                            newJob.setNumberOfOperations(operationPerJob);
                            if (operationPerJob > maxOperationPerJob) {
                                maxOperationPerJob = operationPerJob;
                            }

                            endMachine.addTail((i + 1), Operation.MINIMUN_TAIL);

                            Operation endByJob = new Operation();
                            endByJob.setTimeMachine(0);
                            endByJob.setId("endByJob_" + (i + 1));

                            for (int j = 0; j < totalJobs; j++) {

                                endByJob.addTail(j + 1, Operation.MINIMUN_TAIL);
                            }
                            endByJob.addTail(i + 1, 0);
                            endByJob.setTailMax(0);
                            exclusiveOperations.put(endByJob.getId(), endByJob);

                            for (int j = 0; j < operationPerJob; j++) {
                                Operation newOperation = new Operation();
                                newOperation.setId(newJob.getId() + "-" + (j + 1));
                                newOperation.setJob(i + 1);
                                if (j == 0) {
                                    newOperation.setPreviewOperationByJob("start");
                                    newOperation.setNextOperationByJob(newJob.getId() + "-" + (j + 2));
                                } else if (j > 0 && j < operationPerJob - 1) {
                                    newOperation.setPreviewOperationByJob(newJob.getId() + "-" + (j));
                                    newOperation.setNextOperationByJob(newJob.getId() + "-" + (j + 2));
                                } else if (j == (operationPerJob - 1)) {
                                    newOperation.setPreviewOperationByJob(newJob.getId() + "-" + (j));
                                    newOperation.setNextOperationByJob("endByJob_" + (i + 1));
                                }
                                position++;
                                int availibleMachines = Integer.parseInt(arrayJobInformation[position]);

                                sumOperation = 0;
                                for (int k = 0; k < availibleMachines; k++) {
                                    position++;
                                    int machine = Integer.parseInt(arrayJobInformation[position]);
                                    position++;
                                    int timeMachine = Integer.parseInt(arrayJobInformation[position]);
                                    sumOperation = sumOperation + timeMachine;
                                    newOperation.addOptionMachine(machine, timeMachine);
                                }
                                sumJob += (sumOperation / availibleMachines);

                                newJob.addOperations(newOperation.getId());
                                operations.put(newOperation.getId(), newOperation);
                            }
                            newJob.setAverageTime(sumJob);
                            averageTimeVector[i] = (double) (newJob.getAverageTime());
                            newJob.setDueDate((int) Math.rint(newJob.getAverageTime() * 1.3));
                            duedateVector[i] = newJob.getDueDate();
                            jobs.put(newJob.getId(), newJob);

                        }

                        /*System.out.println("El numero de pedidos es---" + jobs.size());
                        System.out.println("-El numero total de operaciones es---" + operations.size());
                        for (int i = 1; i <= jobs.size(); i++) {
                            Job job1 = jobs.get(i);
                            System.out.println("El trabajo" + job1.getId() + "-tiene--" + job1.getJobOperations().size());
                            for (int j = 0; j < job1.getNumberOfOperations(); j++) {
                                Operation op1 = operations.get(job1.getJobOperations().get(j));
                                for (int m = 0; m < machines.length; m++) {
                                    if (op1.getTimesInMachine().containsKey(m+1)) {
                                        System.out.println("La operación-" + op1.getId() + " se puede hacer en maquina " + machines[m].getId() + "- el tiempo es--" + op1.findTimeInMachine(m+1));
                                    }
                                }

                            }

                        }
                        System.out.println("--Lo hemos probado");
                        }*/ 
                        
                        
                        
                        
                    
                        
                                            
                            
                                    
                                
                                            
                                        

                            

                        
              

                        //-------The arrange of jobs for w-criteria 
                        //-------w value, due-date.-------
                        orderOfJobs = new int[totalJobs];

                        for (int i = 0; i < totalJobs; i++) {
                            int auxiliar = i;
                            for (int j = 0; j < totalJobs; j++) {
                                if (weigthvector[auxiliar] < weigthvector[j]) {
                                    auxiliar = j;
                                } else if (weigthvector[auxiliar] == weigthvector[j] && duedateVector[auxiliar] < duedateVector[j]) {
                                    auxiliar = j;
                                }
                            }
                            orderOfJobs[i] = auxiliar + 1;
                            weigthvector[auxiliar] = 0;
                            duedateVector[auxiliar] = 0;

                        }
                        //To do. Create Alvaro's solutions
                        setOrderOfJobs(orderOfJobs);
                        setMaxOperationPerJob(maxOperationPerJob);
                        //----Initial solution-------
                        //----PerJob-----PerOperation
                        for (int i = 0; i < maxOperationPerJob; i++) {
                            for (int j = 0; j < totalJobs; j++) {
                                Job tmp = jobs.get(orderOfJobs[j]);
                                if (i < tmp.getJobOperations().size()) {

                                    //Invoke the operation on the lecture arrangement  
                                    String p = jobs.get(orderOfJobs[j]).getJobOperations().get(i);
                                    Operation op = operations.get(p);

                                    //Invoke the preview operation by job
                                    String pbj = op.getPreviewOperationByJob();
                                    Operation pj;
                                    if (pbj.equals("start")) {
                                        pj = exclusiveOperations.get("start");
                                    } else {
                                        pj = operations.get(pbj);
                                    }
                                    int begin = pj.getCompletionTime();
                                    int fin = 10000000;
                                    int assignedMachine = 0;

                                    for (int k = 1; k <= totalMachines; k++) {
                                        if (op.getTimesInMachine().containsKey(k)) {
                                            int fin2 = Math.max(begin + op.findTimeInMachine(k), machines[k - 1].getTimeClock() + op.findTimeInMachine(k));

                                            if (fin2 < fin) {
                                                fin = fin2;
                                                assignedMachine = k;
                                            }

                                        }
                                    }
                                    String pbm = machines[assignedMachine - 1].getAssignedOperations().getLast();
                                    Operation pm;
                                    op.setPreviewOperationByMachine(pbm);
                                    if (pbm.equals("start")) {
                                        pm = exclusiveOperations.get("start");
                                    } else {
                                        pm = operations.get(pbm);
                                        pm.setNextOperationByMachine(op.getId());
                                        op.setPreviewOperationByMachine(pm.getId());
                                        operations.put(pm.getId(), pm);
                                    }

                                    op.setMachineAssigned(assignedMachine);
                                    op.setCompletionTime(fin);
                                    op.setStartTime(fin - op.timeInMachine(assignedMachine));
                                    op.setTimeMachine(op.timeInMachine(assignedMachine));
                                    operations.put(op.getId(), op);

                                    machines[assignedMachine - 1].setTimeClock(fin);
                                    machines[assignedMachine - 1].addNewOperation(op.getId());
                                }

                            }

                        }

                    } catch (IOException e) {
                        System.out.println(e.getMessage());

                    }

                    // Here the attributes of the main class are invoked by means setters.
                    setOperations(operations);
                    setJobs(jobs);
                    setExclusiveOperations(exclusiveOperations);
                    setMachines(machines);
                    setOperationsTomove1(operationsTomove1);
                    setOperationsTomove2(operationsTomove2);
                    setBellmanOrder(bellmanOrder);
                    setInsertions(insertions);
                    setInsertionsReal(insertionsReal);

//------------------------Application: Type of moves  --------------------- 
                    LinkedList<Integer> order = new LinkedList<>();
                    //criterion1 = "makespan";
                    //criterion1 = "twu";
                    //criterion1 = "tmax";
                    criterion1 = chosenCriterion;
                    //criterion1 = "twt";
                    //type variable represents the neighborhood structure 

                    //type1---> represents N1
                    //type2---> represents N2
                    type = "type1";
                    if (neigh
                            == 2) {
                        type = "type2";
                    }

                    deleteStructureandUpdateDate(type);
                    order = new LinkedList<>(updateJobsandExclusive(criterion1));
                    updateJobTails(order, type);

                    int makespan = getCriterionValue();
                    int tmax = getCriterionTmax();
                    int tft = getCriterionTFT();
                    int twt = getCriterionTWT();
                    int twu = getCriterionTWU();

                    System.out.println("Solution 1----Makespan-" + makespan + "-Tmax-" + tmax + "-tft-" + tft + "-twu-" + twu + "-TWT-" + twt);

                    //Initial solution Algorithm 1
                    deleteAndIntStartinMachines();
                    for (int i = 1; i <= totalJobs; i++) {
                        Job job1 = jobs.get(getOrderOfJobs()[i - 1]);
                        System.out.println("--Job--" + job1.getId());
                        for (int j = 0; j < job1.getNumberOfOperations(); j++) {
                            Operation op = operations.get(job1.getJobOperations().get(j));

                            if (op.getTimesInMachine().size() == 1) {
                                machines[op.getMachineAssigned() - 1].addOperationToPerform(op.getId());
                            } else {
                                int min = 100000;

                                for (Integer key : op.getTimesInMachine().keySet()) {
                                    if (min > op.findTimeInMachine(key)) {
                                        min = op.findTimeInMachine(key);
                                    }
                                }

                                int cont = 0;
                                int machine = 0;
                                for (Integer key : op.getTimesInMachine().keySet()) {
                                    if (min == op.findTimeInMachine(key)) {
                                        cont++;
                                        machine = key;
                                    }
                                }
                                if (cont == 1) {
                                    op.setMachineAssigned(machine);
                                    op.setTimeMachine(op.getTimesInMachine().get(op.getMachineAssigned()));
                                    machines[op.getMachineAssigned() - 1].addOperationToPerform(op.getId());
                                }

                                if (cont > 1) {
                                    LinkedList<Integer> orderTemp = new LinkedList<>();
                                    for (Integer key : op.getTimesInMachine().keySet()) {
                                        if (min == op.findTimeInMachine(key)) {
                                            orderTemp.add(key);

                                        }
                                    }
                                    int minOp = 100000;
                                    int mach = 0;
                                    for (int k = 0; k < orderTemp.size(); k++) {
                                        if (machines[orderTemp.get(k) - 1].getOperationsToperform().size() < minOp) {
                                            minOp = machines[orderTemp.get(k) - 1].getOperationsToperform().size();
                                            mach = machines[orderTemp.get(k) - 1].getId();
                                        }
                                    }
                                    machines[mach - 1].addOperationToPerform(op.getId());
                                    op.setMachineAssigned(mach);
                                    op.setTimeMachine(op.getTimesInMachine().get(op.getMachineAssigned()));

                                }

                            }

                            operations.put(op.getId(), op);
                            System.out.println("Operation--" + op.getId() + "--was assigned to the machine--" + op.getMachineAssigned());
                        }

                    }

                    for (int m = 0; m < machines.length; m++) {
                        machines[m].getOperationsToperform().clear();
                    }

                    //Assignment by columns
                    for (int i = 0; i < getMaxOperationPerJob(); i++) {
                        for (int j = 1; j <= totalJobs; j++) {
                            Job job1 = jobs.get(j);
                            if (job1.getNumberOfOperations() >= i + 1) {
                                Operation op = operations.get(job1.getJobOperations().get(i));
                                int mach = op.getMachineAssigned();
                                machines[mach - 1].addOperationToPerform(op.getId());
                            }
                        }

                        for (int m = 0; m < machines.length; m++) {
                            if (machines[m].getOperationsToperform().size() == 1) {
                                Operation op = operations.get(machines[m].getOperationsToperform().get(0));
                                op.setPreviewOperationByMachine(machines[m].getAssignedOperations().getLast());
                                if (!machines[m].getAssignedOperations().getLast().equals("start")) {
                                    Operation suc = operations.get(machines[m].getAssignedOperations().getLast());
                                    suc.setNextOperationByMachine(op.getId());
                                    operations.put(suc.getId(), suc);
                                }
                                machines[m].addNewOperation(op.getId());
                                operations.put(op.getId(), op);
                            }
                            if (machines[m].getOperationsToperform().size() > 1) {
                                for (int ord = 0; ord < machines[m].getOperationsToperform().size(); ord++) {
                                    Operation op = operations.get(machines[m].getOperationsToperform().get(ord));
                                    int ref = op.getTimeMachine();
                                    for (int k = ord + 1; k < machines[m].getOperationsToperform().size(); k++) {
                                        Operation fol = operations.get(machines[m].getOperationsToperform().get(k));
                                        if (fol.getTimeMachine() < ref) {
                                            machines[m].getOperationsToperform().set(ord, fol.getId());
                                            machines[m].getOperationsToperform().set(k, op.getId());
                                            ref = fol.getTimeMachine();
                                        }

                                    }
                                }
                                for (int ord = 0; ord < machines[m].getOperationsToperform().size(); ord++) {
                                    Operation op = operations.get(machines[m].getOperationsToperform().get(ord));
                                    if (!machines[m].getAssignedOperations().getLast().equals("start")) {
                                        Operation suc = operations.get(machines[m].getAssignedOperations().getLast());
                                        suc.setNextOperationByMachine(op.getId());
                                        op.setPreviewOperationByMachine(suc.getId());
                                        operations.put(suc.getId(), suc);
                                    } else {
                                        op.setPreviewOperationByMachine("start");
                                    }
                                    machines[m].addNewOperation(op.getId());
                                    operations.put(op.getId(), op);
                                }

                            }

                        }

                        for (int m = 0; m < machines.length; m++) {
                            Operation op = operations.get(machines[m].getAssignedOperations().getLast());
                            op.setNextOperationByMachine("endMachine");
                            operations.put(op.getId(), op);
                            machines[m].getOperationsToperform().clear();
                        }

                    }

                    System.out.println("-------------------------");
                    deleteStructureandUpdateDate(type);
                    order = new LinkedList<>(updateJobsandExclusive(criterion1));
                    updateJobTails(order, type);
                    makespan = getCriterionValue();
                    tmax = getCriterionTmax();
                    tft = getCriterionTFT();
                    twt = getCriterionTWT();
                    twu = getCriterionTWU();
                    System.out.println("Solution 2----Makespan-" + makespan + "-Tmax-" + tmax + "-tft-" + tft + "-twu-" + twu + "-TWT-" + twt);

                        
                    

                        deleteAndIntStartinMachines();
                    
                        // Ivan Solucion
                        // asignacion: Se asigna en primer lugar las operaciones con una sola posible maquina, de manera que se calcule la carga para cada maquina ya asignada.
                        for (int i = 0; i < getMaxOperationPerJob(); i++)
                        {
                            for (int j = 1; j <= totalJobs; j++) 
                            {
                                Job auxJob = jobs.get(j);
                                if (auxJob.getNumberOfOperations() >= i + 1) 
                                {
                                    Operation auxOpe = operations.get(auxJob.getJobOperations().get(i));                                                          
                                    if(auxOpe.getTimesInMachine().size() == 1)
                                    {
                                        for(Integer key1: auxOpe.getTimesInMachine().keySet())
                                        {
                                            machines[key1 - 1].addOperationToPerform(auxOpe.getId());
                                            machines[key1 - 1].setTimeChargue(auxOpe.findTimeInMachine(key1));
                                            auxOpe.setMachineAssigned(key1);
                                            auxOpe.setTimeMachine(auxOpe.getTimesInMachine().get(auxOpe.getMachineAssigned()));
                                            System.out.println("operaciones en una maquina: " + auxOpe.getId());
                                        }
                                    }                                  
                                }
                            }
                        }
                        // se recorre en orden los trabajos para cada operacion ( de arriba-abajo, izquierda a derecha) asignando la maquina con menor tiempo de carga asiganda.
                        for (int i = 0; i < getMaxOperationPerJob(); i++)
                        {
                            for (int j = 1; j <= totalJobs; j++) 
                            {
                                Job auxJob = jobs.get(j);
                                if (auxJob.getNumberOfOperations() >= i + 1) 
                                {
                                    Operation auxOpe = operations.get(auxJob.getJobOperations().get(i));                                                          
                                    if (auxOpe.getTimesInMachine().size()>1)
                                    {
                                        int min = 100000;
                                        int id = 0;
                                        for(Integer key: auxOpe.getTimesInMachine().keySet())
                                        {
                                            Machine maquina = machines[key - 1];
                                            if(min > (maquina.getTimeCharge()))
                                            {
                                                min = maquina.getTimeCharge();
                                                id = key;
                                            }
                                        }
                                     machines[id - 1].addOperationToPerform(auxOpe.getId());
                                     machines[id - 1].setTimeChargue(auxOpe.findTimeInMachine(id));
                                     auxOpe.setMachineAssigned(id);
                                     auxOpe.setTimeMachine(auxOpe.getTimesInMachine().get(auxOpe.getMachineAssigned()));                                 
                                    }
                                    operations.put(auxOpe.getId(), auxOpe);
                                    System.out.println("Operación: " + auxOpe.getId() + " fue asignada en la máquina: " + auxOpe.getMachineAssigned());                                  
                                }
                            }
                        }
                        
                        // Metodo para hallar el tiempo de procesamiento total del trabajo segun las masquinas 
                        for(int i = 1; i <= totalJobs;i++)
                        {
                            Job auxJop = jobs.get(i);
                            for(int j = 0; j < auxJop.getNumberOfOperations(); j++)
                            {
                                Operation auxOpe = operations.get(auxJop.getJobOperations().get(j));
                                auxJop.setPT(auxOpe.findTimeInMachine(auxOpe.getMachineAssigned()));
                            }   
                            System.out.println("El tp de el pedido: "+ i+ " es  " + auxJop.getPt());
                        }
                        
                        
                        
                                             
                        //Se limpian las operaciones a procesar de las máquinas para asignar por columnas.
                        for(int i = 0; i < machines.length; i++)
                        {
                            machines[i].getOperationsToperform().clear();
                        }
                        
                        //Se asigna por columnas según la máquina asignada a cada operación anteriormente.
                        for(int i = 0; i < getMaxOperationPerJob(); i++)
                        {
                            for(int j = 1; j <= totalJobs; j++)
                            {
                                Job auxJob = jobs.get(j);
                                if(auxJob.getNumberOfOperations() >= (i + 1))
                                {
                                Operation operacionAux = operations.get(auxJob.getJobOperations().get(i));
                                int keyMaquina = operacionAux.getMachineAssigned();
                                machines[keyMaquina - 1].addOperationToPerform(operacionAux.getId());
                                }                                
                            }           

                                           
                        //Secuenciación (Se secuencia de acuerdo a los tiempos de procesamiento en máquina)
                        // Se inicia con la operación de mayor tiempo y se finaliza con la de menor
                        
                        for(int x = 0; x < machines.length; x++)
                        {           
                            if(machines[x].getOperationsToperform().size() == 1)
                            {
                                Operation auxOpe = operations.get(machines[x].getOperationsToperform().get(0));
                                auxOpe.setPreviewOperationByMachine(machines[x].getAssignedOperations().getLast());
                                if(!machines[x].getAssignedOperations().getLast().equals("start"))
                                {
                                    Operation anterior = operations.get(machines[x].getAssignedOperations().getLast());
                                    anterior.setNextOperationByJob(auxOpe.getId());
                                    operations.put(anterior.getId(),anterior);
                                }
                                machines[x].addNewOperation(auxOpe.getId());
                                operations.put(auxOpe.getId(), auxOpe);
                            }
                            
                            if(machines[x].getOperationsToperform().size() > 1)
                            {
                                //Se ordenan las operaciones a procesar según el menor tiempo de procesamiento.
                                for(int j = 0; j < machines[x].getOperationsToperform().size(); j++)
                                {
                                    Operation operacionActual = operations.get(machines[x].getOperationsToperform().get(j));
                                                                        
                                    int idJobBuscadoActual  =0;
                                    for( int y = 1; y <= totalJobs;y++)
                                    {
                                        Job auxJob =  jobs.get(y);
                                        for (int h =0; h < auxJob.getNumberOfOperations();h++)
                                        {
                                            Operation buscar = operations.get(auxJob.getJobOperations().get(h));
                                            if(buscar.getId() == operacionActual.getId())
                                            {
                                                idJobBuscadoActual = y;
                                            }
                                        }
                                    }
                                    int tiempo = jobs.get(idJobBuscadoActual).getPt();
                                    
                                    for(int k = j + 1; k < machines[x].getOperationsToperform().size(); k++)
                                    {
                                        Operation operacionSiguiente = operations.get(machines[x].getOperationsToperform().get(k));
                                        int idJobBuscadoSiguiente  =0;
                                        for( int y = 1; y <= totalJobs;y++)
                                        {
                                            Job auxJob =  jobs.get(y);
                                            for (int h =0; h < auxJob.getNumberOfOperations();h++)
                                            {
                                                Operation buscar = operations.get(auxJob.getJobOperations().get(h));
                                                if(buscar.getId() == operacionSiguiente.getId())
                                                {
                                                    idJobBuscadoSiguiente = y;
                                                }
                                            }
                                        }
                                        
                                        
                                        if(tiempo < jobs.get(idJobBuscadoSiguiente).getPt())
                                        {
                                         machines[x].getOperationsToperform().set(j, operacionSiguiente.getId());
                                         machines[x].getOperationsToperform().set(k, operacionActual.getId());
                                         tiempo = jobs.get(idJobBuscadoSiguiente).getPt();
                                        }
                                    }                                    
                                }
                                //Se secuencian las operaciones según el orden encontrado
                                for(int j = 0; j < machines[x].getOperationsToperform().size(); j++)
                                {
                                    Operation auxOpe = operations.get(machines[x].getOperationsToperform().get(j));
                                    if(!machines[x].getAssignedOperations().getLast().equals("start"))
                                    {
                                        Operation anterior = operations.get(machines[x].getAssignedOperations().getLast());
                                        anterior.setNextOperationByMachine(auxOpe.getId());
                                        auxOpe.setPreviewOperationByMachine(anterior.getId());
                                        operations.put(anterior.getId(), anterior);
                                    }
                                    else
                                    {
                                        auxOpe.setPreviewOperationByMachine("start");
                                    }
                                    machines[x].addNewOperation(auxOpe.getId());
                                    operations.put(auxOpe.getId(), auxOpe);
                                }                
                            }
                            
                            
                        }
                        /*for(int x = 0; x < machines.length; x++)
                        {
                            Operation operacion = operations.get(machines[x].getAssignedOperations().getLast());
                            System.out.println("La última operación es: " + operacion.getId());
                            System.out.println("Maquina: "+ machines[x].getAssignedOperations().size());
                        }*/
                        
                        for(int x = 0; x < machines.length; x++)
                        {
                            if(machines[x].getAssignedOperations().size()> 1)
                            {
                            Operation operacion = operations.get(machines[x].getAssignedOperations().getLast());
                            operacion.setNextOperationByMachine("endMachine");
                            operations.put(operacion.getId(), operacion);
                            machines[x].getOperationsToperform().clear();
                            }
                        }
                      
                        }
                        
                        
                        
                    System.out.println("-------------------------");
                    deleteStructureandUpdateDate(type);
                    order = new LinkedList<>(updateJobsandExclusive(criterion1));
                    updateJobTails(order, type);
                    makespan = getCriterionValue();
                    tmax = getCriterionTmax();
                    tft = getCriterionTFT();
                    twt = getCriterionTWT();
                    twu = getCriterionTWU();
                    System.out.println("Solution Ivancho----Makespan-" + makespan + "-Tmax-" + tmax + "-tft-" + tft + "-twu-" + twu + "-TWT-" + twt);

                                      
                     // fin de la solucion inicial   
                    
                        
                        
                        
                        
                    
                    //deleteStructureandUpdateDate(type);
                    //order = new LinkedList<>(updateJobsandExclusive(criterion1));
                    //updateJobTails(order, type);
                    //readerOperations();
                    //Number of iterations
                    int iterations = 1;
                    //The search start in step 1
                    int step = 1;
                    int criterionValue = getCriterionValue();
                    int bestLocal = -Operation.MINIMUN_TAIL;
                    int bestGlobal = -Operation.MINIMUN_TAIL;

                    //Start time
                    long a = System.currentTimeMillis();
                    //-------Starts the local search process-------------//
                    for (int it = 1; it <= iterations; it++) {
                        if (step == 1) {
                            //Update the assignment-update the solution (start time and completion times)-delete the neighborhood
                            deleteStructureandUpdateDate(type);
                            readerOperations();
                            //Determine jobs that affect the criterion
                            order = new LinkedList<>(updateJobsandExclusive(criterion1));
                            for(int x=0;x < order.size();x++)
                            {
                                System.out.println("El orden de op criticas es"+ order.get(x));
                            }
                            if (!order.isEmpty()) {
                                //Calaculate tails of operations and operations to move
                                operationTails(order, type);
                                //Calcualte the criterion
                                criterionValue = getCriterionValue();
                                //Calculate the job tails for operations and the neighborhood according to type
                                if (criterionValue < bestGlobal) {
                                    bestGlobal = criterionValue;
                                }

                                //Update the local value
                                /*
                                 if (it==2){
                                 //Determine all feasible best insertions 
                                 for (int l=0; l<operationsTomove1.size();l++){
                                 String op = operationsTomove1.get(l);
                                 System.out.println("-The operation--" + op );
                                 }
                                 }
                                 */
                                feasibleInsertionsYazid(type, criterionValue, criterion1, order);

                                if (!insertions.isEmpty()) {
                                    createNewSolutionBuilTabu(0);
                                } else {
                                    //Diversification step
                                    step = 3;

                                }
                            } else {
                                break;
                            }
                        }
                        if (step == 3) {
                            int up = 10;
                            int from = 6;
                            int d = (int) (Math.random() * (up - from + 1) + from);
                            deleteStructureandUpdateDate(type);
                            order = new LinkedList<>(updateJobsandExclusive(criterion1));
                            operationTails(order, type);
                            feasibleDiversif(type);
                            if (type.equals("type2") && operationsToMove2.isEmpty()) {
                                type = "type1";
                                deleteStructureandUpdateDate(type);
                                order = new LinkedList<>(updateJobsandExclusive(criterion1));
                                operationTails(order, type);
                            }
                            for (int ran = 1; ran <= d; ran++) {

                                feasibleDiversif(type);
                                int sel = (int) (Math.random() * (insertions.size() - 1 + 1) + 1);

                                createNewSolutionBuilTabu(sel - 1);
                                //Update the assignment-update the solution (start time and completion times)-delete the neighborhood
                                deleteStructureandUpdateDate(type);
                                //Find the jobs which affect the criterion, completion time jobs and update exclusive operation (0 and *)-calculate criterion
                                order = new LinkedList<>(updateJobsandExclusive(criterion1));
                                //contains the value of the criterion in the last function it was set
                                criterionValue = getCriterionValue();
                                //Calculate the job tails for operations and the neighborhood according to type
                                operationTails(order, type);
                                if (type.equals("type2") && operationsToMove2.isEmpty()) {
                                    type = "type1";
                                    deleteStructureandUpdateDate(type);
                                    order = new LinkedList<>(updateJobsandExclusive(criterion1));
                                    operationTails(order, type);
                                }

                                //Update best Global Value 
                                if (criterionValue < bestGlobal) {
                                    bestGlobal = criterionValue;
                                    step = 1;
                                    if (neigh == 2) {
                                        type = "type2";
                                    }
                                    break;
                                }

                                if (ran == d) {
                                    bestLocal = -Operation.MINIMUN_TAIL;
                                    step = 1;
                                    if (neigh == 2) {
                                        type = "type2";
                                    }

                                }
                            }

                        }

                        long b = System.currentTimeMillis();
                        //If the current time is more than 300 seconds break. 
                        if (b - a > 300000) {
                            break;
                        }

                    }
                    //readerOperations();

                }// end of the Neighborhood     
            }// end of the file
        }//If the folder is empty
    } //End of the main method

        
    
    
    public static void createFile(String fileName, String instance, double htaImpRS, double tailPhiImpRS, double lostImpRS,
            double htaNonImpRS, double tailPhiNonImpRS, double lostNonImpRS,
            double htaImpRAG, double tailPhiImpRAG, double lostImpRAG,
            double htaNonImpRAG, double tailPhiNonImpRAG, double lostNonImpRAG
    ) {
        File f = new File(fileName);

        try {
            FileWriter w = new FileWriter(f);
            BufferedWriter bw = new BufferedWriter(w);
            PrintWriter wr = new PrintWriter(bw);
            wr.write("-----Fesibility conditions------ \n");
            wr.append("\n");
            wr.append("--Instance-" + " --- " + instance);
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("--Improving moves Resequencing-");
            wr.write("------------------ \n");
            wr.append(" \n");
            wr.append(" Pecentage of Improving moves RSQ ");
            wr.append(" \n");
            wr.append(" HTA Conditions  " + htaImpRS);
            wr.append(" \n");
            wr.append(" Tail-Phi Conditions " + tailPhiImpRS);
            wr.append(" \n");
            wr.append(" Lost moves  " + lostImpRS);
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("--Non improving moves Resequencing-");
            wr.write("------------------ \n");
            wr.append(" \n");
            wr.append(" HTA Conditions  " + htaNonImpRS);
            wr.append(" \n");
            wr.append(" Tail-Phi Conditions " + tailPhiNonImpRS);
            wr.append(" \n");
            wr.append(" Lost moves  " + lostNonImpRS);
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("--Improving moves Reassignment-");
            wr.write("------------------ \n");
            wr.append(" \n");
            wr.append(" HTA Conditions  " + htaImpRAG);
            wr.append(" \n");
            wr.append(" Tail-Phi Conditions " + tailPhiImpRAG);
            wr.append(" \n");
            wr.append(" Lost moves  " + lostImpRAG);
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("--Non improving moves Reassignment-");
            wr.write("------------------ \n");
            wr.append(" HTA Conditions  " + htaNonImpRAG);
            wr.append(" \n");
            wr.append(" \n");
            wr.append(" Tail-Phi Conditions " + tailPhiNonImpRAG);
            wr.append(" \n");
            wr.append(" Lost moves  " + lostNonImpRAG);
            wr.append(" \n");
            wr.close();
            bw.close();
        } catch (IOException e) {
        };

    }

    public static HashMap<String, Operation> getOperations() {
        return operations;
    }

    public static void setOperations(HashMap<String, Operation> operations) {
        FJSProyect.operations = operations;
    }

    static void setUnavailableOperation() {
        Set<String> s = operations.keySet();
        Iterator<String> ik = s.iterator();
        while (ik.hasNext()) {
            Operation op = operations.get(ik.next());
            op.setStatus(0);
            operations.put(op.getId(), op);

        }
    }

    public static HashMap<Integer, Job> getJobs() {
        return jobs;
    }

    public static void setJobs(HashMap<Integer, Job> jobs) {
        FJSProyect.jobs = jobs;
    }

    public static HashMap<String, Operation> getExclusiveOperations() {
        return exclusiveOperations;
    }

    public static void setExclusiveOperations(HashMap<String, Operation> exclusiveOperations) {
        FJSProyect.exclusiveOperations = exclusiveOperations;
    }

    public static Machine[] getMachines() {
        return machines;
    }

    public static void setMachines(Machine[] machines) {
        FJSProyect.machines = machines;
    }

    public static int getCriterionValue() {
        return criterionValue;
    }

    public static void setCriterionValue(int criterionValue) {
        FJSProyect.criterionValue = criterionValue;
    }

    public static int getCriterionMk() {
        return criterionMk;
    }

    public static void setCriterionMk(int criterionMk) {
        FJSProyect.criterionMk = criterionMk;
    }

    public static int getCriterionTmax() {
        return criterionTmax;
    }

    public static void setCriterionTmax(int criterionTmax) {
        FJSProyect.criterionTmax = criterionTmax;
    }

    public static int getCriterionTFT() {
        return criterionTFT;
    }

    public static void setCriterionTFT(int criterionTFT) {
        FJSProyect.criterionTFT = criterionTFT;
    }

    public static int getCriterionTWFT() {
        return criterionTWFT;
    }

    public static void setCriterionTWFT(int criterionTWFT) {
        FJSProyect.criterionTWFT = criterionTWFT;
    }

    public static int getCriterionTWT() {
        return criterionTWT;
    }

    public static void setCriterionTWT(int criterionTWT) {
        FJSProyect.criterionTWT = criterionTWT;
    }

    public static int getCriterionTWU() {
        return criterionTWU;
    }

    public static void setCriterionTWU(int criterionTWU) {
        FJSProyect.criterionTWU = criterionTWU;
    }

    public static LinkedList<String> getOperationsTomove1() {
        return operationsTomove1;
    }

    public static void setOperationsTomove1(LinkedList<String> operationsTomove1) {
        FJSProyect.operationsTomove1 = operationsTomove1;
    }

    public static LinkedList<String> getOperationsTomove2() {
        return operationsTomove2;
    }

    public static void setOperationsTomove2(LinkedList<String> operationsTomove2) {
        FJSProyect.operationsTomove2 = operationsTomove2;
    }

    public static LinkedList<Insertion> getInsertions() {
        return insertions;
    }

    public static void setInsertions(LinkedList<Insertion> insertions) {
        FJSProyect.insertions = insertions;
    }

    public static LinkedList<Insertion> getInsertionsReal() {
        return insertionsReal;
    }

    public static void setInsertionsReal(LinkedList<Insertion> insertionsReal) {
        FJSProyect.insertionsReal = insertionsReal;
    }

    static void updateOperations() {

        setUnavailableOperation();
        LinkedList<String> pending = new LinkedList<String>();
        LinkedList<String> pendingAux = new LinkedList<String>();

        TreeMap<String, Operation> updating = new TreeMap<String, Operation>(operations);

        for (Map.Entry<String, Operation> node : updating.entrySet()) {
            Operation op = node.getValue();
            pending = updateOperation(op, pending);
        }

        do {
            pendingAux.clear();

            for (int i = 0; i < pending.size(); i++) {
                pendingAux = updateOperation(operations.get(pending.get(i)), pendingAux);
            }
            pending = new LinkedList<String>(pendingAux);

        } while (pending.size() != 0);

    }

    static void deleteAndIntStartinMachines() {
        // Clear all assigned operations to the machines and the record for the file
        // As soon all operations are deleted start is added.
        for (int m = 0; m < machines.length; m++) {
            machines[m].getAssignedOperations().clear();
            machines[m].getAssignRecord().clear();
            machines[m].addNewOperation("start");
        }

    }

    static void addendMachine() {
        //Add * to the list to the operations to the machines
        for (int m = 0; m < machines.length; m++) {
            String last = machines[m].getAssignedOperations().getLast();

            if (last.equals("start")) {
                machines[m].addNewOperation("endMachine");
            } else {
                Operation op = operations.get(last);
                op.setNextOperationByMachine("endMachine");
                operations.put(last, op);
                machines[m].addNewOperation("endMachine");
            }

        }
    }

    static LinkedList<String> updateOperation(Operation op, LinkedList<String> pending) {

        if (op.getStatus() == 0) {

            if (op.getPreviewOperationByJob().equals("start") && op.getPreviewOperationByMachine().equals("start")) {

                op.setStartTime(0);
                op.setCompletionTime(op.getTimeMachine());
                op.setStatus(1);
                op.setNumberOfArcs(1);
                if (bellmanOrder.size() == 0) {
                    LinkedList<String> order = new LinkedList<String>();
                    order.add(op.getId());
                    bellmanOrder.add(order);
                } else {
                    bellmanOrder.getFirst().add(op.getId());
                }
                op.setOrderinMachine(machines[op.getMachineAssigned() - 1].getAssignedOperations().size());
                machines[op.getMachineAssigned() - 1].addNewOperation(op.getId());
                machines[op.getMachineAssigned() - 1].addRecord(op.getId() + "(" + op.getStartTime() + "," + op.getCompletionTime() + ")");

            } else if (op.getPreviewOperationByJob().equals("start") && !op.getPreviewOperationByMachine().equals("start")) {

                Operation pM = operations.get(op.getPreviewOperationByMachine());
                if (pM.getStatus() == 1) {
                    op.setStartTime(pM.getCompletionTime());
                    op.setCompletionTime(pM.getCompletionTime() + op.getTimeMachine());
                    op.setStatus(1);
                    op.setNumberOfArcs(pM.getNumberOfArcs() + 1);
                    if (bellmanOrder.size() == pM.getNumberOfArcs()) {
                        LinkedList<String> order = new LinkedList<String>();
                        order.add(op.getId());
                        bellmanOrder.add(order);
                    } else {
                        bellmanOrder.get(pM.getNumberOfArcs()).add(op.getId());
                    }
                    op.setOrderinMachine(machines[op.getMachineAssigned() - 1].getAssignedOperations().size());
                    machines[op.getMachineAssigned() - 1].addNewOperation(op.getId());
                    machines[op.getMachineAssigned() - 1].addRecord(op.getId() + "(" + op.getStartTime() + "," + op.getCompletionTime() + ")");
                } else {
                    pending.add(op.getId());
                }
            } else if (!op.getPreviewOperationByJob().equals("start") && op.getPreviewOperationByMachine().equals("start")) {

                Operation pJ = operations.get(op.getPreviewOperationByJob());
                if (pJ.getStatus() == 1) {
                    op.setStartTime(pJ.getCompletionTime());
                    op.setCompletionTime(pJ.getCompletionTime() + op.getTimeMachine());
                    op.setStatus(1);
                    op.setNumberOfArcs(pJ.getNumberOfArcs() + 1);

                    if (bellmanOrder.size() == pJ.getNumberOfArcs()) {
                        LinkedList<String> order = new LinkedList<String>();
                        order.add(op.getId());
                        bellmanOrder.add(order);
                    } else {
                        bellmanOrder.get(pJ.getNumberOfArcs()).add(op.getId());
                    }

                    op.setOrderinMachine(machines[op.getMachineAssigned() - 1].getAssignedOperations().size());
                    machines[op.getMachineAssigned() - 1].addNewOperation(op.getId());
                    machines[op.getMachineAssigned() - 1].addRecord(op.getId() + "(" + op.getStartTime() + "," + op.getCompletionTime() + ")");
                } else {
                    pending.add(op.getId());
                }

            } else {
                Operation oJ = operations.get(op.getPreviewOperationByJob());
                Operation oM = operations.get(op.getPreviewOperationByMachine());

                if (oJ.getStatus() == 1 && oM.getStatus() == 1) {

                    op.setStartTime(Math.max(oJ.getCompletionTime(), oM.getCompletionTime()));
                    op.setCompletionTime(op.getStartTime() + op.getTimeMachine());
                    op.setStatus(1);
                    op.setNumberOfArcs(Math.max(oJ.getNumberOfArcs(), oM.getNumberOfArcs()) + 1);
                    if (bellmanOrder.size() == Math.max(oJ.getNumberOfArcs(), oM.getNumberOfArcs())) {
                        LinkedList<String> order = new LinkedList<String>();
                        order.add(op.getId());
                        bellmanOrder.add(order);
                    } else {
                        bellmanOrder.get(Math.max(oJ.getNumberOfArcs(), oM.getNumberOfArcs())).add(op.getId());
                    }

                    op.setOrderinMachine(machines[op.getMachineAssigned() - 1].getAssignedOperations().size());
                    machines[op.getMachineAssigned() - 1].addNewOperation(op.getId());
                    machines[op.getMachineAssigned() - 1].addRecord(op.getId() + "(" + op.getStartTime() + "," + op.getCompletionTime() + ")");
                } else {
                    pending.add(op.getId());
                }
            }

            operations.put(op.getId(), op);
        }

        return pending;

    }

    static void readerOperations() {
        Set<String> s = operations.keySet();
        Iterator<String> ik = s.iterator();
        while (ik.hasNext()) {
            Operation op = operations.get(ik.next());
            System.out.println(" Operation " + op.getId());
            System.out.println(" Tail max---" + op.getTailMax() + "---Arcs---" + op.getNumberOfArcs());
            System.out.println(" Machine " + op.getMachineAssigned() + " Order " + op.getOrderinMachine());
            System.out.println(" Start Time " + op.getStartTime() + " Completion Time " + op.getCompletionTime());
            System.out.println(" Next operation by machine  " + op.getNextOperationByMachine() + " Preview by machine " + op.getPreviewOperationByMachine());
            //System.out.println("Next by Job--" + op.getNextOperationByJob() + "-----Preview by Job----" + op.getPreviewOperationByJob());
            System.out.println("-----Tails and critical----------");
            for (int i = 1; i <= totalJobs; i++) {
                System.out.println("To Job---" + i + "---The tail is--- " + op.getJobsTails().get(i) + " -----Is crtical ?---" + op.getCriticalToJob().get(i));
            }
            for (int i = 0; i < op.getSuccesors().size(); i++) {
                System.out.println("Succesor--" + (i + 1) + "--" + op.getSuccesors().get(i));
            }
            System.out.println("-------Fin--------");
        }

    }

    static void readerExclusiveOperations() {
        Set<String> s = exclusiveOperations.keySet();
        Iterator<String> ik = s.iterator();
        while (ik.hasNext()) {
            Operation op = exclusiveOperations.get(ik.next());
            System.out.println(" Operation " + op.getId());
            System.out.println(" Tail max " + op.getTailMax());
            System.out.println(" Start Time " + op.getStartTime() + " Arcs " + op.getNumberOfArcs());
            System.out.println("-----Tails----------");
            for (int i = 1; i <= totalJobs; i++) {
                System.out.println(op.findJobsTail(i));
            }
            System.out.println("-------Fin--------");
        }

    }

    static void updateJobTails(LinkedList<Integer> order, String type) {

        setUnavailableOperation();
        LinkedList<String> pending = new LinkedList<String>();
        LinkedList<String> pendingAux = new LinkedList<String>();
        LinkedList<Integer> orderJobs = new LinkedList<>(order);
        String structure;
        structure = type;

        for (Map.Entry<String, Operation> node : operations.entrySet()) {
            Operation op = node.getValue();
            pending = updateTailToOperation(op, pending, orderJobs, structure);
        }

        do {
            pendingAux.clear();

            for (int i = 0; i < pending.size(); i++) {
                pendingAux = updateTailToOperation(operations.get(pending.get(i)), pendingAux, orderJobs, structure);
            }
            pending = new LinkedList<String>(pendingAux);

        } while (pending.size() != 0);
    }

    static LinkedList<String> updateTailToOperation(Operation op, LinkedList<String> pending, LinkedList<Integer> orderJobs, String structure) {

        //Op es la operacion actual, en donde se esta situado
        if (op.getStatus() == 0) {

            /*Se pregunta si es el ultimo nodo del trabajo y de la maquina
             * Las carga todas con -Infinito y al trabajo al que pertenezca la operacion asigna un 0
             */
            if (op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && op.getNextOperationByMachine().equals("endMachine")) {

                if (structure.equals("type1")) {
                    if (orderJobs.contains(op.getJob())) {
                        operationsTomove1.addFirst(op.getId());
                    }
                }

                if (structure.equals("type2")) {
                    Operation pbM;
                    if (op.getOrderinMachine() == 1) {
                        pbM = exclusiveOperations.get("start");
                    } else {
                        pbM = operations.get(op.getPreviewOperationByMachine());
                    }

                    if (!pbM.getId().equals("start") && orderJobs.contains(op.getJob()) && pbM.getCompletionTime() == op.getStartTime() && op.getJob() != pbM.getJob()) {
                        operationsTomove2.addFirst(op.getId());
                    }
                }

                if (structure.equals("type3")) {
                    Operation pbM;

                    if (op.getOrderinMachine() == 1) {
                        pbM = exclusiveOperations.get("start");
                    } else {
                        pbM = operations.get(op.getPreviewOperationByMachine());
                    }
                    if (!pbM.getId().equals("start") && orderJobs.contains(op.getJob()) && pbM.getCompletionTime() == op.getStartTime() && op.getJob() != pbM.getJob()) {
                        operationsTomove2.addFirst(op.getId());
                    }

                }
                op.clearSuccesors();
                op.addsuccesor("endByJob_" + op.getJob());

                for (int job = 1; job <= jobs.size(); job++) {
                    op.addTail(job, Operation.MINIMUN_TAIL);
                    op.notCriticalToJob(job);
                    if (job == op.getJob()) {
                        op.addTail(op.getJob(), 0);
                        op.criticalToJob(op.getJob());
                    }
                }
                op.setStatus(1);
                op.setTailMax(0);
            } //Ultimo en operacion por trabajo, No ultimo en operacion por maquina
            else if (op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && !op.getNextOperationByMachine().equals("endMachine")) {
                //La nomenclatura cambio temporalmente, pM Es proximoMaquina

                Operation pM = operations.get(op.getNextOperationByMachine());

                if (pM.getStatus() == 1) {

                    op.clearSuccesors();
                    op.addsuccesor("endByJob_" + op.getJob());
                    op.addsuccesor(pM.getId());
                    op.addsuccesors(pM.getSuccesors());

                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        tail = pM.findJobsTail(job);
                        if (tail != Operation.MINIMUN_TAIL) {

                            op.addTail(job, tail + pM.getTimeMachine());

                            if (tail + pM.getTimeMachine() > tailMax) {
                                tailMax = tail + pM.getTimeMachine();
                            }
                            if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                                op.criticalToJob(job);
                            }

                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }

                        if (job == op.getJob() && tail == Operation.MINIMUN_TAIL && op.getNextOperationByJob().equals("endByJob_" + op.getJob())) {
                            op.addTail(job, 0);
                            op.criticalToJob(job);
                        }

                    }

                    op.setTailMax(tailMax);
                    op.setStatus(1);

                    if (structure.equals("type1")) {
                        if ((operationsTomove1.contains(pM.getId()) && op.getCompletionTime() == pM.getStartTime())
                                || orderJobs.contains(op.getJob())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }

                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }
                        if ((operationsTomove2.contains(pM.getId()) && op.getCompletionTime() == pM.getStartTime())
                                || (orderJobs.contains(op.getJob()) && !pbM.getId().equals("start") && pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob())) {
                            operationsTomove2.addFirst(op.getId());
                        }

                    }

                } else {
                    pending.add(op.getId());
                }

            } // Ultimo en operacion por maquina  y No ultimo en operacion por trabajo
            else if (!op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && op.getNextOperationByMachine().equals("endMachine")) {

                Operation pJ = operations.get(op.getNextOperationByJob());
                if (pJ.getStatus() == 1) {
                    //Delete the last successors
                    op.clearSuccesors();
                    //Add PJ
                    op.addsuccesor(pJ.getId());
                    //Add Succesor of PJ
                    op.addsuccesors(pJ.getSuccesors());

                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        tail = pJ.findJobsTail(job);
                        if (tail != Operation.MINIMUN_TAIL) {
                            op.addTail(job, tail + pJ.getTimeMachine());
                            if (tail + pJ.getTimeMachine() > tailMax) {
                                tailMax = tail + pJ.getTimeMachine();
                            }
                            if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                                op.criticalToJob(job);
                            }

                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }
                    }
                    op.setTailMax(tailMax);
                    op.setStatus(1);

                    if (structure.equals("type1") && operationsTomove1.contains(pJ.getId()) && op.getCompletionTime() == pJ.getStartTime()) {
                        operationsTomove1.addFirst(op.getId());
                    }

                    if (structure.equals("type2") || structure.equals("type3")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        for (int job = 1; job <= jobs.size(); job++) {
                            if (orderJobs.contains(job) && op.getCriticalToJob().get(job) == Boolean.TRUE) {
                                if (structure.equals("type2")) {
                                    if (pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob() && !pbM.getId().equals("start")) {
                                        operationsTomove2.addFirst(op.getId());
                                        break;
                                    }
                                }
                            }
                        }

                    }

                } else {
                    pending.add(op.getId());
                }

            } else {
                //Oj Es la operacion siguiente por trabajo
                Operation oJ = operations.get(op.getNextOperationByJob());
                //Om Es la operacion siguiente por maquina
                Operation oM = operations.get(op.getNextOperationByMachine());
                if (oJ.getStatus() == 1 && oM.getStatus() == 1) {
                    //Clear last succesors
                    op.clearSuccesors();
                    //Add if oJ=oM else oJ!=oM
                    if (oJ.getId().equals(oM.getId())) {
                        op.addsuccesor(oJ.getId());
                        op.addsuccesors(oJ.getSuccesors());
                    } else {
                        op.addsuccesor(oJ.getId());
                        op.addsuccesor(oM.getId());
                        op.addsuccesors(oJ.getSuccesors());
                        op.addsuccesors(oM.getSuccesors());
                        op.addsuccesorsTotal();
                    }

                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        int tailJ = oJ.findJobsTail(job) + oJ.getTimeMachine();
                        int tailM = oM.findJobsTail(job) + oM.getTimeMachine();

                        if (tailJ >= tailM) {
                            tail = tailJ;

                        } else {
                            tail = tailM;
                        }

                        if (tail > tailMax) {
                            tailMax = tail;
                        }

                        if (tail >= 0) {
                            op.addTail(job, tail);
                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }

                        if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                            op.criticalToJob(job);
                        }
                    }
                    op.setTailMax(tailMax);
                    op.setStatus(1);

                    if (structure.equals("type1")) {
                        if ((operationsTomove1.contains(oJ.getId()) && op.getCompletionTime() == oJ.getStartTime())
                                || (operationsTomove1.contains(oM.getId()) && op.getCompletionTime() == oM.getStartTime())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }

                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        for (int job = 1; job <= jobs.size(); job++) {
                            if (orderJobs.contains(job) && op.getCriticalToJob().get(job) == Boolean.TRUE) {
                                if (structure.equals("type2")) {
                                    if ((pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob() && !pbM.getId().equals("start"))
                                            || (operationsTomove2.contains(oM.getId()) && op.getCompletionTime() == oM.getStartTime() && oM.getJob() != op.getJob())) {
                                        operationsTomove2.addFirst(op.getId());
                                        break;
                                    }
                                }

                            }
                        }
                    }

                } else {
                    pending.add(op.getId());
                }
            }
            operations.put(op.getId(), op);
        }
        return pending;
    }

    //------------------------------------
    //---- This is more efficient mehod since update the tails using Bellman principle-----// 
    static void operationTails(LinkedList<Integer> orderJobs, String structure) {

        //To update the tails of operations, Bellman order is invoked from the highest order
        for (int b = bellmanOrder.size() - 1; b >= 0; b--) {
            for (int c = 0; c < bellmanOrder.get(b).size(); c++) {
                Operation op = operations.get(bellmanOrder.get(b).get(c));

                //op is the last operation by machine and by job.
                if (op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && op.getNextOperationByMachine().equals("endMachine")) {

                    // For N1 is critical operation, since is the last operation of job
                    if (structure.equals("type1")) {
                        if (orderJobs.contains(op.getJob())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }

                    //Analyze if N2 is considered
                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        if (!pbM.getId().equals("start") && orderJobs.contains(op.getJob()) && pbM.getCompletionTime() == op.getStartTime() && op.getJob() != pbM.getJob()) {
                            operationsTomove2.addFirst(op.getId());
                        }
                    }
                    //Succesor by Op is deleted, then phi is added. 
                    op.clearSuccesors();
                    op.addsuccesor("endByJob_" + op.getJob());

                    //Determine the tails to nodes phi.
                    for (int job = 1; job <= jobs.size(); job++) {
                        op.addTail(job, Operation.MINIMUN_TAIL);
                        op.notCriticalToJob(job);
                        if (job == op.getJob()) {
                            op.addTail(op.getJob(), 0);
                            op.criticalToJob(op.getJob());
                        }
                    }
                    //Tail to node *
                    op.setTailMax(0);

                } else if (op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && !op.getNextOperationByMachine().equals("endMachine")) {
                    //PM is fs(op)
                    Operation pM = operations.get(op.getNextOperationByMachine());

                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        tail = pM.findJobsTail(job);
                        //The tail is calculated and at the same time the tail to node *
                        if (tail != Operation.MINIMUN_TAIL) {
                            op.addTail(job, tail + pM.getTimeMachine());
                            if (tail + pM.getTimeMachine() > tailMax) {
                                tailMax = tail + pM.getTimeMachine();
                            }
                            if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                                op.criticalToJob(job);
                            }

                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }

                        if (job == op.getJob() && tail == Operation.MINIMUN_TAIL && op.getNextOperationByJob().equals("endByJob_" + op.getJob())) {
                            op.addTail(job, 0);
                            op.criticalToJob(job);
                        }

                    }

                    op.setTailMax(tailMax);
                    //Condition to add in N1
                    if (structure.equals("type1")) {
                        if ((operationsTomove1.contains(pM.getId()) && op.getCompletionTime() == pM.getStartTime())
                                || orderJobs.contains(op.getJob())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }
                    //Condition to add in N2
                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }
                        if ((operationsTomove2.contains(pM.getId()) && op.getCompletionTime() == pM.getStartTime())
                                || (orderJobs.contains(op.getJob()) && !pbM.getId().equals("start") && pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob())) {
                            operationsTomove2.addFirst(op.getId());
                        }

                    }
                    //Add the succesors
                    op.clearSuccesors();
                    op.addsuccesor("endByJob_" + op.getJob());
                    op.addsuccesor(pM.getId());
                    op.addsuccesors(pM.getSuccesors());

                } else if (!op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && op.getNextOperationByMachine().equals("endMachine")) {

                    Operation pJ = operations.get(op.getNextOperationByJob());
                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        tail = pJ.findJobsTail(job);
                        if (tail != Operation.MINIMUN_TAIL) {
                            op.addTail(job, tail + pJ.getTimeMachine());
                            if (tail + pJ.getTimeMachine() > tailMax) {
                                tailMax = tail + pJ.getTimeMachine();
                            }
                            if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                                op.criticalToJob(job);
                            }

                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);
                        }
                    }
                    op.setTailMax(tailMax);

                    if (structure.equals("type1") && operationsTomove1.contains(pJ.getId()) && op.getCompletionTime() == pJ.getStartTime()) {
                        operationsTomove1.addFirst(op.getId());
                    }

                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        for (int job = 1; job <= jobs.size(); job++) {
                            if (orderJobs.contains(job) && op.getCriticalToJob().get(job) == Boolean.TRUE) {
                                if (pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob() && !pbM.getId().equals("start")) {
                                    operationsTomove2.addFirst(op.getId());
                                    break;
                                }
                            }
                        }

                    }
                    //Delete the last successors
                    op.clearSuccesors();
                    //Add PJ
                    op.addsuccesor(pJ.getId());
                    //Add Succesor of PJ
                    op.addsuccesors(pJ.getSuccesors());
                } else {

                    //Oj represents the fr(op) 
                    Operation oJ = operations.get(op.getNextOperationByJob());
                    //Om represents fs(op) 
                    Operation oM = operations.get(op.getNextOperationByMachine());

                    //Clear last succesors
                    op.clearSuccesors();
                    //Add if oJ=oM else oJ!=oM
                    if (oJ.getId().equals(oM.getId())) {
                        op.addsuccesor(oJ.getId());
                        op.addsuccesors(oJ.getSuccesors());
                    } else {
                        op.addsuccesor(oJ.getId());
                        op.addsuccesor(oM.getId());
                        op.addsuccesors(oJ.getSuccesors());
                        op.addsuccesors(oM.getSuccesors());
                        op.addsuccesorsTotal();
                    }

                    int tail = 0;
                    int tailMax = 0;
                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        int tailJ = oJ.findJobsTail(job) + oJ.getTimeMachine();
                        int tailM = oM.findJobsTail(job) + oM.getTimeMachine();

                        if (tailJ >= tailM) {
                            tail = tailJ;

                        } else {
                            tail = tailM;
                        }

                        if (tail > tailMax) {
                            tailMax = tail;
                        }

                        if (tail >= 0) {
                            op.addTail(job, tail);
                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }

                        if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                            op.criticalToJob(job);
                        }
                    }
                    op.setTailMax(tailMax);
                    if (structure.equals("type1")) {
                        if ((operationsTomove1.contains(oJ.getId()) && op.getCompletionTime() == oJ.getStartTime())
                                || (operationsTomove1.contains(oM.getId()) && op.getCompletionTime() == oM.getStartTime())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }

                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        for (int job = 1; job <= jobs.size(); job++) {
                            if (orderJobs.contains(job) && op.getCriticalToJob().get(job) == Boolean.TRUE) {
                                if ((pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob() && !pbM.getId().equals("start"))
                                        || (operationsTomove2.contains(oM.getId()) && op.getCompletionTime() == oM.getStartTime() && oM.getJob() != op.getJob())) {
                                    operationsTomove2.addFirst(op.getId());
                                    break;
                                }
                            }
                        }
                    }

                }
                operations.put(op.getId(), op);
            }
        }
    }

    //--------------------------
    static LinkedList<Integer> updateJobsandExclusive(String criterion) {

        LinkedList<Integer> partial = new LinkedList<Integer>();
        LinkedList<Integer> order = new LinkedList<Integer>();
        Operation start = exclusiveOperations.get("start");
        Operation endMachine = exclusiveOperations.get("endMachine");
        int arcs = 0;
        int makespan = 0;
        int tmax = 0;
        int tft = 0;
        int twft = 0;
        int twt = 0;
        int twu = 0;

        if (criterion.equals("makespan")) {

            for (int i = 1; i <= jobs.size(); i++) {

                jobs.get(i).setStartTime(operations.get(jobs.get(i).getJobOperations().getFirst()).getStartTime());
                jobs.get(i).setCompletionTime(operations.get(jobs.get(i).getJobOperations().getLast()).getCompletionTime());
                Operation last = operations.get(jobs.get(i).getJobOperations().getLast());
                Operation endByJob = exclusiveOperations.get("endByJob_" + last.getJob());
                endByJob.setNumberOfArcs(last.getNumberOfArcs() + 1);
                endByJob.setCompletionTime(last.getCompletionTime());
                exclusiveOperations.put(endByJob.getId(), endByJob);
                jobs.put(i, jobs.get(i));

                int maxArcs = last.getNumberOfArcs();
                if (maxArcs > arcs) {
                    arcs = maxArcs;
                }
                int ref = jobs.get(i).getCompletionTime();
                start.addTail(i, ref);

                if (ref >= makespan) {
                    makespan = ref;
                    partial.addFirst(i);
                }
                int refTmax = 0;

                if (jobs.get(i).getCompletionTime() > jobs.get(i).getDueDate()) {
                    refTmax = jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate();
                    twt = twt + (jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate()) * jobs.get(i).getWeigthValue();
                    twu = twu + 1;
                    if (refTmax > tmax) {
                        tmax = refTmax;
                    }
                }

                tft = tft + jobs.get(i).getCompletionTime();
                twft = twft + jobs.get(i).getCompletionTime() * jobs.get(i).getWeigthValue();

            }

            setCriterionValue(makespan);
            setCriterionTmax(tmax);
            setCriterionTFT(tft);
            setCriterionTWFT(twft);
            setCriterionTWT(twt);
            setCriterionTWU(twu);

            start.setTailMax(makespan);
            endMachine.setStartTime(makespan);
            endMachine.setNumberOfArcs(arcs + 1);
            exclusiveOperations.put("start", start);
            exclusiveOperations.put("endMachine", endMachine);
            order.add(partial.getFirst());

            for (int j = 0; j < partial.size() - 1; j++) {

                if (partial.size() == 1) {
                    break;
                }
                if (jobs.get(partial.get(j)).getCompletionTime() > jobs.get(partial.get(j + 1)).getCompletionTime()) {
                    break;
                }
                if (jobs.get(partial.get(j)).getCompletionTime() == jobs.get(partial.get(j + 1)).getCompletionTime()) {
                    order.add(partial.get(j + 1));
                }

            }

        } else if (criterion.equals("tmax")) {

            for (int i = 1; i <= jobs.size(); i++) {
                jobs.get(i).setStartTime(operations.get(jobs.get(i).getJobOperations().getFirst()).getStartTime());
                jobs.get(i).setCompletionTime(operations.get(jobs.get(i).getJobOperations().getLast()).getCompletionTime());
                jobs.get(i).setJobTardiness(0);
                Operation last = operations.get(jobs.get(i).getJobOperations().getLast());
                Operation endByJob = exclusiveOperations.get("endByJob_" + last.getJob());
                endByJob.setNumberOfArcs(last.getNumberOfArcs() + 1);
                endByJob.setCompletionTime(last.getCompletionTime());
                exclusiveOperations.put(endByJob.getId(), endByJob);
                jobs.put(i, jobs.get(i));

                if (jobs.get(i).getCompletionTime() > jobs.get(i).getDueDate()) {
                    twt = twt + (jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate()) * jobs.get(i).getWeigthValue();
                    twu = twu + jobs.get(i).getWeigthValue();
                    jobs.get(i).setJobTardiness(jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate());
                }

                int maxArcs = last.getNumberOfArcs();
                if (maxArcs > arcs) {
                    arcs = maxArcs;
                }
                int ref1 = jobs.get(i).getCompletionTime();
                start.addTail(i, ref1);

                if (ref1 >= makespan) {
                    makespan = ref1;
                }
                int ref = jobs.get(i).getJobTardiness();
                if (ref >= tmax) {
                    tmax = ref;
                    partial.addFirst(i);
                }
                tft = tft + jobs.get(i).getCompletionTime();
                twft = twft + jobs.get(i).getCompletionTime() * jobs.get(i).getWeigthValue();
            }
            setCriterionValue(tmax);
            setCriterionMk(makespan);
            setCriterionTFT(tft);
            setCriterionTWFT(twft);
            setCriterionTWT(twt);
            setCriterionTWU(twu);

            start.setTailMax(makespan);
            endMachine.setStartTime(makespan);
            endMachine.setNumberOfArcs(arcs + 1);
            exclusiveOperations.put("start", start);
            exclusiveOperations.put("endMachine", endMachine);
            order.add(partial.getFirst());

            for (int j = 0; j < partial.size() - 1; j++) {
                if (partial.size() == 1) {
                    break;
                }
                if (jobs.get(partial.get(j)).getJobTardiness() > jobs.get(partial.get(j + 1)).getJobTardiness()) {
                    break;
                }
                if (jobs.get(partial.get(j)).getJobTardiness() == jobs.get(partial.get(j + 1)).getJobTardiness()) {
                    order.add(partial.get(j + 1));
                }

            }

        } else if (criterion.equals("twt") || criterion.equals("twu")) {

            for (int i = 1; i <= jobs.size(); i++) {

                jobs.get(i).setStartTime(operations.get(jobs.get(i).getJobOperations().getFirst()).getStartTime());
                jobs.get(i).setCompletionTime(operations.get(jobs.get(i).getJobOperations().getLast()).getCompletionTime());
                jobs.get(i).setJobTardiness(0);

                if (jobs.get(i).getCompletionTime() > jobs.get(i).getDueDate()) {
                    jobs.get(i).setJobTardiness(jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate());
                }
                Operation last = operations.get(jobs.get(i).getJobOperations().getLast());
                Operation endByJob = exclusiveOperations.get("endByJob_" + last.getJob());
                endByJob.setNumberOfArcs(last.getNumberOfArcs() + 1);
                endByJob.setCompletionTime(last.getCompletionTime());
                exclusiveOperations.put(endByJob.getId(), endByJob);
                jobs.put(i, jobs.get(i));
                int maxArcs = last.getNumberOfArcs();
                if (maxArcs > arcs) {
                    arcs = maxArcs;
                }
                int ref1 = jobs.get(i).getCompletionTime();
                start.addTail(i, ref1);
                if (ref1 >= makespan) {
                    makespan = ref1;
                }
                int ref = jobs.get(i).getJobTardiness();
                if (ref >= tmax) {
                    tmax = ref;
                }

                tft = tft + jobs.get(i).getCompletionTime();
                twft = twft + jobs.get(i).getCompletionTime() * jobs.get(i).getWeigthValue();

                if (criterion.equals("twt")) {

                    int tardiness = jobs.get(i).getJobTardiness();
                    if (tardiness > 0) {
                        twt = twt + jobs.get(i).getWeigthValue() * jobs.get(i).getJobTardiness();
                        twu = twu + jobs.get(i).getWeigthValue();
                        order.add(i);
                    }
                    setCriterionValue(twt);
                    setCriterionTWU(twu);

                }

                if (criterion.equals("twu")) {

                    int tardiness = jobs.get(i).getJobTardiness();
                    if (tardiness > 0) {
                        order.add(i);
                        twu = twu + jobs.get(i).getWeigthValue();
                        twt = twt + jobs.get(i).getWeigthValue() * jobs.get(i).getJobTardiness();
                    }
                    setCriterionValue(twu);
                    setCriterionTWT(twt);
                }

            }

            start.setTailMax(makespan);
            endMachine.setStartTime(makespan);
            setCriterionMk(makespan);
            setCriterionTFT(tft);
            setCriterionTWFT(twft);
            setCriterionTmax(tmax);

            endMachine.setNumberOfArcs(arcs + 1);
            exclusiveOperations.put("start", start);
            exclusiveOperations.put("endMachine", endMachine);
        } else if (criterion.equals("twc") || criterion.equals("tc")) {

            for (int i = 1; i <= jobs.size(); i++) {
                jobs.get(i).setStartTime(operations.get(jobs.get(i).getJobOperations().getFirst()).getStartTime());
                jobs.get(i).setCompletionTime(operations.get(jobs.get(i).getJobOperations().getLast()).getCompletionTime());
                Operation last = operations.get(jobs.get(i).getJobOperations().getLast());
                Operation endByJob = exclusiveOperations.get("endByJob_" + last.getJob());
                endByJob.setNumberOfArcs(last.getNumberOfArcs() + 1);
                endByJob.setCompletionTime(last.getCompletionTime());
                exclusiveOperations.put(endByJob.getId(), endByJob);
                jobs.put(i, jobs.get(i));
                int maxArcs = last.getNumberOfArcs();
                if (maxArcs > arcs) {
                    arcs = maxArcs;
                }

                int refTmax = 0;

                if (jobs.get(i).getCompletionTime() > jobs.get(i).getDueDate()) {
                    refTmax = jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate();
                    twt = twt + (jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate()) * jobs.get(i).getWeigthValue();
                    twu = twu + jobs.get(i).getWeigthValue();
                    if (refTmax > tmax) {
                        tmax = refTmax;
                    }
                }

                int ref1 = jobs.get(i).getCompletionTime();
                start.addTail(i, ref1);
                if (ref1 >= makespan) {
                    makespan = ref1;
                }
                order.add(i);

                if (criterion.equals("twc")) {
                    twft = twft + jobs.get(i).getWeigthValue() * jobs.get(i).getCompletionTime();
                    tft = tft + jobs.get(i).getCompletionTime();
                    setCriterionValue(twft);
                    setCriterionTFT(tft);
                }
                if (criterion.equals("tc")) {
                    tft = tft + jobs.get(i).getCompletionTime();
                    twft = twft + jobs.get(i).getWeigthValue() * jobs.get(i).getCompletionTime();
                    setCriterionValue(tft);
                    setCriterionTWFT(twft);
                }
            }
            setCriterionMk(makespan);
            setCriterionTmax(tmax);
            setCriterionTWT(twt);
            setCriterionTWU(twu);
            start.setTailMax(makespan);
            endMachine.setStartTime(makespan);
            endMachine.setNumberOfArcs(arcs + 1);
            exclusiveOperations.put("start", start);
            exclusiveOperations.put("endMachine", endMachine);

        }
        return order;
    }

    static void readerStructure(String type) {
        if (type.equals("type1")) {
            for (int i = 0; i < operationsTomove1.size(); i++) {
                System.out.println(operationsTomove1.get(i));
            }
        }
        if (type.equals("type2")) {
            for (int i = 0; i < operationsTomove2.size(); i++) {
                System.out.println(operationsTomove2.get(i));
            }
        }

    }
//------Feasible insertions Mista without Tabu List------

    //Hommework to Yazid.
    static void feasibleInsertionsYazid(String type, int criterionValue, String criterion, LinkedList<Integer> orderJobs) {

        // Set that Saves the operations to move
        LinkedList<String> operationsTomove = new LinkedList<>();
        //In order to protect the order of the jobs
        LinkedList<Integer> orderTemp = new LinkedList<>();
        // Real value of the criterion if a move were done
        int criterionValueTemp;
        // Best value of the move in realInsertions
        int bestMove = -Operation.MINIMUN_TAIL;

        if (type.equals("type1")) {
            //The operations to move of N1 are saved, since the graph is partially transformed and return to the same position
            for (int li = 0; li < operationsTomove1.size(); li++) {
                operationsTomove.add(operationsTomove1.get(li));
            }
        } else {
            //The operations to move of N12 are saved, since the graph is partially transformed and return to the same position
            for (int li = 0; li < operationsTomove2.size(); li++) {
                operationsTomove.add(operationsTomove2.get(li));
            }
        }
        
     
        for (int i = 0; i < operationsTomove.size(); i++) {
            //Operations related to I are invoked 
            Operation opI = operations.get(operationsTomove.get(i));
            int mach = opI.getMachineAssigned();
            //preview operation by machine
            Operation opS;
            if (opI.getPreviewOperationByMachine().equals("start")) {
                opS = exclusiveOperations.get("start");
            } else {
                opS = operations.get(opI.getPreviewOperationByMachine());
            }

            //Next operation by machine of I
            Operation opT;
            if (opI.getNextOperationByMachine().equals("endMachine")) {
                opT = exclusiveOperations.get("endMachine");
            } else {
                opT = operations.get(opI.getNextOperationByMachine());
            }
            //Next operation by job of I
            Operation nbjI;
            if (opI.getNextOperationByJob().equals("endByJob_" + opI.getJob())) {
                nbjI = exclusiveOperations.get("endByJob_" + opI.getJob());
            } else {
                nbjI = operations.get(opI.getNextOperationByJob());
            }
            //Preview operatioin by job of I
            Operation pbjI;
            if (opI.getPreviewOperationByJob().equals("start")) {
                pbjI = exclusiveOperations.get("start");
            } else {
                pbjI = operations.get(opI.getPreviewOperationByJob());
            }

            //-----It is the resequencing process-----------//
            if (machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() > 3) {

                //-----Forward process (Case 1 is applied)-----------//
                if (opI.getOrderinMachine() >= 1 && opI.getOrderinMachine()
                        <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                    //The position of the operation in the machine is located then advancing in the move search
                    for (int pos = opI.getOrderinMachine(); pos <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3; pos++) {
                        Operation opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 1));
                        //If the job of J is the same of I, the cycle is broken
                        if (opJ.getJob() == opI.getJob()) {
                            break;
                        }
                        // The Operation k is invoked
                        Operation opK;
                        if (pos == machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                            opK = exclusiveOperations.get("endMachine");
                        } else {
                            opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 2));
                        }

                        //Control variables of each test before evalauting the feasibility
                        int htaFeas = 0;
                        int tailPhiFeas = 0;
                        //Starts The test HTA test as soon as J and K are defined
                        if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                            if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                //Test HTA success
                                htaFeas = 1;
                            }
                        }

                        //If HTA fails TailPhi will be tested to ensure the feasibility
                        if (htaFeas == 0) {
                            //control Variable.

                            for (int job = 1; job <= totalJobs; job++) {
                                if ((nbjI.findJobsTail(job) < 0 && opJ.findJobsTail(job) >= 0)
                                        || ((nbjI.findJobsTail(job) >= 0 && opJ.findJobsTail(job) >= 0)
                                        && (nbjI.findJobsTail(job) < opJ.findJobsTail(job) + opJ.getTimeMachine()))) {
                                    if ((opK.findJobsTail(job) < 0 && pbjI.findJobsTail(job) >= 0)
                                            || ((opK.findJobsTail(job) >= 0 && pbjI.findJobsTail(job) >= 0) && (pbjI.findJobsTail(job) + pbjI.getTimeMachine() > opK.findJobsTail(job)))) {
                                        tailPhiFeas = 1;
                                        break;
                                    }
                                }
                            }
                        }

                        int sufCond = 0;
                        //If HTA and Tail-Phi fails, suficient conditions are evaluated
                        if (htaFeas == 0 && tailPhiFeas == 0) {
                            if (!nbjI.getSuccesors().contains(opJ.getId())) {
                                sufCond = 1;
                            }
                            if (sufCond == 0) {
                                break;
                            }
                        }

                        if (htaFeas == 1 || tailPhiFeas == 1 || sufCond == 1) {
                            //Transformation of the graph to determine the quality of the move

                            //readerOperations();
                            createSolutionForward(opI.getId(), opJ.getId(), opK.getId(), opS.getId(), opT.getId(), mach);
                            deleteStructureTemporal(type);
                            orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                            operationTails(orderTemp, type);
                            //The value of the criterion is saved 
                            criterionValueTemp = getCriterionValue();

                            //System.out.println(opJ.getId() + "---" + opI.getId() +"---" +opK.getId() + "----" +criterionValueTemp);
                            //Return to the original graph
                            //readerOperations();
                            createSolutionForward(opI.getId(), opS.getId(), opT.getId(), opJ.getId(), opK.getId(), mach);
                            deleteStructureTemporal(type);
                            orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                            operationTails(orderTemp, type);
                            //-------End of the transformation of the graph

                            //Evaluate the quality of the move
                            if (criterionValueTemp < criterionValue) {
                                //The insertion is saved if it is improved the current value with the machine
                                if (criterionValueTemp <= bestMove) {
                                    bestMove = criterionValueTemp;
                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), criterionValueTemp, mach);
                                    insertions.add(newInsertion);
                                }
                                //Count as an improving move

                            }//Close the count of  moves
                        }
                    }

                    //Backward process
                    if (opI.getOrderinMachine() >= 2 && opI.getOrderinMachine() <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 2) {
                        for (int pos = opI.getOrderinMachine(); pos >= 2; pos--) {
                            Operation opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 1));
                            // If opK belongs to the same job of opI is broken cycle
                            if (opK.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opJ;
                            if (pos == 2) {
                                opJ = exclusiveOperations.get("start");
                            } else {
                                opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 2));
                            }

                            //Control variables of each test before evalauting the feasibility
                            int htaFeas = 0;
                            int tailPhiFeas = 0;
                            //Starts The test HTA test as soon as J and K are defined
                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    //Test HTA success
                                    htaFeas = 1;
                                }
                            }

                            //If HTA fails TailPhi will be tested to ensure the feasibility
                            if (htaFeas == 0) {
                                for (int job = 1; job <= totalJobs; job++) {
                                    if ((nbjI.findJobsTail(job) < 0 && opJ.findJobsTail(job) >= 0)
                                            || ((nbjI.findJobsTail(job) >= 0 && opJ.findJobsTail(job) >= 0)
                                            && (nbjI.findJobsTail(job) < opJ.findJobsTail(job) + opJ.getTimeMachine()))) {
                                        if ((opK.findJobsTail(job) < 0 && pbjI.findJobsTail(job) >= 0)
                                                || ((opK.findJobsTail(job) >= 0 && pbjI.findJobsTail(job) >= 0) && (pbjI.findJobsTail(job) + pbjI.getTimeMachine() > opK.findJobsTail(job)))) {
                                            //Test success
                                            tailPhiFeas = 1;
                                            //control variable
                                            break;
                                        }
                                    }
                                }
                            }

                            int sufCond = 0;
                            //If HTA and Tail-Phi fails, suficient conditions are evaluated
                            if (htaFeas == 0 && tailPhiFeas == 0) {
                                if (!opK.getSuccesors().contains(pbjI.getId())) {
                                    sufCond = 1;
                                }
                                if (sufCond == 0) {
                                    break;
                                }
                            }

                            if (htaFeas == 1 || tailPhiFeas == 1 || sufCond == 1) {
                                //Transformation of the graph to determine the quality of the move
                                //readerOperations();
                                createSolutionForward(opI.getId(), opJ.getId(), opK.getId(), opS.getId(), opT.getId(), mach);
                                deleteStructureTemporal(type);
                                orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                operationTails(orderTemp, type);
                                //The value of the criterion is saved 
                                criterionValueTemp = getCriterionValue();
                                //readerOperations();
                                //Return to the original graph
                                //System.out.println(opJ.getId() + "---" + opI.getId() +"---" +opK.getId() + "----" + criterionValueTemp);

                                createSolutionForward(opI.getId(), opS.getId(), opT.getId(), opJ.getId(), opK.getId(), mach);
                                deleteStructureTemporal(type);
                                orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                operationTails(orderTemp, type);
                                //-------End of the transformation of the graph

                                //Evaluate the quality of the move
                                if (criterionValueTemp < criterionValue) {
                                    //The insertion is saved if it is improved the current value with the machine
                                    if (criterionValueTemp <= bestMove) {
                                        bestMove = criterionValueTemp;
                                        Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), criterionValueTemp, mach);
                                        insertions.add(newInsertion);
                                    }
                                    //Count as an improving move

                                }//Close the count of  moves
                            }
                        }
                    }
                    //-------Finish resequencing process--------

                    //---------Start reasignning process---
                    for (int m = 0; m < machines.length; m++) {
                        if (machines[m].getId() != opI.getMachineAssigned() && opI.getTimesInMachine().containsKey(machines[m].getId())) {

                            //If there is at least one machine which belong to M opI. M contains Start and End Machine 
                            if (machines[m].getAssignedOperations().size() < 3) {
                                Operation opJ = exclusiveOperations.get("start");
                                Operation opK = exclusiveOperations.get("endMachine");
                                //Transformation of the graph to determine the quality of the move
                                createSolutionForward(opI.getId(), opJ.getId(), opK.getId(), opS.getId(), opT.getId(), machines[m].getId());
                                deleteStructureTemporal(type);
                                orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                operationTails(orderTemp, type);
                                //The value of the criterion is saved 
                                criterionValueTemp = getCriterionValue();
                                //Return to the original graph
                                createSolutionForward(opI.getId(), opS.getId(), opT.getId(), opJ.getId(), opK.getId(), mach);
                                deleteStructureTemporal(type);
                                orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                operationTails(orderTemp, type);
                                //-------End of the transformation of the graph                      

                                if (criterionValueTemp < criterionValue) {
                                    if (criterionValueTemp <= bestMove) {
                                        bestMove = criterionValueTemp;
                                        Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), criterionValueTemp, machines[m].getId());
                                        insertions.add(newInsertion);
                                    }
                                }

                            }

                            //If there exists any machine which belong to M opI, its sequence size is greater or equal than 3.  
                            if (machines[m].getAssignedOperations().size() >= 3) {

                                // In case M performs pbjI, pbjI different from start
                                if (machines[m].getId() == pbjI.getMachineAssigned() && !pbjI.getId().equals("start")) {
                                    int cont = 0;

                                    for (int w = pbjI.getOrderinMachine(); w < machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().size() - 1; w++) {
                                        Operation opJ = operations.get(machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                        if ((opJ.getJob() == opI.getJob()) && (opJ.getNumberOfArcs() > opI.getNumberOfArcs())) {
                                            break;
                                        }

                                        Operation opK;
                                        if (opJ.getNextOperationByMachine().equals("endMachine")) {
                                            opK = exclusiveOperations.get("endMachine");
                                        } else {
                                            opK = operations.get(opJ.getNextOperationByMachine());
                                        }
                                        //Control variables of each test before evalauting the feasibility
                                        int htaFeas = 0;
                                        int tailPhiFeas = 0;
                                        //Starts The test HTA test as soon as J and K are defined
                                        if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                            if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                                //Test HTA success
                                                htaFeas = 1;
                                            }
                                        }

                                        //If HTA fails TailPhi will be tested to ensure the feasibility
                                        if (htaFeas == 0) {
                                            for (int job = 1; job <= totalJobs; job++) {
                                                if ((nbjI.findJobsTail(job) < 0 && opJ.findJobsTail(job) >= 0)
                                                        || ((nbjI.findJobsTail(job) >= 0 && opJ.findJobsTail(job) >= 0)
                                                        && (nbjI.findJobsTail(job) < opJ.findJobsTail(job) + opJ.getTimeMachine()))) {
                                                    if ((opK.findJobsTail(job) < 0 && pbjI.findJobsTail(job) >= 0)
                                                            || ((opK.findJobsTail(job) >= 0 && pbjI.findJobsTail(job) >= 0) && (pbjI.findJobsTail(job) + pbjI.getTimeMachine() > opK.findJobsTail(job)))) {
                                                        //Test success
                                                        tailPhiFeas = 1;
                                                        //control variable
                                                        break;
                                                    }
                                                }
                                            }
                                        }

                                        int sufCond = 0;
                                        //If HTA and Tail-Phi fails, suficient conditions are evaluated
                                        if (htaFeas == 0 && tailPhiFeas == 0) {
                                            int val = 0;
                                            if (opJ.getNumberOfArcs() > nbjI.getNumberOfArcs()) {
                                                val = 1;
                                                if (!nbjI.getSuccesors().contains(opJ.getId())) {
                                                    sufCond = 1;
                                                }
                                            }
                                            if (val == 0 && sufCond == 0) {
                                                sufCond = 1;
                                            }
                                            if (val == 1 && sufCond == 0) {
                                                break;
                                            }
                                        }

                                        if (htaFeas == 1 || tailPhiFeas == 1 || sufCond == 1) {
                                            //Transformation of the graph to determine the quality of the move
                                            createSolutionForward(opI.getId(), opJ.getId(), opK.getId(), opS.getId(), opT.getId(), machines[m].getId());
                                            deleteStructureTemporal(type);
                                            orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                            operationTails(orderTemp, type);
                                            //The value of the criterion is saved 
                                            criterionValueTemp = getCriterionValue();
                                            //readerOperations();
                                            //System.out.println(opJ.getId() + "---" + opI.getId() +"---" +opK.getId() + "----" + criterionValueTemp);                                    
                                            //Return to the original graph
                                            createSolutionForward(opI.getId(), opS.getId(), opT.getId(), opJ.getId(), opK.getId(), mach);
                                            deleteStructureTemporal(type);
                                            orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                            operationTails(orderTemp, type);

                                            //-------End of the transformation of the graph
                                            //Evaluate the quality of the move
                                            if (criterionValueTemp < criterionValue) {
                                                //The insertion is saved if it is improved the current value with the machine
                                                if (criterionValueTemp <= bestMove) {
                                                    bestMove = criterionValueTemp;
                                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), criterionValueTemp, machines[m].getId());
                                                    insertions.add(newInsertion);
                                                }

                                            }//Close the count of  moves
                                        }//Search
                                    }//Close

                                    // if m performs nbjI but not pbjI. nbjI different from endByJob
                                    if (machines[m].getId() == nbjI.getMachineAssigned() && !nbjI.getId().equals("endByJob_" + opI.getJob()) && pbjI.getMachineAssigned() != machines[m].getId()) {
                                        //Determine the feasible insertions since it is a backward strategy
                                        for (int w = nbjI.getOrderinMachine(); w >= 1; w--) {
                                            Operation opK = operations.get(machines[nbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                            if (opK.getJob() == opI.getJob() && w < nbjI.getOrderinMachine()) {
                                                break;
                                            }
                                            Operation opJ;
                                            if (opK.getPreviewOperationByMachine().equals("start")) {
                                                opJ = exclusiveOperations.get("start");
                                            } else {
                                                opJ = operations.get(opK.getPreviewOperationByMachine());
                                            }
                                            //Control variables of each test before evalauting the feasibility
                                            int htaFeas = 0;
                                            int tailPhiFeas = 0;

                                            //Starts The test HTA test as soon as J and K are defined
                                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                                    //Test HTA success
                                                    htaFeas = 1;
                                                }
                                            }

                                            //If HTA fails TailPhi will be tested to ensure the feasibility
                                            if (htaFeas == 0) {
                                                for (int job = 1; job <= totalJobs; job++) {
                                                    if ((nbjI.findJobsTail(job) < 0 && opJ.findJobsTail(job) >= 0)
                                                            || ((nbjI.findJobsTail(job) >= 0 && opJ.findJobsTail(job) >= 0)
                                                            && (nbjI.findJobsTail(job) < opJ.findJobsTail(job) + opJ.getTimeMachine()))) {
                                                        if ((opK.findJobsTail(job) < 0 && pbjI.findJobsTail(job) >= 0)
                                                                || ((opK.findJobsTail(job) >= 0 && pbjI.findJobsTail(job) >= 0) && (pbjI.findJobsTail(job) + pbjI.getTimeMachine() > opK.findJobsTail(job)))) {
                                                            //Test success
                                                            tailPhiFeas = 1;
                                                            //control variable
                                                            break;
                                                        }
                                                    }
                                                }
                                            }

                                            int sufCond = 0;
                                            //If HTA and Tail-Phi fails, suficient conditions are evaluated
                                            if (htaFeas == 0 && tailPhiFeas == 0) {
                                                int val = 0;
                                                if (pbjI.getNumberOfArcs() > opK.getNumberOfArcs()) {
                                                    val = 1;
                                                    if (!opK.getSuccesors().contains(pbjI.getId())) {
                                                        sufCond = 1;
                                                    }
                                                }
                                                if (val == 0 && sufCond == 0) {
                                                    sufCond = 1;
                                                }
                                                if (val == 1 && sufCond == 0) {
                                                    break;
                                                }
                                            }

                                            if (htaFeas == 1 || tailPhiFeas == 1 || sufCond == 1) {
                                                //Transformation of the graph to determine the quality of the move
                                                createSolutionForward(opI.getId(), opJ.getId(), opK.getId(), opS.getId(), opT.getId(), machines[m].getId());
                                                deleteStructureTemporal(type);
                                                orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                                operationTails(orderTemp, type);
                                                //The value of the criterion is saved 
                                                criterionValueTemp = getCriterionValue();
                                                //System.out.println(opJ.getId() + "---" + opI.getId() +"---" +opK.getId() + "----" + criterionValueTemp);
                                                //readerOperations();
                                                //Return to the original graph
                                                createSolutionForward(opI.getId(), opS.getId(), opT.getId(), opJ.getId(), opK.getId(), mach);
                                                deleteStructureTemporal(type);
                                                orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                                operationTails(orderTemp, type);

                                                //-------End of the transformation of the graph
                                                //Evaluate the quality of the move
                                                if (criterionValueTemp < criterionValue) {
                                                    //The insertion is saved if it is improved the current value with the machine
                                                    if (criterionValueTemp <= bestMove) {
                                                        bestMove = criterionValueTemp;
                                                        Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), criterionValueTemp, machines[m].getId());
                                                        insertions.add(newInsertion);
                                                    }
                                                    //Count as an improving move

                                                }
                                            }//Close the count of  moves
                                        }

                                    }

                                    //-------------------------- This part evaluates from the first operation 
                                    if (machines[m].getId() != pbjI.getMachineAssigned() && machines[m].getId() != nbjI.getMachineAssigned()) {
                                        //Determine the moves

                                        for (int w = 0; w < machines[m].getAssignedOperations().size() - 1; w++) {
                                            //Invoke k
                                            Operation opJ;
                                            Operation opK;
                                            if (w == 0) {
                                                opJ = exclusiveOperations.get("start");
                                            } else {
                                                opJ = operations.get(machines[m].getAssignedOperations().get(w));
                                            }
                                            //Condition to finish the search
                                            if (opJ.getJob() == opI.getJob() && opJ.getNumberOfArcs() > opI.getNumberOfArcs()) {
                                                break;
                                            }
                                            if (w == machines[m].getAssignedOperations().size() - 2) {
                                                opK = exclusiveOperations.get("endMachine");
                                            } else {
                                                opK = operations.get(machines[m].getAssignedOperations().get(w + 1));
                                            }
                                            //Control variables of each test before evalauting the feasibility
                                            int htaFeas = 0;
                                            int tailPhiFeas = 0;
                                            //Starts The test HTA test as soon as J and K are defined
                                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                                    //Test HTA success
                                                    htaFeas = 1;
                                                }
                                            }

                                            //If HTA fails TailPhi will be tested to ensure the feasibility
                                            if (htaFeas == 0) {
                                                for (int job = 1; job <= totalJobs; job++) {
                                                    if ((nbjI.findJobsTail(job) < 0 && opJ.findJobsTail(job) >= 0)
                                                            || ((nbjI.findJobsTail(job) >= 0 && opJ.findJobsTail(job) >= 0)
                                                            && (nbjI.findJobsTail(job) < opJ.findJobsTail(job) + opJ.getTimeMachine()))) {
                                                        if ((opK.findJobsTail(job) < 0 && pbjI.findJobsTail(job) >= 0)
                                                                || ((opK.findJobsTail(job) >= 0 && pbjI.findJobsTail(job) >= 0) && (pbjI.findJobsTail(job) + pbjI.getTimeMachine() > opK.findJobsTail(job)))) {
                                                            //Test success
                                                            tailPhiFeas = 1;
                                                            //control variable
                                                            break;
                                                        }
                                                    }
                                                }
                                            }
                                            int sufCond = 0;
                                            //If HTA and Tail-Phi fails, suficient conditions are evaluated
                                            if (htaFeas == 0 && tailPhiFeas == 0) {
                                                int cond1 = 1;
                                                int cond2 = 0;
                                                if (pbjI.getNumberOfArcs() > opK.getNumberOfArcs()) {
                                                    if (opK.getSuccesors().contains(pbjI.getId())) {
                                                        cond1 = 0;
                                                    }
                                                }
                                                if (cond1 == 1) {
                                                    if (opJ.getNumberOfArcs() > nbjI.getNumberOfArcs()) {
                                                        if (nbjI.getSuccesors().contains(opJ.getId())) {
                                                            break;
                                                        } else {
                                                            cond2 = 1;
                                                        }
                                                    } else {
                                                        cond2 = 1;
                                                    }
                                                }

                                                if (cond2 == 1) {
                                                    sufCond = 1;
                                                }
                                                if (cond1 == 1 && cond2 == 0) {
                                                    break;
                                                }

                                            }

                                            if (htaFeas == 1 || tailPhiFeas == 1 || sufCond == 1) {
                                                //Transformation of the graph to determine the quality of the move
                                                createSolutionForward(opI.getId(), opJ.getId(), opK.getId(), opS.getId(), opT.getId(), machines[m].getId());
                                                deleteStructureTemporal(type);
                                                orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                                operationTails(orderTemp, type);
                                                //The value of the criterion is saved 
                                                criterionValueTemp = getCriterionValue();

                                                //readerOperations();
                                                //System.out.println(opJ.getId() + "---" + opI.getId() +"---" +opK.getId() + "----" + criterionValueTemp);                                    
                                                //Return to the original graph
                                                createSolutionForward(opI.getId(), opS.getId(), opT.getId(), opJ.getId(), opK.getId(), mach);
                                                deleteStructureTemporal(type);
                                                orderTemp = new LinkedList<>(updateJobsandExclusive(criterion));
                                                operationTails(orderTemp, type);

                                                //-------End of the transformation of the graph
                                                //Evaluate the quality of the move
                                                if (criterionValueTemp < criterionValue) {
                                                    //The insertion is saved if it is improved the current value with the machine
                                                    if (criterionValueTemp <= bestMove) {
                                                        bestMove = criterionValueTemp;
                                                        Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), criterionValueTemp, machines[m].getId());
                                                        insertions.add(newInsertion);
                                                    }
                                                    //Count as an improving move

                                                }
                                            }//Close the count of  moves
                                        }
                                    }

                                }

                            }
                        }

                    }
                    //readerOperations();
                    if (!insertions.isEmpty()) {
                        String j1 = "";
                        String x1 = "";
                        String k1 = "";
                        int mac = 0;

                        //Recover the insertion related to bem. This insertion represents the move to perform.
                        for (int ins = 0; ins < insertions.size(); ins++) {
                            if (bestMove == insertions.get(ins).getCriterionValue()) {
                                j1 = insertions.get(ins).getNodej();
                                x1 = insertions.get(ins).getNodei();
                                k1 = insertions.get(ins).getNodek();
                                mac = insertions.get(ins).getMachine();
                                insertions.clear();
                                Insertion newSel = new Insertion(x1, j1, k1, bestMove, mac);
                                insertions.add(newSel);
                                //System.out.println("Insertion--(" + j1 + ")(" + x1 + ")(" + k1 + ")" + bestMove);
                                break;
                            }
                        }
                    }
                }
            }
        }
    } //Close homework of Yazid. 
//----

    static int criterionStimated(int[] estimatedValues, String criterion, LinkedList<Integer> orderJobs) {
        int criterionStimated = 0;

        if (criterion.equals("makespan")) {

            for (int i = 0; i < totalJobs; i++) {
                if (estimatedValues[i] >= criterionStimated) {
                    criterionStimated = estimatedValues[i];
                }
            }
        } else if (criterion.equals("tc")) {
            for (int i = 0; i < totalJobs; i++) {
                criterionStimated = criterionStimated + estimatedValues[i];
            }
        } else if (criterion.equals("twc")) {
            for (int i = 0; i < totalJobs; i++) {
                criterionStimated = criterionStimated + estimatedValues[i] * jobs.get(i + 1).getWeigthValue();
            }
        } else if (criterion.equals("tmax")) {
            int tmax = 0;
            for (int i = 0; i < totalJobs; i++) {
                if (jobs.get(i + 1).getDueDate() < estimatedValues[i]) {
                    tmax = estimatedValues[i] - jobs.get(i + 1).getDueDate();
                }
                if (tmax > criterionStimated) {
                    criterionStimated = tmax;
                }
            }
        } else if (criterion.equals("twt")) {
            for (int i = 0; i < totalJobs; i++) {
                if (jobs.get(i + 1).getDueDate() < estimatedValues[i]) {
                    criterionStimated = criterionStimated + estimatedValues[i] - jobs.get(i + 1).getDueDate();
                }

            }
        } else if (criterion.equals("aux")) {
            for (int i = 0; i < totalJobs; i++) {
                if (orderJobs.contains(i + 1)) {
                    if (estimatedValues[i] > jobs.get(i + 1).getDueDate()) {
                        criterionStimated = criterionStimated + estimatedValues[i] - jobs.get(i + 1).getDueDate();
                    }
                }
            }
        }

        return criterionStimated;
    }

    static void bestInsertion() {

        //Escoger la mas pequeña. 
        int ref = -Operation.MINIMUN_TAIL;
        for (int i = 0; i < insertions.size(); i++) {
            if (insertions.get(i).getCriterionValue() < ref) {
                ref = insertions.get(i).getCriterionValue();
            }

        }

        for (int i = 0; i < insertions.size(); i++) {
            if (insertions.get(i).getCriterionValue() > ref) {
                insertions.remove(i);
                i--;
            }

        }

    }

    static void createNewSolutionBuilTabu(int x) {

        Operation opI = operations.get(insertions.get(x).getNodei());
        Operation opJ;
        Operation opK;
        Operation opS;
        Operation opT;
        String opj = insertions.get(x).getNodej();
        String opk = insertions.get(x).getNodek();
        String ops = opI.getPreviewOperationByMachine();
        String opt = opI.getNextOperationByMachine();

        if (opj.equals("start")) {
            opJ = exclusiveOperations.get("start");
        } else {
            opJ = operations.get(insertions.get(x).getNodej());
        }
        if (opk.equals("endMachine")) {
            opK = exclusiveOperations.get("endMachine");
        } else {
            opK = operations.get(insertions.get(x).getNodek());
        }
        if (ops.equals("start")) {
            opS = exclusiveOperations.get("start");
        } else {
            opS = operations.get(opI.getPreviewOperationByMachine());
        }
        if (opt.equals("endMachine")) {
            opT = exclusiveOperations.get("endMachine");
        } else {
            opT = operations.get(opI.getNextOperationByMachine());
        }

        opI.setNextOperationByMachine(opK.getId());
        opI.setPreviewOperationByMachine(opJ.getId());
        opI.setMachineAssigned(insertions.get(x).getMachine());
        opI.setTimeMachine(opI.getTimesInMachine().get(opI.getMachineAssigned()));
        operations.put(opI.getId(), opI);
        if (!opJ.getId().equals("start")) {
            opJ.setNextOperationByMachine(opI.getId());
            operations.put(opJ.getId(), opJ);
        }
        if (!opK.getId().equals("endMachine")) {
            opK.setPreviewOperationByMachine(opI.getId());
            operations.put(opK.getId(), opK);
        }
        if (!opS.getId().equals("start")) {
            opS.setNextOperationByMachine(opT.getId());
            operations.put(opS.getId(), opS);
        }
        if (!opT.getId().equals("endMachine")) {
            opT.setPreviewOperationByMachine(opS.getId());
            operations.put(opT.getId(), opT);
        }

    }

    static void deleteStructureandUpdateDate(String type) {
        //Delete the assigned operations to the machines and add Start
        deleteAndIntStartinMachines();
        //Delete Bellman Order
        bellmanOrder.clear();
        //Set start time, completion time. Forward Solution      
        updateOperations();
        //Add *(end Machine)
        addendMachine();
        //Delete the set of feasible insertions less than the current value
        insertions.clear();
        insertionsReal.clear();

        if (type.equals("type1")) {
            operationsTomove1.clear();
        } else {
            operationsTomove2.clear();
        }
    }

    public static void createFileBest(String fileName) {
        File f = new File(fileName);

        try {
            FileWriter w = new FileWriter(f);
            BufferedWriter bw = new BufferedWriter(w);
            PrintWriter wr = new PrintWriter(bw);

            wr.write("Results for the Schedule \n");

            for (int i = 0; i < machines.length; i++) {
                wr.append("--Machine--" + machines[i].getId() + "\n");
                for (int j = 0; j < machines[i].getAssignRecord().size(); j++) {
                    if (j <= machines[i].getAssignRecord().size() - 2) {
                        wr.append(machines[i].getAssignRecord().get(j) + ",");
                    }
                    if (j == machines[i].getAssignRecord().size() - 1) {
                        wr.append(machines[i].getAssignRecord().get(j) + ".");
                    }
                }
                wr.append("\n");
            }
            wr.close();
            bw.close();

        } catch (IOException e) {
        };

    }

    static void feasibleDiversif(String type) {

        LinkedList<String> operationsTodiversify = new LinkedList<>();
        if (type.equals("type1")) {
            //Select random two operations
            operationsTodiversify.add(operationsTomove1.get(((int) (Math.random() * (operationsTomove1.size() - 1 + 1) + 1)) - 1));
            operationsTodiversify.add(operationsTomove1.get(((int) (Math.random() * (operationsTomove1.size() - 1 + 1) + 1)) - 1));

            for (int i = 0; i < operationsTodiversify.size(); i++) {

                //Operations related to I are invoked 
                Operation opI = operations.get(operationsTodiversify.get(i));

                Operation nbjI;
                if (opI.getNextOperationByJob().equals("endByJob_" + opI.getJob())) {
                    nbjI = exclusiveOperations.get("endByJob_" + opI.getJob());
                } else {
                    nbjI = operations.get(opI.getNextOperationByJob());
                }

                Operation pbjI;
                if (opI.getPreviewOperationByJob().equals("start")) {
                    pbjI = exclusiveOperations.get("start");
                } else {
                    pbjI = operations.get(opI.getPreviewOperationByJob());
                }
                //-----It is the resequencing process-----------//
                if (machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() > 3) {

                    //-----Forward process -----------//
                    if (opI.getOrderinMachine() >= 1 && opI.getOrderinMachine()
                            <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {

                        //Control variable for escaping if an ubfeasible move is found.
                        int cont = 0;

                        for (int pos = opI.getOrderinMachine(); pos <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3; pos++) {
                            Operation opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 1));

                            if (opJ.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opK;
                            if (pos == machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                                opK = exclusiveOperations.get("endMachine");
                            } else {
                                opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 2));
                            }

                            //The test HTA
                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    cont = pos;
                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), opI.getMachineAssigned());
                                    insertions.add(newInsertion);

                                }
                            }
                            if (cont != 0 && pos > cont) {
                                //System.out.println("----Aqui se rompio---" + opI.getId() + "---" + opJ.getId() + "---" + opK.getId());
                                break;
                            }
                        }

                    }
                    //Backward process

                    if (opI.getOrderinMachine() >= 2 && opI.getOrderinMachine() <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 2) {

                        int cont = 0;
                        for (int pos = opI.getOrderinMachine(); pos >= 2; pos--) {

                            Operation opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 1));
                            if (opK.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opJ;
                            if (pos == 2) {
                                opJ = exclusiveOperations.get("start");
                            } else {
                                opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 2));
                            }

                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    cont = pos;

                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), opI.getMachineAssigned());
                                    insertions.add(newInsertion);

                                }
                            }

                            if (cont != 0 && pos < cont) {
                                break;
                            }

                        }

                    }
                }
                //-------Finish resequencing process--------

                //---------Start reasignning process---
                for (int m = 0; m < machines.length; m++) {

                    if (machines[m].getId() != opI.getMachineAssigned() && opI.getTimesInMachine().containsKey(machines[m].getId())) {

                        //If there is at least one machine which belong to M opI. M contains Start and End Machine 
                        if (machines[m].getAssignedOperations().size() < 3) {
                            Insertion newInsertion = new Insertion(opI.getId(), "start", "endMachine", machines[m].getId());
                            insertions.add(newInsertion);
                        }

                        //If there exists any machine which belong to M opI, its sequence size is greater or equal than 3.  
                        if (machines[m].getAssignedOperations().size() >= 3) {

                            // In case M performs pbjI, pbjI different from start
                            if (machines[m].getId() == pbjI.getMachineAssigned() && !pbjI.getId().equals("start")) {
                                int cont = 0;

                                for (int w = pbjI.getOrderinMachine(); w < machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ = operations.get(machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                    if ((opJ.getJob() == opI.getJob()) && (opJ.getNumberOfArcs() > opI.getNumberOfArcs())) {
                                        break;
                                    }

                                    Operation opK;
                                    if (opJ.getNextOperationByMachine().equals("endMachine")) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(opJ.getNextOperationByMachine());
                                    }

                                    //Test HTA
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            cont = w;
                                            Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
                                            insertions.add(newInsertion);
                                        }
                                    }

                                    if (cont != 0 && w > cont) {
                                        break;
                                    }

                                }
                            }

                            // if m performs nbjI but not pbjI. nbjI different from endByJob
                            if (machines[m].getId() == nbjI.getMachineAssigned() && !nbjI.getId().equals("endByJob_" + opI.getJob()) && pbjI.getMachineAssigned() != machines[m].getId()) {

                                int cont = 0;

                                LinkedList<String> operationsToEvaluate = new LinkedList<>();
                                operationsToEvaluate.addFirst(nbjI.getId());

                                //Determine the feasible insertions since it is a backward startegy
                                for (int w = nbjI.getOrderinMachine(); w >= 1; w--) {

                                    Operation opK = operations.get(machines[nbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));
                                    if (opK.getJob() == opI.getJob() && w < nbjI.getOrderinMachine()) {
                                        break;
                                    }

                                    Operation opJ;
                                    if (opK.getPreviewOperationByMachine().equals("start")) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(opK.getPreviewOperationByMachine());
                                    }
                                    //Test HTA
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {

                                            cont = w;
                                            operationsToEvaluate.addFirst(opJ.getId());
                                        }
                                    }
                                    //A move is unfeasible break cycle
                                    if (cont != 0 && w < cont) {
                                        break;
                                    }

                                }

                                //As soon as the operations are obtained, all are invoked
                                for (int ind = 0; ind < operationsToEvaluate.size() - 1; ind++) {

                                    Operation opJ;
                                    Operation opK;
                                    String opj = operationsToEvaluate.get(ind);
                                    if (opj.equals("start")) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(opj);
                                    }
                                    opK = operations.get(operationsToEvaluate.get(ind + 1));

                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
                                    insertions.add(newInsertion);

                                }
                            }
                            //Here finsihes nbjI reassign (line 2745)

                            // This part evaluates from the first operation 
                            if (machines[m].getId() != pbjI.getMachineAssigned() && machines[m].getId() != nbjI.getMachineAssigned()) {

                                //Control variable for escaping as soon as a move is unfeasible
                                int cont = 0;
                                for (int w = 0; w < machines[m].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ;
                                    Operation opK;

                                    if (w == 0) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(machines[m].getAssignedOperations().get(w));
                                    }
                                    if (opJ.getJob() == opI.getJob() && opJ.getNumberOfArcs() > opI.getNumberOfArcs()) {
                                        break;
                                    }
                                    if (w == machines[m].getAssignedOperations().size() - 2) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(machines[m].getAssignedOperations().get(w + 1));
                                    }

                                    //HTA test
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            cont = w;

                                            Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
                                            insertions.add(newInsertion);

                                        }
                                    }

                                    if (cont != 0 && w > cont) {
                                        break;
                                    }

                                }
                            }

                        }

                    }
                }

            }

        } else if (type.equals("type2")) {

            operationsTodiversify.add(operationsTomove2.get(((int) (Math.random() * (operationsTomove2.size() - 1 + 1) + 1)) - 1));

            for (int i = 0; i < operationsTodiversify.size(); i++) {

                //Operations related to I are invoked 
                Operation opI = operations.get(operationsTodiversify.get(i));

                Operation nbjI;
                if (opI.getNextOperationByJob().equals("endByJob_" + opI.getJob())) {
                    nbjI = exclusiveOperations.get("endByJob_" + opI.getJob());
                } else {
                    nbjI = operations.get(opI.getNextOperationByJob());
                }

                Operation pbjI;
                if (opI.getPreviewOperationByJob().equals("start")) {
                    pbjI = exclusiveOperations.get("start");
                } else {
                    pbjI = operations.get(opI.getPreviewOperationByJob());
                }
                //-----It is the resequencing process-----------//
                if (machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() > 3) {

                    //-----Forward process -----------//
                    if (opI.getOrderinMachine() >= 1 && opI.getOrderinMachine()
                            <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {

                        //Control variable for escaping if an ubfeasible move is found.
                        int cont = 0;

                        for (int pos = opI.getOrderinMachine(); pos <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3; pos++) {
                            Operation opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 1));

                            if (opJ.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opK;
                            if (pos == machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                                opK = exclusiveOperations.get("endMachine");
                            } else {
                                opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 2));
                            }

                            //The test HTA
                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    cont = pos;
                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), opI.getMachineAssigned());
                                    insertions.add(newInsertion);

                                }
                            }
                            if (cont != 0 && pos > cont) {
                                //System.out.println("----Aqui se rompio---" + opI.getId() + "---" + opJ.getId() + "---" + opK.getId());
                                break;
                            }
                        }

                    }
                    //Backward process

                    if (opI.getOrderinMachine() >= 2 && opI.getOrderinMachine() <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 2) {

                        int cont = 0;
                        for (int pos = opI.getOrderinMachine(); pos >= 2; pos--) {

                            Operation opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 1));
                            if (opK.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opJ;
                            if (pos == 2) {
                                opJ = exclusiveOperations.get("start");
                            } else {
                                opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 2));
                            }

                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    cont = pos;

                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), opI.getMachineAssigned());
                                    insertions.add(newInsertion);

                                }
                            }

                            if (cont != 0 && pos < cont) {
                                break;
                            }

                        }

                    }
                }
                //-------Finish resequencing process--------

                //---------Start reasignning process---
                for (int m = 0; m < machines.length; m++) {

                    if (machines[m].getId() != opI.getMachineAssigned() && opI.getTimesInMachine().containsKey(machines[m].getId())) {

                        //If there is at least one machine which belong to M opI. M contains Start and End Machine 
                        if (machines[m].getAssignedOperations().size() < 3) {
                            Insertion newInsertion = new Insertion(opI.getId(), "start", "endMachine", machines[m].getId());
                            insertions.add(newInsertion);
                        }

                        //If there exists any machine which belong to M opI, its sequence size is greater or equal than 3.  
                        if (machines[m].getAssignedOperations().size() >= 3) {

                            // In case M performs pbjI, pbjI different from start
                            if (machines[m].getId() == pbjI.getMachineAssigned() && !pbjI.getId().equals("start")) {
                                int cont = 0;

                                for (int w = pbjI.getOrderinMachine(); w < machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ = operations.get(machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                    if ((opJ.getJob() == opI.getJob()) && (opJ.getNumberOfArcs() > opI.getNumberOfArcs())) {
                                        break;
                                    }

                                    Operation opK;
                                    if (opJ.getNextOperationByMachine().equals("endMachine")) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(opJ.getNextOperationByMachine());
                                    }

                                    //Test HTA
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            cont = w;
                                            Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
                                            insertions.add(newInsertion);
                                        }
                                    }

                                    if (cont != 0 && w > cont) {
                                        break;
                                    }

                                }
                            }

                            // if m performs nbjI but not pbjI. nbjI different from endByJob
                            if (machines[m].getId() == nbjI.getMachineAssigned() && !nbjI.getId().equals("endByJob_" + opI.getJob()) && pbjI.getMachineAssigned() != machines[m].getId()) {

                                int cont = 0;

                                LinkedList<String> operationsToEvaluate = new LinkedList<>();
                                operationsToEvaluate.addFirst(nbjI.getId());

                                //Determine the feasible insertions since it is a backward startegy
                                for (int w = nbjI.getOrderinMachine(); w >= 1; w--) {

                                    Operation opK = operations.get(machines[nbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));
                                    if (opK.getJob() == opI.getJob() && w < nbjI.getOrderinMachine()) {
                                        break;
                                    }

                                    Operation opJ;
                                    if (opK.getPreviewOperationByMachine().equals("start")) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(opK.getPreviewOperationByMachine());
                                    }
                                    //Test HTA
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {

                                            cont = w;
                                            operationsToEvaluate.addFirst(opJ.getId());
                                        }
                                    }
                                    //A move is unfeasible break cycle
                                    if (cont != 0 && w < cont) {
                                        break;
                                    }

                                }

                                //As soon as the operations are obtained, all are invoked
                                for (int ind = 0; ind < operationsToEvaluate.size() - 1; ind++) {

                                    Operation opJ;
                                    Operation opK;
                                    String opj = operationsToEvaluate.get(ind);
                                    if (opj.equals("start")) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(opj);
                                    }
                                    opK = operations.get(operationsToEvaluate.get(ind + 1));

                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
                                    insertions.add(newInsertion);

                                }
                            }
                            //Here finsihes nbjI reassign (line 2745)

                            // This part evaluates from the first operation 
                            if (machines[m].getId() != pbjI.getMachineAssigned() && machines[m].getId() != nbjI.getMachineAssigned()) {

                                //Control variable for escaping as soon as a move is unfeasible
                                int cont = 0;
                                for (int w = 0; w < machines[m].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ;
                                    Operation opK;

                                    if (w == 0) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(machines[m].getAssignedOperations().get(w));
                                    }
                                    if (opJ.getJob() == opI.getJob() && opJ.getNumberOfArcs() > opI.getNumberOfArcs()) {
                                        break;
                                    }
                                    if (w == machines[m].getAssignedOperations().size() - 2) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(machines[m].getAssignedOperations().get(w + 1));
                                    }

                                    //HTA test
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            cont = w;

                                            Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
                                            insertions.add(newInsertion);

                                        }
                                    }

                                    if (cont != 0 && w > cont) {
                                        break;
                                    }

                                }
                            }

                        }

                    }
                }

            }

        }
    }

    //Select a random number between 1 and 3.
    static int controltwo() {
        int select = 0;

        double select1 = Math.random();

        if (select1 <= 0.500) {
            select = 1;
        } else {
            select = 3;
        }

        return select;
    }

    // Draw the points of a schedule
    static void doScatterPlot(LinkedList<Schedule> schedulesP) {

        double x[] = new double[schedulesP.size()];
        double y[] = new double[schedulesP.size()];
        double z[] = new double[schedulesP.size()];

        for (int i = 0; i < schedulesP.size(); i++) {
            x[i] = schedulesP.get(i).getCriterion1();
            y[i] = schedulesP.get(i).getCriterion2();
            z[i] = schedulesP.get(i).getCriterion3();
        }

        //PlotPanelSos scatterPlot = new PlotPanelSos("SOUTH");
        //scatterPlot.addScatterPlot("-Schedules--", x, y, z);
        JFrame frame = new JFrame("Scatter plot");
        frame.setSize(800, 600);
        //frame.setContentPane(scatterPlot);
        frame.setDefaultCloseOperation(frame.EXIT_ON_CLOSE);
        frame.setVisible(true);

    }

//-----------------------Start Non-dominated-Points-sets---------------------------------
//These methods allow to update the list of non-dominated points and delete the file 
    static void nodominatedPoints(LinkedList<Schedule> schedulesP) {
        for (int i = 0; i < schedulesP.size(); i++) {
            for (int j = i + 1; j < schedulesP.size(); j++) {
                if ((schedulesP.get(i).getCriterion1() >= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() >= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() >= schedulesP.get(j).getCriterion3())) {
                    File fileDelete = new File(schedulesP.get(i).getAddresFile());
                    fileDelete.delete();
                    schedulesP.remove(i);
                    i--;
                    break;
                }
                if ((schedulesP.get(i).getCriterion1() < schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() < schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() < schedulesP.get(j).getCriterion3())) {
                    File fileDelete = new File(schedulesP.get(j).getAddresFile());
                    fileDelete.delete();
                    schedulesP.remove(j);
                    j--;
                }

            }

        }

    }

//-----------------------Finish Non-dominated-Points-sets---------------------------------    
//-----Start Method to determine the non-dominated points, it does not include the file address         
    static void nodominatedPointsTest(LinkedList<Schedule> schedulesP) {
        for (int i = 0; i < schedulesP.size(); i++) {
            for (int j = i + 1; j < schedulesP.size(); j++) {
                if ((schedulesP.get(i).getCriterion1() >= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() >= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() >= schedulesP.get(j).getCriterion3())) {
                    schedulesP.remove(i);
                    i--;
                    break;
                }
                if ((schedulesP.get(i).getCriterion1() < schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() < schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() < schedulesP.get(j).getCriterion3())) {
                    schedulesP.remove(j);
                    j--;
                }

            }

        }

    }

    //-----End Method to determine the non-dominated points, it does not include the file address only is used for final set
    //This method is used to detemine if a list enters in a list of non-dominated points
    static boolean enterToNDP(int c1, int c2, int c3, Schedule s1, Schedule s2, Schedule s3) {
        boolean enter = false;
        //S1 does not domain the new schedule
        if (s1.getCriterion1() > c1 || s1.getCriterion2() > c2 || s1.getCriterion3() > c3) {
            // S2 does not domain the new possible schedule
            if (s2.getCriterion1() > c1 || s2.getCriterion2() > c2 || s2.getCriterion3() > c3) {
                // S3 does not domain the new possible schedule
                if (s3.getCriterion1() > c1 || s3.getCriterion2() > c2 || s3.getCriterion3() > c3) {
                    enter = true;
                }
            }
        }
        return enter;

    }

    static boolean enterToNDPTotal(int c1, int c2, int c3, LinkedList<Schedule> schedulesRef) {
        boolean enter = false;
        int win = 0;
        int lost = 0;

        for (int i = 0; i < schedulesRef.size(); i++) {
            if (schedulesRef.get(i).getCriterion1() <= c1 && schedulesRef.get(i).getCriterion2() <= c2 && schedulesRef.get(i).getCriterion3() <= c3) {
                lost++;
                break;
            }
            if ((schedulesRef.get(i).getCriterion1() > c1 && schedulesRef.get(i).getCriterion2() >= c2 && schedulesRef.get(i).getCriterion3() >= c3)
                    || (schedulesRef.get(i).getCriterion1() >= c1 && schedulesRef.get(i).getCriterion2() > c2 && schedulesRef.get(i).getCriterion3() >= c3)
                    || (schedulesRef.get(i).getCriterion1() >= c1 && schedulesRef.get(i).getCriterion2() >= c2 && schedulesRef.get(i).getCriterion3() > c3)) {
                win++;
            }

        }
        if (win >= 0 && lost == 0) {
            enter = true;
        }
        return enter;
    }

    //This method determines the weakly dominance between to sets of schedules SP and SQ
    //-----1 means SP dominates to SQ
    //-----0 means SP and SQ do not have any dominance
    //----(-1) means SQ domains to SP. 
    //----2 means beetwen them there self dominance
    static int sDomainQ(LinkedList<Schedule> schedulesP, LinkedList<Schedule> schedulesQ) {
        int domain = 0;
        boolean domain1 = false;
        boolean domain2 = false;
        //S1 to S2
        for (int i = 0; i < schedulesP.size(); i++) {
            int win = 0;
            for (int j = 0; j < schedulesQ.size(); j++) {
                if ((schedulesP.get(i).getCriterion1() < schedulesQ.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesQ.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesQ.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesQ.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() < schedulesQ.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesQ.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesQ.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesQ.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() < schedulesQ.get(j).getCriterion3())) {
                    domain1 = true;
                    break;
                }
            }
            if (domain1 == true) {
                break;
            }
        }

        //S2 to S1
        for (int i = 0; i < schedulesQ.size(); i++) {
            int win = 0;
            for (int j = 0; j < schedulesP.size(); j++) {
                if ((schedulesQ.get(i).getCriterion1() < schedulesP.get(j).getCriterion1() && schedulesQ.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesQ.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesQ.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesQ.get(i).getCriterion2() < schedulesP.get(j).getCriterion2() && schedulesQ.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesQ.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesQ.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesQ.get(i).getCriterion3() < schedulesP.get(j).getCriterion3())) {
                    domain2 = true;
                    break;
                }
            }
            if (domain2 == true) {
                break;
            }
        }
        if (domain1 == true && domain2 == false) {
            domain = 1;
        } else if (domain1 == true && domain2 == true) {
            domain = 2;
        } else if (domain1 == false && domain2 == false) {
            domain = 0;
        } else if (domain1 == false && domain2 == true) {
            domain = -1;
        }

        return domain;
    }

    //-------------New methods for solving the quality of the estimation function----------
    //This method transforms the graph from the current to j-k
    static void createSolutionForward(String opi, String opj, String opk, String ops, String opt, int mach) {

        Operation opI = operations.get(opi);
        Operation opJ;
        Operation opK;
        Operation opS;
        Operation opT;

        if (opj.equals("start")) {
            opJ = exclusiveOperations.get("start");
        } else {
            opJ = operations.get(opj);;
        }
        if (opk.equals("endMachine")) {
            opK = exclusiveOperations.get("endMachine");
        } else {
            opK = operations.get(opk);
        }

        if (ops.equals("start")) {
            opS = exclusiveOperations.get("start");
        } else {
            opS = operations.get(opI.getPreviewOperationByMachine());
        }
        if (opt.equals("endMachine")) {
            opT = exclusiveOperations.get("endMachine");
        } else {
            opT = operations.get(opI.getNextOperationByMachine());
        }

        opI.setNextOperationByMachine(opK.getId());
        opI.setPreviewOperationByMachine(opJ.getId());
        opI.setMachineAssigned(mach);
        opI.setTimeMachine(opI.getTimesInMachine().get(opI.getMachineAssigned()));
        operations.put(opI.getId(), opI);
        if (!opJ.getId().equals("start")) {
            opJ.setNextOperationByMachine(opI.getId());
            operations.put(opJ.getId(), opJ);
        }
        if (!opK.getId().equals("endMachine")) {
            opK.setPreviewOperationByMachine(opI.getId());
            operations.put(opK.getId(), opK);
        }
        if (!opS.getId().equals("start")) {
            opS.setNextOperationByMachine(opT.getId());
            operations.put(opS.getId(), opS);
        }
        if (!opT.getId().equals("endMachine")) {
            opT.setPreviewOperationByMachine(opS.getId());
            operations.put(opT.getId(), opT);
        }

    }

    static void deleteStructureTemporal(String type) {
        //Delete the assigned operations to the machines and add Start
        deleteAndIntStartinMachines();
        //Delete Bellman
        bellmanOrder.clear();
        //Set start time, completion time.
        updateOperations();
        //Add *(end Machine)
        addendMachine();
        if (type.equals("type1")) {
            operationsTomove1.clear();
        } else {
            operationsTomove2.clear();
        }
    }

    public static LinkedList<LinkedList<String>> getBellmanOrder() {
        return bellmanOrder;
    }

    public static void setBellmanOrder(LinkedList<LinkedList<String>> bellmanOrder) {
        FJSProyect.bellmanOrder = bellmanOrder;
    }

    public static int[] getOrderOfJobs() {
        return orderOfJobs;
    }

    public static void setOrderOfJobs(int[] orderOfJobs) {
        FJSProyect.orderOfJobs = orderOfJobs;
    }

    public static int getMaxOperationPerJob() {
        return maxOperationPerJob;
    }

    public static void setMaxOperationPerJob(int maxOperationPerJob) {
        FJSProyect.maxOperationPerJob = maxOperationPerJob;
    }

}//Close the main class la clase principal 

