/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fjsproyect;

import java.util.HashMap;
import java.util.Map;
import java.io.*;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;

import java.util.Date;
import javax.swing.JOptionPane;
//C:\Users\Andres_Garcia\Desktop\solinicial

/**
 *
 * @author Andres_Garcia
 */
public class FJSProyect {

    //The set of jobs
    static HashMap<Integer, Job> jobs;
    //This the set of the operations for jobs
    static HashMap<String, Operation> operations;
    //This set contains the dummy phi-nodes, start and *
    static HashMap<String, Operation> exclusiveOperations;

    static int totalJobs;
    static Machine[] machines;
    //Operations to evaluate the moves for the neighborhood N1. 
    static LinkedList<String> operationsTomove1;
    //Operations to evaluate the moves for the neighborhood N2.
    static LinkedList<String> operationsTomove2;
    //Operations to evaluate for the neighborhood N1-N2

    static int criterionValue;
    //This is the value of the makespan
    static int criterionMk;
    //This is the value for the maximmum tardiness
    static int criterionTmax;
    //This is the value of Total flow time
    static int criterionTFT;
    //This is the value for Total weighted flow time
    static int criterionTWFT;
    //This is the value for the total weighted tardiness
    static int criterionTWT;
    //This is the value for the total weighted tardy jobs
    static int criterionTWU;
    //This set represent the feasible insertions which estimatiion is less tahn the current one.
    static int case3;

    static int[] orderOfJobs;
    static int maxOperationPerJob;

    static LinkedList<Insertion> insertions;
    static LinkedList<Insertion> insertionsReal;

    static LinkedList<LinkedList<String>> bellmanOrder;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here

        //Ask for a folder to read according to the Hurink format. 
        String folder = JOptionPane.showInputDialog("write the address of the folder to read");
        String chosenCriterion = JOptionPane.showInputDialog("write the criterion makespan, tmax, tc, twt");
        File directorio = new File(folder);
        String[] listaDirectorio = directorio.list();
        if (listaDirectorio == null) {
            System.out.println("There are not files in the folder to read");
        } else {
            for (int xyz = 0; xyz < listaDirectorio.length; xyz++) {
                File finalResults = new File(folder + File.separator + "(" + listaDirectorio[xyz] + "-" + chosenCriterion + ")");
                finalResults.mkdir();
                //System.out.println("--Instance--" + listaDirectorio[xyz]);
                for (int neigh = 1; neigh <= 2; neigh++) {

                    int totalMachines = 0;
                    float flexibility = 0;
                    int maximumNumberOperation;
                    int totalOperationPerMachine;
                    double averageTimeOperation;
                    double averageTimeJob;
                    double sumOperation;
                    double sumJob;

                    //Vectors for definning the order of jobs for initial solution
                    int[] orderOfJobs;
                    int[] duedateVector;
                    double[] averageTimeVector;
                    int[] weigthvector;
                    int[] numbOperationVector;

                    int maxOperationPerJob;
                    String criterion1;
                    String criterion2;
                    String criterion3;
                    String criterion4;
                    String criterion5;
                    String criterion6;
                    String type;
                    int control;

                    Machine[] machines = null;

                    HashMap<String, Operation> exclusiveOperations = new HashMap<>();
                    HashMap<String, Operation> operations = new HashMap<>();
                    HashMap<String, Operation> operationsToMove2 = new HashMap<>();
                    HashMap<String, Operation> operationsToMove3 = new HashMap<>();
                    HashMap<Integer, Job> jobs = new HashMap<>();
                    LinkedList<String> operationsTomove1 = new LinkedList<>();
                    LinkedList<String> operationsTomove2 = new LinkedList<>();
                    LinkedList<String> operationsTomove3 = new LinkedList<>();
                    LinkedList<Insertion> tabuList = new LinkedList<>();
                    LinkedList<Insertion> insertions = new LinkedList<>();
                    LinkedList<Insertion> insertionsReal = new LinkedList<>();
                    LinkedList<Schedule> schedules = new LinkedList<>();
                    LinkedList<Schedule> schedules2 = new LinkedList<>();
                    LinkedList<Schedule> schedules3 = new LinkedList<>();
                    LinkedList<Schedule> schedulesFinal = new LinkedList<>();
                    LinkedList<LinkedList<String>> bellmanOrder = new LinkedList<>();

                    //----------------
                    try {
                        FileReader r = new FileReader(folder + File.separator + listaDirectorio[xyz]);
                        BufferedReader buffer = new BufferedReader(r);
                        String firstInformation = buffer.readLine();
                        //The line is divided to form an array
                        String[] arrayFirstInformation = firstInformation.split(" ");
                        // With the array, it is possible to obtain the variables. 
                        totalJobs = Integer.parseInt(arrayFirstInformation[0]);
                        totalMachines = Integer.parseInt(arrayFirstInformation[1]);
                        //Start represents the node 0. 
                        Operation start = new Operation();
                        start.setId("start");
                        exclusiveOperations.put(start.getId(), start);
                        machines = new Machine[totalMachines];
                        for (int i = 0; i < totalMachines; i++) {
                            Machine newMachine = new Machine();
                            newMachine.setId(i + 1);
                            newMachine.addNewOperation("start");
                            machines[i] = newMachine;
                        }

                        flexibility = Float.parseFloat(arrayFirstInformation[2]);
                        // Node endMachine represents the node *

                        Operation endMachine = new Operation();
                        endMachine.setId("endMachine");
                        exclusiveOperations.put(endMachine.getId(), endMachine);
                        //Due-date vector saves increasing order of jobs according to its due date
                        duedateVector = new int[totalJobs];
                        // average time vector increasing order
                        averageTimeVector = new double[totalJobs];
                        // w vector decreasing order
                        weigthvector = new int[totalJobs];
                        maxOperationPerJob = 0;
                        numbOperationVector = new int[totalJobs];
                        //This cicle creates the w-values for the jobs according to Singer & Pinedo's approach
                        for (int i = 0; i < totalJobs; i++) {
                            sumJob = 0;
                            Job newJob = new Job();
                            newJob.setId(i + 1);
                            if (i < 0.2 * totalJobs) {
                                newJob.setWeigthValue(1);
                                weigthvector[i] = newJob.getWeigthValue();
                            }
                            if (i >= 0.2 * totalJobs && i < 0.8 * totalJobs) {
                                newJob.setWeigthValue(1);
                                weigthvector[i] = newJob.getWeigthValue();
                            }
                            if (i >= 0.8 * totalJobs) {
                                weigthvector[i] = 1;
                            }

                            String jobInformation = buffer.readLine().trim();
                            String[] arrayJobInformation;
                            int position = 0;
                            arrayJobInformation = jobInformation.split(" ");
                            int operationPerJob = Integer.parseInt(arrayJobInformation[position]);
                            numbOperationVector[i] = operationPerJob;
                            newJob.setNumberOfOperations(operationPerJob);
                            if (operationPerJob > maxOperationPerJob) {
                                maxOperationPerJob = operationPerJob;
                            }

                            endMachine.addTail((i + 1), Operation.MINIMUN_TAIL);

                            Operation endByJob = new Operation();
                            endByJob.setTimeMachine(0);
                            endByJob.setId("endByJob_" + (i + 1));

                            for (int j = 0; j < totalJobs; j++) {

                                endByJob.addTail(j + 1, Operation.MINIMUN_TAIL);
                            }
                            endByJob.addTail(i + 1, 0);
                            endByJob.setTailMax(0);
                            exclusiveOperations.put(endByJob.getId(), endByJob);

                            for (int j = 0; j < operationPerJob; j++) {
                                Operation newOperation = new Operation();
                                newOperation.setId(newJob.getId() + "-" + (j + 1));
                                newOperation.setJob(i + 1);
                                if (j == 0) {
                                    newOperation.setPreviewOperationByJob("start");
                                    newOperation.setNextOperationByJob(newJob.getId() + "-" + (j + 2));
                                } else if (j > 0 && j < operationPerJob - 1) {
                                    newOperation.setPreviewOperationByJob(newJob.getId() + "-" + (j));
                                    newOperation.setNextOperationByJob(newJob.getId() + "-" + (j + 2));
                                } else if (j == (operationPerJob - 1)) {
                                    newOperation.setPreviewOperationByJob(newJob.getId() + "-" + (j));
                                    newOperation.setNextOperationByJob("endByJob_" + (i + 1));
                                }
                                position++;
                                int availibleMachines = Integer.parseInt(arrayJobInformation[position]);

                                sumOperation = 0;
                                for (int k = 0; k < availibleMachines; k++) {
                                    position++;
                                    int machine = Integer.parseInt(arrayJobInformation[position]);
                                    position++;
                                    int timeMachine = Integer.parseInt(arrayJobInformation[position]);
                                    sumOperation = sumOperation + timeMachine;
                                    newOperation.addOptionMachine(machine, timeMachine);
                                }
                                sumJob += (sumOperation / availibleMachines);

                                newJob.addOperations(newOperation.getId());
                                operations.put(newOperation.getId(), newOperation);
                            }
                            newJob.setAverageTime(sumJob);
                            averageTimeVector[i] = (double) (newJob.getAverageTime());
                            newJob.setDueDate((int) Math.rint(newJob.getAverageTime() * 1.3));
                            duedateVector[i] = newJob.getDueDate();
                            jobs.put(newJob.getId(), newJob);

                        }

                        //-------The arrange of jobs for w-criteria 
                        //-------w value, due-date.-------
                        orderOfJobs = new int[totalJobs];

                        for (int i = 0; i < totalJobs; i++) {
                            int auxiliar = i;
                            for (int j = 0; j < totalJobs; j++) {
                                if (weigthvector[auxiliar] < weigthvector[j]) {
                                    auxiliar = j;
                                } else if (weigthvector[auxiliar] == weigthvector[j] && duedateVector[auxiliar] < duedateVector[j]) {
                                    auxiliar = j;
                                }
                            }
                            orderOfJobs[i] = auxiliar + 1;
                            weigthvector[auxiliar] = 0;
                            duedateVector[auxiliar] = 0;

                        }
                        //To do. Create Alvaro's solutions
                        setOrderOfJobs(orderOfJobs);
                        setMaxOperationPerJob(maxOperationPerJob);
                        //----Initial solution-------
                        //----PerJob-----PerOperation
                        for (int i = 0; i < maxOperationPerJob; i++) {
                            for (int j = 0; j < totalJobs; j++) {
                                Job tmp = jobs.get(orderOfJobs[j]);
                                if (i < tmp.getJobOperations().size()) {

                                    //Invoke the operation on the lecture arrangement  
                                    String p = jobs.get(orderOfJobs[j]).getJobOperations().get(i);
                                    Operation op = operations.get(p);

                                    //Invoke the preview operation by job
                                    String pbj = op.getPreviewOperationByJob();
                                    Operation pj;
                                    if (pbj.equals("start")) {
                                        pj = exclusiveOperations.get("start");
                                    } else {
                                        pj = operations.get(pbj);
                                    }
                                    int begin = pj.getCompletionTime();
                                    int fin = 10000000;
                                    int assignedMachine = 0;

                                    for (int k = 1; k <= totalMachines; k++) {
                                        if (op.getTimesInMachine().containsKey(k)) {
                                            int fin2 = Math.max(begin + op.findTimeInMachine(k), machines[k - 1].getTimeClock() + op.findTimeInMachine(k));

                                            if (fin2 < fin) {
                                                fin = fin2;
                                                assignedMachine = k;
                                            }

                                        }
                                    }
                                    String pbm = machines[assignedMachine - 1].getAssignedOperations().getLast();
                                    Operation pm;
                                    op.setPreviewOperationByMachine(pbm);
                                    if (pbm.equals("start")) {
                                        pm = exclusiveOperations.get("start");
                                    } else {
                                        pm = operations.get(pbm);
                                        pm.setNextOperationByMachine(op.getId());
                                        op.setPreviewOperationByMachine(pm.getId());
                                        operations.put(pm.getId(), pm);
                                    }

                                    op.setMachineAssigned(assignedMachine);
                                    op.setCompletionTime(fin);
                                    op.setStartTime(fin - op.timeInMachine(assignedMachine));
                                    op.setTimeMachine(op.timeInMachine(assignedMachine));
                                    operations.put(op.getId(), op);

                                    machines[assignedMachine - 1].setTimeClock(fin);
                                    machines[assignedMachine - 1].addNewOperation(op.getId());
                                }

                            }

                        }

                    } catch (IOException e) {
                        System.out.println(e.getMessage());

                    }

                    // Here the attributes of the main class are invoked by means setters.
                    setOperations(operations);
                    setJobs(jobs);
                    setExclusiveOperations(exclusiveOperations);
                    setMachines(machines);
                    setOperationsTomove1(operationsTomove1);
                    setOperationsTomove2(operationsTomove2);
                    setBellmanOrder(bellmanOrder);
                    setInsertions(insertions);

                    setInsertionsReal(insertionsReal);
                    setCase3(0);
//------------------------Application: Type of moves  --------------------- 
                    LinkedList<Integer> order = new LinkedList<>();
                    //criterion1 = "makespan";
                    //criterion1 = "twu";
                    //criterion1 = "tmax";
                    criterion1 = chosenCriterion;
                    //criterion1 = "twt";
                    //type variable represents the neighborhood structure 

                    //type1---> represents N1
                    //type2---> represents N2
                    type = "type1";
                    if (neigh
                            == 2) {
                        type = "type2";
                    }

                    deleteStructureandUpdateDate(type);
                    order = new LinkedList<>(updateJobsandExclusive(criterion1));
                    int iterations = 1000000000;
                    //The search start in step 1
                    int step = 1;
                    int real = 0;
                    int bestLocal = -Operation.MINIMUN_TAIL;
                    int bestGlobal = -Operation.MINIMUN_TAIL;
                    int localOptimal = -Operation.MINIMUN_TAIL;
                    int criterionValue = getCriterionValue();
                    //if (type.equals("type1")) {
                      //  System.out.println("-Makespan at the beginning is " + criterionValue);
                    //}

                    //operationTails(order, type);
                    //Start time
                    long a = System.currentTimeMillis();
                    int veces = 0;
                    int italc = 0;
                    //-------Starts the local search process-------------//
                    for (int it = 1; it <= iterations; it++) {
                        if (step == 1) {
                            //Update the assignment-update the solution (start time and completion times)-delete the neighborhood
                            if (!order.isEmpty()) {
                                operationTails(order, type);
                                feasibleInsertionsYazid(type, criterionValue, criterion1, order);
                                if (!insertions.isEmpty()) {
                                    order = new LinkedList<>(updateJobsandExclusive(criterion1));
                                    criterionValue = getCriterionValue();
                                    if (criterionValue < localOptimal) {
                                        localOptimal = criterionValue;
                                        if (criterionValue < bestGlobal) {
                                            bestGlobal = criterionValue;
                                        }
                                    }
                                    insertions.clear();
                                    if (type.equals("type1")) {
                                        operationsTomove1.clear();
                                    } else {
                                        operationsTomove2.clear();
                                    }

                                } else {

                                    if (type.equals("type1")) {
                                        operationsTomove1.clear();
                                    } else {
                                        operationsTomove2.clear();
                                    }
                                    order = new LinkedList<>(updateJobsandExclusive(criterion1));
                                    operationTails(order, type);
                                    step = 2;
                                }
                            }
                        }
                        if (step == 2) {
                            veces++;
                            int up = 6;
                            int from = 2;
                            int d = (int) (Math.random() * (up - from + 1) + from);
                            for (int div = 1; div <= d; div++) {
                                it++;
                                feasibleInsertionsYazid1(type, criterionValue, criterion1, order);
                                order = new LinkedList<>(updateJobsandExclusive(criterion1));
                                criterionValue = getCriterionValue();
                                if (criterionValue < localOptimal) {
                                    localOptimal = criterionValue;
                                    if (criterionValue < bestGlobal) {
                                        bestGlobal = criterionValue;
                                    }
                                    if (type.equals("type1")) {
                                        operationsTomove1.clear();
                                    } else {
                                        operationsTomove2.clear();
                                    }
                                    step = 1;
                                    break;
                                } else {
                                    if (div == d) {
                                        if (type.equals("type1")) {
                                            operationsTomove1.clear();
                                        } else {
                                            operationsTomove2.clear();
                                        }
                                        localOptimal = -Operation.MINIMUN_TAIL;
                                        step = 1;
                                    } else {
                                        if (type.equals("type1")) {
                                            operationsTomove1.clear();
                                        } else {
                                            operationsTomove2.clear();
                                        }
                                        operationTails(order, type);
                                    }
                                }

                            }

                        }
                        italc = it;
                        long b = System.currentTimeMillis();
                        //If the current time is more than 300 seconds break. 
                        if (b - a > /*7200000*/300) {
                            break;
                        }

                    }
                    createFichier(finalResults+ File.separator + "N" + neigh + ".txt", listaDirectorio[xyz], italc, bestGlobal, veces, getCase3());
                   
                }// end of the Neighborhood     
            }// end of the file
        }//If the folder is empty
    } //End of the main method

    public static void createFichier(String fileName, String instance, int number, int bestGlobal, int veces, int case3) {
        File f = new File(fileName);

        try {
            FileWriter w = new FileWriter(f);
            BufferedWriter bw = new BufferedWriter(w);
            PrintWriter wr = new PrintWriter(bw);
            wr.append("--Instance-" + instance);
            wr.write("-------------- \n");
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("-Makespan-at the end of " + number + "-Iterations-is---" + bestGlobal);
            wr.write("-------------- \n");
            wr.append(" \n");
            wr.append("-The number of times the search diversifies--" + veces);
            wr.write("---------------- \n");
            wr.append(" \n");
            wr.append("-The number of times case C--" + case3);
            wr.close();
            bw.close();
        } catch (IOException e) {
        };
    }

    public static void createFile(String fileName, String instance, double htaImpRS, double tailPhiImpRS, double lostImpRS,
            double htaNonImpRS, double tailPhiNonImpRS, double lostNonImpRS,
            double htaImpRAG, double tailPhiImpRAG, double lostImpRAG,
            double htaNonImpRAG, double tailPhiNonImpRAG, double lostNonImpRAG
    ) {
        File f = new File(fileName);

        try {
            FileWriter w = new FileWriter(f);
            BufferedWriter bw = new BufferedWriter(w);
            PrintWriter wr = new PrintWriter(bw);
            wr.write("-----Fesibility conditions------ \n");
            wr.append("\n");
            wr.append("--Instance-" + " --- " + instance);
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("--Improving moves Resequencing-");
            wr.write("------------------ \n");
            wr.append(" \n");
            wr.append(" Pecentage of Improving moves RSQ ");
            wr.append(" \n");
            wr.append(" HTA Conditions  " + htaImpRS);
            wr.append(" \n");
            wr.append(" Tail-Phi Conditions " + tailPhiImpRS);
            wr.append(" \n");
            wr.append(" Lost moves  " + lostImpRS);
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("--Non improving moves Resequencing-");
            wr.write("------------------ \n");
            wr.append(" \n");
            wr.append(" HTA Conditions  " + htaNonImpRS);
            wr.append(" \n");
            wr.append(" Tail-Phi Conditions " + tailPhiNonImpRS);
            wr.append(" \n");
            wr.append(" Lost moves  " + lostNonImpRS);
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("--Improving moves Reassignment-");
            wr.write("------------------ \n");
            wr.append(" \n");
            wr.append(" HTA Conditions  " + htaImpRAG);
            wr.append(" \n");
            wr.append(" Tail-Phi Conditions " + tailPhiImpRAG);
            wr.append(" \n");
            wr.append(" Lost moves  " + lostImpRAG);
            wr.append(" \n");
            wr.write("------------------ \n");
            wr.append("--Non improving moves Reassignment-");
            wr.write("------------------ \n");
            wr.append(" HTA Conditions  " + htaNonImpRAG);
            wr.append(" \n");
            wr.append(" \n");
            wr.append(" Tail-Phi Conditions " + tailPhiNonImpRAG);
            wr.append(" \n");
            wr.append(" Lost moves  " + lostNonImpRAG);
            wr.append(" \n");
            wr.close();
            bw.close();
        } catch (IOException e) {
        };

    }

    public static HashMap<String, Operation> getOperations() {
        return operations;
    }

    public static void setOperations(HashMap<String, Operation> operations) {
        FJSProyect.operations = operations;
    }

    static void setUnavailableOperation() {
        Set<String> s = operations.keySet();
        Iterator<String> ik = s.iterator();
        while (ik.hasNext()) {
            Operation op = operations.get(ik.next());
            op.setStatus(0);
            operations.put(op.getId(), op);

        }
    }

    public static HashMap<Integer, Job> getJobs() {
        return jobs;
    }

    public static void setJobs(HashMap<Integer, Job> jobs) {
        FJSProyect.jobs = jobs;
    }

    public static HashMap<String, Operation> getExclusiveOperations() {
        return exclusiveOperations;
    }

    public static void setExclusiveOperations(HashMap<String, Operation> exclusiveOperations) {
        FJSProyect.exclusiveOperations = exclusiveOperations;
    }

    public static Machine[] getMachines() {
        return machines;
    }

    public static void setMachines(Machine[] machines) {
        FJSProyect.machines = machines;
    }

    public static int getCriterionValue() {
        return criterionValue;
    }

    public static void setCriterionValue(int criterionValue) {
        FJSProyect.criterionValue = criterionValue;
    }

    public static int getCriterionMk() {
        return criterionMk;
    }

    public static void setCriterionMk(int criterionMk) {
        FJSProyect.criterionMk = criterionMk;
    }

    public static int getCriterionTmax() {
        return criterionTmax;
    }

    public static void setCriterionTmax(int criterionTmax) {
        FJSProyect.criterionTmax = criterionTmax;
    }

    public static int getCriterionTFT() {
        return criterionTFT;
    }

    public static void setCriterionTFT(int criterionTFT) {
        FJSProyect.criterionTFT = criterionTFT;
    }

    public static int getCriterionTWFT() {
        return criterionTWFT;
    }

    public static void setCriterionTWFT(int criterionTWFT) {
        FJSProyect.criterionTWFT = criterionTWFT;
    }

    public static int getCriterionTWT() {
        return criterionTWT;
    }

    public static void setCriterionTWT(int criterionTWT) {
        FJSProyect.criterionTWT = criterionTWT;
    }

    public static int getCriterionTWU() {
        return criterionTWU;
    }

    public static void setCriterionTWU(int criterionTWU) {
        FJSProyect.criterionTWU = criterionTWU;
    }

    public static LinkedList<String> getOperationsTomove1() {
        return operationsTomove1;
    }

    public static void setOperationsTomove1(LinkedList<String> operationsTomove1) {
        FJSProyect.operationsTomove1 = operationsTomove1;
    }

    public static LinkedList<String> getOperationsTomove2() {
        return operationsTomove2;
    }

    public static void setOperationsTomove2(LinkedList<String> operationsTomove2) {
        FJSProyect.operationsTomove2 = operationsTomove2;
    }

    public static LinkedList<Insertion> getInsertions() {
        return insertions;
    }

    public static void setInsertions(LinkedList<Insertion> insertions) {
        FJSProyect.insertions = insertions;
    }

    public static LinkedList<Insertion> getInsertionsReal() {
        return insertionsReal;
    }

    public static void setInsertionsReal(LinkedList<Insertion> insertionsReal) {
        FJSProyect.insertionsReal = insertionsReal;
    }

    static void updateOperations() {

        setUnavailableOperation();
        LinkedList<String> pending = new LinkedList<String>();
        LinkedList<String> pendingAux = new LinkedList<String>();

        TreeMap<String, Operation> updating = new TreeMap<String, Operation>(operations);

        for (Map.Entry<String, Operation> node : updating.entrySet()) {
            Operation op = node.getValue();
            pending = updateOperation(op, pending);
        }

        do {
            pendingAux.clear();

            for (int i = 0; i < pending.size(); i++) {
                pendingAux = updateOperation(operations.get(pending.get(i)), pendingAux);
            }
            pending = new LinkedList<String>(pendingAux);

        } while (pending.size() != 0);

    }

    static void deleteAndIntStartinMachines() {
        // Clear all assigned operations to the machines and the record for the file
        // As soon all operations are deleted start is added.
        for (int m = 0; m < machines.length; m++) {
            machines[m].getAssignedOperations().clear();
            machines[m].getAssignRecord().clear();
            machines[m].addNewOperation("start");
        }

    }

    static void addendMachine() {
        //Add * to the list to the operations to the machines
        for (int m = 0; m < machines.length; m++) {
            String last = machines[m].getAssignedOperations().getLast();

            if (last.equals("start")) {
                machines[m].addNewOperation("endMachine");
            } else {
                Operation op = operations.get(last);
                op.setNextOperationByMachine("endMachine");
                operations.put(last, op);
                machines[m].addNewOperation("endMachine");
            }

        }
    }

    static LinkedList<String> updateOperation(Operation op, LinkedList<String> pending) {

        if (op.getStatus() == 0) {

            if (op.getPreviewOperationByJob().equals("start") && op.getPreviewOperationByMachine().equals("start")) {

                op.setStartTime(0);
                op.setCompletionTime(op.getTimeMachine());
                op.setStatus(1);
                op.setNumberOfArcs(1);
                if (bellmanOrder.size() == 0) {
                    LinkedList<String> order = new LinkedList<String>();
                    order.add(op.getId());
                    bellmanOrder.add(order);
                } else {
                    bellmanOrder.getFirst().add(op.getId());
                }
                op.setOrderinMachine(machines[op.getMachineAssigned() - 1].getAssignedOperations().size());
                machines[op.getMachineAssigned() - 1].addNewOperation(op.getId());
                machines[op.getMachineAssigned() - 1].addRecord(op.getId() + "(" + op.getStartTime() + "," + op.getCompletionTime() + ")");

            } else if (op.getPreviewOperationByJob().equals("start") && !op.getPreviewOperationByMachine().equals("start")) {

                Operation pM = operations.get(op.getPreviewOperationByMachine());
                if (pM.getStatus() == 1) {
                    op.setStartTime(pM.getCompletionTime());
                    op.setCompletionTime(pM.getCompletionTime() + op.getTimeMachine());
                    op.setStatus(1);
                    op.setNumberOfArcs(pM.getNumberOfArcs() + 1);
                    if (bellmanOrder.size() == pM.getNumberOfArcs()) {
                        LinkedList<String> order = new LinkedList<String>();
                        order.add(op.getId());
                        bellmanOrder.add(order);
                    } else {
                        bellmanOrder.get(pM.getNumberOfArcs()).add(op.getId());
                    }
                    op.setOrderinMachine(machines[op.getMachineAssigned() - 1].getAssignedOperations().size());
                    machines[op.getMachineAssigned() - 1].addNewOperation(op.getId());
                    machines[op.getMachineAssigned() - 1].addRecord(op.getId() + "(" + op.getStartTime() + "," + op.getCompletionTime() + ")");
                } else {
                    pending.add(op.getId());
                }
            } else if (!op.getPreviewOperationByJob().equals("start") && op.getPreviewOperationByMachine().equals("start")) {

                Operation pJ = operations.get(op.getPreviewOperationByJob());
                if (pJ.getStatus() == 1) {
                    op.setStartTime(pJ.getCompletionTime());
                    op.setCompletionTime(pJ.getCompletionTime() + op.getTimeMachine());
                    op.setStatus(1);
                    op.setNumberOfArcs(pJ.getNumberOfArcs() + 1);

                    if (bellmanOrder.size() == pJ.getNumberOfArcs()) {
                        LinkedList<String> order = new LinkedList<String>();
                        order.add(op.getId());
                        bellmanOrder.add(order);
                    } else {
                        bellmanOrder.get(pJ.getNumberOfArcs()).add(op.getId());
                    }

                    op.setOrderinMachine(machines[op.getMachineAssigned() - 1].getAssignedOperations().size());
                    machines[op.getMachineAssigned() - 1].addNewOperation(op.getId());
                    machines[op.getMachineAssigned() - 1].addRecord(op.getId() + "(" + op.getStartTime() + "," + op.getCompletionTime() + ")");
                } else {
                    pending.add(op.getId());
                }

            } else {
                Operation oJ = operations.get(op.getPreviewOperationByJob());
                Operation oM = operations.get(op.getPreviewOperationByMachine());

                if (oJ.getStatus() == 1 && oM.getStatus() == 1) {

                    op.setStartTime(Math.max(oJ.getCompletionTime(), oM.getCompletionTime()));
                    op.setCompletionTime(op.getStartTime() + op.getTimeMachine());
                    op.setStatus(1);
                    op.setNumberOfArcs(Math.max(oJ.getNumberOfArcs(), oM.getNumberOfArcs()) + 1);
                    if (bellmanOrder.size() == Math.max(oJ.getNumberOfArcs(), oM.getNumberOfArcs())) {
                        LinkedList<String> order = new LinkedList<String>();
                        order.add(op.getId());
                        bellmanOrder.add(order);
                    } else {
                        bellmanOrder.get(Math.max(oJ.getNumberOfArcs(), oM.getNumberOfArcs())).add(op.getId());
                    }

                    op.setOrderinMachine(machines[op.getMachineAssigned() - 1].getAssignedOperations().size());
                    machines[op.getMachineAssigned() - 1].addNewOperation(op.getId());
                    machines[op.getMachineAssigned() - 1].addRecord(op.getId() + "(" + op.getStartTime() + "," + op.getCompletionTime() + ")");
                } else {
                    pending.add(op.getId());
                }
            }

            operations.put(op.getId(), op);
        }

        return pending;

    }

    static void readerOperations() {
        Set<String> s = operations.keySet();
        Iterator<String> ik = s.iterator();
        while (ik.hasNext()) {
            Operation op = operations.get(ik.next());
            System.out.println(" Operation " + op.getId());
            System.out.println(" Tail max---" + op.getTailMax() + "---Arcs---" + op.getNumberOfArcs());
            System.out.println(" Machine " + op.getMachineAssigned() + " Order " + op.getOrderinMachine());
            System.out.println(" Start Time " + op.getStartTime() + " Completion Time " + op.getCompletionTime());
            System.out.println(" Next operation by machine  " + op.getNextOperationByMachine() + " Preview by machine " + op.getPreviewOperationByMachine());
            //System.out.println("Next by Job--" + op.getNextOperationByJob() + "-----Preview by Job----" + op.getPreviewOperationByJob());
            System.out.println("-----Tails and critical----------");
            for (int i = 1; i <= totalJobs; i++) {
                System.out.println("To Job---" + i + "---The tail is--- " + op.getJobsTails().get(i) + " -----Is crtical ?---" + op.getCriticalToJob().get(i));
            }
            //for (int i = 0; i < op.getSuccesors().size(); i++) {
            //  System.out.println("Succesor--" + (i + 1) + "--" + op.getSuccesors().get(i));
            //}
            System.out.println("-------Fin--------");
        }

    }

    static void readerExclusiveOperations() {
        Set<String> s = exclusiveOperations.keySet();
        Iterator<String> ik = s.iterator();
        while (ik.hasNext()) {
            Operation op = exclusiveOperations.get(ik.next());
            System.out.println(" Operation " + op.getId());
            System.out.println(" Tail max " + op.getTailMax());
            System.out.println(" Start Time " + op.getStartTime() + " Arcs " + op.getNumberOfArcs());
            System.out.println("-----Tails----------");
            for (int i = 1; i <= totalJobs; i++) {
                System.out.println(op.findJobsTail(i));
            }
            System.out.println("-------Fin--------");
        }

    }

    static void updateJobTails(LinkedList<Integer> order, String type) {

        setUnavailableOperation();
        LinkedList<String> pending = new LinkedList<String>();
        LinkedList<String> pendingAux = new LinkedList<String>();
        LinkedList<Integer> orderJobs = new LinkedList<>(order);
        String structure;
        structure = type;

        for (Map.Entry<String, Operation> node : operations.entrySet()) {
            Operation op = node.getValue();
            pending = updateTailToOperation(op, pending, orderJobs, structure);
        }

        do {
            pendingAux.clear();

            for (int i = 0; i < pending.size(); i++) {
                pendingAux = updateTailToOperation(operations.get(pending.get(i)), pendingAux, orderJobs, structure);
            }
            pending = new LinkedList<String>(pendingAux);

        } while (pending.size() != 0);
    }

    static LinkedList<String> updateTailToOperation(Operation op, LinkedList<String> pending, LinkedList<Integer> orderJobs, String structure) {

        //Op es la operacion actual, en donde se esta situado
        if (op.getStatus() == 0) {

            /*Se pregunta si es el ultimo nodo del trabajo y de la maquina
             * Las carga todas con -Infinito y al trabajo al que pertenezca la operacion asigna un 0
             */
            if (op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && op.getNextOperationByMachine().equals("endMachine")) {

                if (structure.equals("type1")) {
                    if (orderJobs.contains(op.getJob())) {
                        operationsTomove1.addFirst(op.getId());
                    }
                }

                if (structure.equals("type2")) {
                    Operation pbM;
                    if (op.getOrderinMachine() == 1) {
                        pbM = exclusiveOperations.get("start");
                    } else {
                        pbM = operations.get(op.getPreviewOperationByMachine());
                    }

                    if (!pbM.getId().equals("start") && orderJobs.contains(op.getJob()) && pbM.getCompletionTime() == op.getStartTime() && op.getJob() != pbM.getJob()) {
                        operationsTomove2.addFirst(op.getId());
                    }
                }

                if (structure.equals("type3")) {
                    Operation pbM;

                    if (op.getOrderinMachine() == 1) {
                        pbM = exclusiveOperations.get("start");
                    } else {
                        pbM = operations.get(op.getPreviewOperationByMachine());
                    }
                    if (!pbM.getId().equals("start") && orderJobs.contains(op.getJob()) && pbM.getCompletionTime() == op.getStartTime() && op.getJob() != pbM.getJob()) {
                        operationsTomove2.addFirst(op.getId());
                    }

                }
                op.clearSuccesors();
                op.addsuccesor("endByJob_" + op.getJob());

                for (int job = 1; job <= jobs.size(); job++) {
                    op.addTail(job, Operation.MINIMUN_TAIL);
                    op.notCriticalToJob(job);
                    if (job == op.getJob()) {
                        op.addTail(op.getJob(), 0);
                        op.criticalToJob(op.getJob());
                    }
                }
                op.setStatus(1);
                op.setTailMax(0);
            } //Ultimo en operacion por trabajo, No ultimo en operacion por maquina
            else if (op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && !op.getNextOperationByMachine().equals("endMachine")) {
                //La nomenclatura cambio temporalmente, pM Es proximoMaquina

                Operation pM = operations.get(op.getNextOperationByMachine());

                if (pM.getStatus() == 1) {

                    op.clearSuccesors();
                    op.addsuccesor("endByJob_" + op.getJob());
                    op.addsuccesor(pM.getId());
                    op.addsuccesors(pM.getSuccesors());

                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        tail = pM.findJobsTail(job);
                        if (tail != Operation.MINIMUN_TAIL) {

                            op.addTail(job, tail + pM.getTimeMachine());

                            if (tail + pM.getTimeMachine() > tailMax) {
                                tailMax = tail + pM.getTimeMachine();
                            }
                            if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                                op.criticalToJob(job);
                            }

                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }

                        if (job == op.getJob() && tail == Operation.MINIMUN_TAIL && op.getNextOperationByJob().equals("endByJob_" + op.getJob())) {
                            op.addTail(job, 0);
                            op.criticalToJob(job);
                        }

                    }

                    op.setTailMax(tailMax);
                    op.setStatus(1);

                    if (structure.equals("type1")) {
                        if ((operationsTomove1.contains(pM.getId()) && op.getCompletionTime() == pM.getStartTime())
                                || orderJobs.contains(op.getJob())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }

                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }
                        if ((operationsTomove2.contains(pM.getId()) && op.getCompletionTime() == pM.getStartTime())
                                || (orderJobs.contains(op.getJob()) && !pbM.getId().equals("start") && pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob())) {
                            operationsTomove2.addFirst(op.getId());
                        }

                    }

                } else {
                    pending.add(op.getId());
                }

            } // Ultimo en operacion por maquina  y No ultimo en operacion por trabajo
            else if (!op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && op.getNextOperationByMachine().equals("endMachine")) {

                Operation pJ = operations.get(op.getNextOperationByJob());
                if (pJ.getStatus() == 1) {
                    //Delete the last successors
                    op.clearSuccesors();
                    //Add PJ
                    op.addsuccesor(pJ.getId());
                    //Add Succesor of PJ
                    op.addsuccesors(pJ.getSuccesors());

                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        tail = pJ.findJobsTail(job);
                        if (tail != Operation.MINIMUN_TAIL) {
                            op.addTail(job, tail + pJ.getTimeMachine());
                            if (tail + pJ.getTimeMachine() > tailMax) {
                                tailMax = tail + pJ.getTimeMachine();
                            }
                            if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                                op.criticalToJob(job);
                            }

                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }
                    }
                    op.setTailMax(tailMax);
                    op.setStatus(1);

                    if (structure.equals("type1") && operationsTomove1.contains(pJ.getId()) && op.getCompletionTime() == pJ.getStartTime()) {
                        operationsTomove1.addFirst(op.getId());
                    }

                    if (structure.equals("type2") || structure.equals("type3")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        for (int job = 1; job <= jobs.size(); job++) {
                            if (orderJobs.contains(job) && op.getCriticalToJob().get(job) == Boolean.TRUE) {
                                if (structure.equals("type2")) {
                                    if (pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob() && !pbM.getId().equals("start")) {
                                        operationsTomove2.addFirst(op.getId());
                                        break;
                                    }
                                }
                            }
                        }

                    }

                } else {
                    pending.add(op.getId());
                }

            } else {
                //Oj Es la operacion siguiente por trabajo
                Operation oJ = operations.get(op.getNextOperationByJob());
                //Om Es la operacion siguiente por maquina
                Operation oM = operations.get(op.getNextOperationByMachine());
                if (oJ.getStatus() == 1 && oM.getStatus() == 1) {
                    //Clear last succesors
                    op.clearSuccesors();
                    //Add if oJ=oM else oJ!=oM
                    if (oJ.getId().equals(oM.getId())) {
                        op.addsuccesor(oJ.getId());
                        op.addsuccesors(oJ.getSuccesors());
                    } else {
                        op.addsuccesor(oJ.getId());
                        op.addsuccesor(oM.getId());
                        op.addsuccesors(oJ.getSuccesors());
                        op.addsuccesors(oM.getSuccesors());
                        op.addsuccesorsTotal();
                    }

                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        int tailJ = oJ.findJobsTail(job) + oJ.getTimeMachine();
                        int tailM = oM.findJobsTail(job) + oM.getTimeMachine();

                        if (tailJ >= tailM) {
                            tail = tailJ;

                        } else {
                            tail = tailM;
                        }

                        if (tail > tailMax) {
                            tailMax = tail;
                        }

                        if (tail >= 0) {
                            op.addTail(job, tail);
                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }

                        if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                            op.criticalToJob(job);
                        }
                    }
                    op.setTailMax(tailMax);
                    op.setStatus(1);

                    if (structure.equals("type1")) {
                        if ((operationsTomove1.contains(oJ.getId()) && op.getCompletionTime() == oJ.getStartTime())
                                || (operationsTomove1.contains(oM.getId()) && op.getCompletionTime() == oM.getStartTime())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }

                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        for (int job = 1; job <= jobs.size(); job++) {
                            if (orderJobs.contains(job) && op.getCriticalToJob().get(job) == Boolean.TRUE) {
                                if (structure.equals("type2")) {
                                    if ((pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob() && !pbM.getId().equals("start"))
                                            || (operationsTomove2.contains(oM.getId()) && op.getCompletionTime() == oM.getStartTime() && oM.getJob() != op.getJob())) {
                                        operationsTomove2.addFirst(op.getId());
                                        break;
                                    }
                                }

                            }
                        }
                    }

                } else {
                    pending.add(op.getId());
                }
            }
            operations.put(op.getId(), op);
        }
        return pending;
    }

    //------------------------------------
    //---- This is more efficient mehod since update the tails using Bellman principle-----// 
    static void operationTails(LinkedList<Integer> orderJobs, String structure) {

        //To update the tails of operations, Bellman order is invoked from the highest order
        for (int b = bellmanOrder.size() - 1; b >= 0; b--) {
            for (int c = 0; c < bellmanOrder.get(b).size(); c++) {
                Operation op = operations.get(bellmanOrder.get(b).get(c));

                //op is the last operation by machine and by job.
                if (op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && op.getNextOperationByMachine().equals("endMachine")) {

                    // For N1 is critical operation, since is the last operation of job
                    if (structure.equals("type1")) {
                        if (orderJobs.contains(op.getJob())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }

                    //Analyze if N2 is considered
                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        if (!pbM.getId().equals("start") && orderJobs.contains(op.getJob()) && pbM.getCompletionTime() == op.getStartTime() && op.getJob() != pbM.getJob()) {
                            operationsTomove2.addFirst(op.getId());
                        }
                    }
                    //Succesor by Op is deleted, then phi is added. 
                    op.clearSuccesors();
                    op.addsuccesor("endByJob_" + op.getJob());

                    //Determine the tails to nodes phi.
                    for (int job = 1; job <= jobs.size(); job++) {
                        op.addTail(job, Operation.MINIMUN_TAIL);
                        op.notCriticalToJob(job);
                        if (job == op.getJob()) {
                            op.addTail(op.getJob(), 0);
                            op.criticalToJob(op.getJob());
                        }
                    }
                    //Tail to node *
                    op.setTailMax(0);

                } else if (op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && !op.getNextOperationByMachine().equals("endMachine")) {
                    //PM is fs(op)
                    Operation pM = operations.get(op.getNextOperationByMachine());

                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        tail = pM.findJobsTail(job);
                        //The tail is calculated and at the same time the tail to node *
                        if (tail != Operation.MINIMUN_TAIL) {
                            op.addTail(job, tail + pM.getTimeMachine());
                            if (tail + pM.getTimeMachine() > tailMax) {
                                tailMax = tail + pM.getTimeMachine();
                            }
                            if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                                op.criticalToJob(job);
                            }

                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }

                        if (job == op.getJob() && tail == Operation.MINIMUN_TAIL && op.getNextOperationByJob().equals("endByJob_" + op.getJob())) {
                            op.addTail(job, 0);
                            op.criticalToJob(job);
                        }

                    }

                    op.setTailMax(tailMax);
                    //Condition to add in N1
                    if (structure.equals("type1")) {
                        if ((operationsTomove1.contains(pM.getId()) && op.getCompletionTime() == pM.getStartTime())
                                || orderJobs.contains(op.getJob())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }
                    //Condition to add in N2
                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }
                        if ((operationsTomove2.contains(pM.getId()) && op.getCompletionTime() == pM.getStartTime())
                                || (orderJobs.contains(op.getJob()) && !pbM.getId().equals("start") && pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob())) {
                            operationsTomove2.addFirst(op.getId());
                        }

                    }
                    //Add the succesors
                    op.clearSuccesors();
                    op.addsuccesor("endByJob_" + op.getJob());
                    op.addsuccesor(pM.getId());
                    op.addsuccesors(pM.getSuccesors());

                } else if (!op.getNextOperationByJob().equals("endByJob_" + op.getJob()) && op.getNextOperationByMachine().equals("endMachine")) {

                    Operation pJ = operations.get(op.getNextOperationByJob());
                    int tail = 0;
                    int tailMax = 0;

                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        tail = pJ.findJobsTail(job);
                        if (tail != Operation.MINIMUN_TAIL) {
                            op.addTail(job, tail + pJ.getTimeMachine());
                            if (tail + pJ.getTimeMachine() > tailMax) {
                                tailMax = tail + pJ.getTimeMachine();
                            }
                            if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                                op.criticalToJob(job);
                            }

                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);
                        }
                    }
                    op.setTailMax(tailMax);

                    if (structure.equals("type1") && operationsTomove1.contains(pJ.getId()) && op.getCompletionTime() == pJ.getStartTime()) {
                        operationsTomove1.addFirst(op.getId());
                    }

                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        for (int job = 1; job <= jobs.size(); job++) {
                            if (orderJobs.contains(job) && op.getCriticalToJob().get(job) == Boolean.TRUE) {
                                if (pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob() && !pbM.getId().equals("start")) {
                                    operationsTomove2.addFirst(op.getId());
                                    break;
                                }
                            }
                        }

                    }
                    //Delete the last successors
                    op.clearSuccesors();
                    //Add PJ
                    op.addsuccesor(pJ.getId());
                    //Add Succesor of PJ
                    op.addsuccesors(pJ.getSuccesors());
                } else {

                    //Oj represents the fr(op) 
                    Operation oJ = operations.get(op.getNextOperationByJob());
                    //Om represents fs(op) 
                    Operation oM = operations.get(op.getNextOperationByMachine());

                    //Clear last succesors
                    op.clearSuccesors();
                    //Add if oJ=oM else oJ!=oM
                    if (oJ.getId().equals(oM.getId())) {
                        op.addsuccesor(oJ.getId());
                        op.addsuccesors(oJ.getSuccesors());
                    } else {
                        op.addsuccesor(oJ.getId());
                        op.addsuccesor(oM.getId());
                        op.addsuccesors(oJ.getSuccesors());
                        op.addsuccesors(oM.getSuccesors());
                        op.addsuccesorsTotal();
                    }

                    int tail = 0;
                    int tailMax = 0;
                    for (int job = 1; job <= jobs.size(); job++) {
                        op.notCriticalToJob(job);
                        int tailJ = oJ.findJobsTail(job) + oJ.getTimeMachine();
                        int tailM = oM.findJobsTail(job) + oM.getTimeMachine();

                        if (tailJ >= tailM) {
                            tail = tailJ;

                        } else {
                            tail = tailM;
                        }

                        if (tail > tailMax) {
                            tailMax = tail;
                        }

                        if (tail >= 0) {
                            op.addTail(job, tail);
                        } else {
                            op.addTail(job, Operation.MINIMUN_TAIL);

                        }

                        if (op.getCompletionTime() + op.findJobsTail(job) == jobs.get(job).getCompletionTime()) {
                            op.criticalToJob(job);
                        }
                    }
                    op.setTailMax(tailMax);
                    if (structure.equals("type1")) {
                        if ((operationsTomove1.contains(oJ.getId()) && op.getCompletionTime() == oJ.getStartTime())
                                || (operationsTomove1.contains(oM.getId()) && op.getCompletionTime() == oM.getStartTime())) {
                            operationsTomove1.addFirst(op.getId());
                        }
                    }

                    if (structure.equals("type2")) {
                        Operation pbM;
                        if (op.getOrderinMachine() == 1) {
                            pbM = exclusiveOperations.get("start");
                        } else {
                            pbM = operations.get(op.getPreviewOperationByMachine());
                        }

                        for (int job = 1; job <= jobs.size(); job++) {
                            if (orderJobs.contains(job) && op.getCriticalToJob().get(job) == Boolean.TRUE) {
                                if ((pbM.getCompletionTime() == op.getStartTime() && pbM.getJob() != op.getJob() && !pbM.getId().equals("start"))
                                        || (operationsTomove2.contains(oM.getId()) && op.getCompletionTime() == oM.getStartTime() && oM.getJob() != op.getJob())) {
                                    operationsTomove2.addFirst(op.getId());
                                    break;
                                }
                            }
                        }
                    }

                }
                operations.put(op.getId(), op);
            }
        }
    }

    //--------------------------
    static LinkedList<Integer> updateJobsandExclusive(String criterion) {

        LinkedList<Integer> partial = new LinkedList<Integer>();
        LinkedList<Integer> order = new LinkedList<Integer>();
        Operation start = exclusiveOperations.get("start");
        Operation endMachine = exclusiveOperations.get("endMachine");
        int arcs = 0;
        int makespan = 0;
        int tmax = 0;
        int tft = 0;
        int twft = 0;
        int twt = 0;
        int twu = 0;

        if (criterion.equals("makespan")) {

            for (int i = 1; i <= jobs.size(); i++) {

                jobs.get(i).setStartTime(operations.get(jobs.get(i).getJobOperations().getFirst()).getStartTime());
                jobs.get(i).setCompletionTime(operations.get(jobs.get(i).getJobOperations().getLast()).getCompletionTime());
                Operation last = operations.get(jobs.get(i).getJobOperations().getLast());
                Operation endByJob = exclusiveOperations.get("endByJob_" + last.getJob());
                endByJob.setNumberOfArcs(last.getNumberOfArcs() + 1);
                endByJob.setCompletionTime(last.getCompletionTime());
                exclusiveOperations.put(endByJob.getId(), endByJob);
                jobs.put(i, jobs.get(i));

                int maxArcs = last.getNumberOfArcs();
                if (maxArcs > arcs) {
                    arcs = maxArcs;
                }
                int ref = jobs.get(i).getCompletionTime();
                start.addTail(i, ref);

                if (ref >= makespan) {
                    makespan = ref;
                    partial.addFirst(i);
                }
                int refTmax = 0;

                if (jobs.get(i).getCompletionTime() > jobs.get(i).getDueDate()) {
                    refTmax = jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate();
                    twt = twt + (jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate()) * jobs.get(i).getWeigthValue();
                    twu = twu + 1;
                    if (refTmax > tmax) {
                        tmax = refTmax;
                    }
                }

                tft = tft + jobs.get(i).getCompletionTime();
                twft = twft + jobs.get(i).getCompletionTime() * jobs.get(i).getWeigthValue();

            }

            setCriterionValue(makespan);
            setCriterionTmax(tmax);
            setCriterionTFT(tft);
            setCriterionTWFT(twft);
            setCriterionTWT(twt);
            setCriterionTWU(twu);

            start.setTailMax(makespan);
            endMachine.setStartTime(makespan);
            endMachine.setNumberOfArcs(arcs + 1);
            exclusiveOperations.put("start", start);
            exclusiveOperations.put("endMachine", endMachine);
            order.add(partial.getFirst());

            for (int j = 0; j < partial.size() - 1; j++) {

                if (partial.size() == 1) {
                    break;
                }
                if (jobs.get(partial.get(j)).getCompletionTime() > jobs.get(partial.get(j + 1)).getCompletionTime()) {
                    break;
                }
                if (jobs.get(partial.get(j)).getCompletionTime() == jobs.get(partial.get(j + 1)).getCompletionTime()) {
                    order.add(partial.get(j + 1));
                }

            }

        } else if (criterion.equals("tmax")) {

            for (int i = 1; i <= jobs.size(); i++) {
                jobs.get(i).setStartTime(operations.get(jobs.get(i).getJobOperations().getFirst()).getStartTime());
                jobs.get(i).setCompletionTime(operations.get(jobs.get(i).getJobOperations().getLast()).getCompletionTime());
                jobs.get(i).setJobTardiness(0);
                Operation last = operations.get(jobs.get(i).getJobOperations().getLast());
                Operation endByJob = exclusiveOperations.get("endByJob_" + last.getJob());
                endByJob.setNumberOfArcs(last.getNumberOfArcs() + 1);
                endByJob.setCompletionTime(last.getCompletionTime());
                exclusiveOperations.put(endByJob.getId(), endByJob);
                jobs.put(i, jobs.get(i));

                if (jobs.get(i).getCompletionTime() > jobs.get(i).getDueDate()) {
                    twt = twt + (jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate()) * jobs.get(i).getWeigthValue();
                    twu = twu + jobs.get(i).getWeigthValue();
                    jobs.get(i).setJobTardiness(jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate());
                }

                int maxArcs = last.getNumberOfArcs();
                if (maxArcs > arcs) {
                    arcs = maxArcs;
                }
                int ref1 = jobs.get(i).getCompletionTime();
                start.addTail(i, ref1);

                if (ref1 >= makespan) {
                    makespan = ref1;
                }
                int ref = jobs.get(i).getJobTardiness();
                if (ref >= tmax) {
                    tmax = ref;
                    partial.addFirst(i);
                }
                tft = tft + jobs.get(i).getCompletionTime();
                twft = twft + jobs.get(i).getCompletionTime() * jobs.get(i).getWeigthValue();
            }
            setCriterionValue(tmax);
            setCriterionMk(makespan);
            setCriterionTFT(tft);
            setCriterionTWFT(twft);
            setCriterionTWT(twt);
            setCriterionTWU(twu);

            start.setTailMax(makespan);
            endMachine.setStartTime(makespan);
            endMachine.setNumberOfArcs(arcs + 1);
            exclusiveOperations.put("start", start);
            exclusiveOperations.put("endMachine", endMachine);
            order.add(partial.getFirst());

            for (int j = 0; j < partial.size() - 1; j++) {
                if (partial.size() == 1) {
                    break;
                }
                if (jobs.get(partial.get(j)).getJobTardiness() > jobs.get(partial.get(j + 1)).getJobTardiness()) {
                    break;
                }
                if (jobs.get(partial.get(j)).getJobTardiness() == jobs.get(partial.get(j + 1)).getJobTardiness()) {
                    order.add(partial.get(j + 1));
                }

            }

        } else if (criterion.equals("twt") || criterion.equals("twu")) {

            for (int i = 1; i <= jobs.size(); i++) {

                jobs.get(i).setStartTime(operations.get(jobs.get(i).getJobOperations().getFirst()).getStartTime());
                jobs.get(i).setCompletionTime(operations.get(jobs.get(i).getJobOperations().getLast()).getCompletionTime());
                jobs.get(i).setJobTardiness(0);

                if (jobs.get(i).getCompletionTime() > jobs.get(i).getDueDate()) {
                    jobs.get(i).setJobTardiness(jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate());
                }
                Operation last = operations.get(jobs.get(i).getJobOperations().getLast());
                Operation endByJob = exclusiveOperations.get("endByJob_" + last.getJob());
                endByJob.setNumberOfArcs(last.getNumberOfArcs() + 1);
                endByJob.setCompletionTime(last.getCompletionTime());
                exclusiveOperations.put(endByJob.getId(), endByJob);
                jobs.put(i, jobs.get(i));
                int maxArcs = last.getNumberOfArcs();
                if (maxArcs > arcs) {
                    arcs = maxArcs;
                }
                int ref1 = jobs.get(i).getCompletionTime();
                start.addTail(i, ref1);
                if (ref1 >= makespan) {
                    makespan = ref1;
                }
                int ref = jobs.get(i).getJobTardiness();
                if (ref >= tmax) {
                    tmax = ref;
                }

                tft = tft + jobs.get(i).getCompletionTime();
                twft = twft + jobs.get(i).getCompletionTime() * jobs.get(i).getWeigthValue();

                if (criterion.equals("twt")) {

                    int tardiness = jobs.get(i).getJobTardiness();
                    if (tardiness > 0) {
                        twt = twt + jobs.get(i).getWeigthValue() * jobs.get(i).getJobTardiness();
                        twu = twu + jobs.get(i).getWeigthValue();
                        order.add(i);
                    }
                    setCriterionValue(twt);
                    setCriterionTWU(twu);

                }

                if (criterion.equals("twu")) {

                    int tardiness = jobs.get(i).getJobTardiness();
                    if (tardiness > 0) {
                        order.add(i);
                        twu = twu + jobs.get(i).getWeigthValue();
                        twt = twt + jobs.get(i).getWeigthValue() * jobs.get(i).getJobTardiness();
                    }
                    setCriterionValue(twu);
                    setCriterionTWT(twt);
                }

            }

            start.setTailMax(makespan);
            endMachine.setStartTime(makespan);
            setCriterionMk(makespan);
            setCriterionTFT(tft);
            setCriterionTWFT(twft);
            setCriterionTmax(tmax);

            endMachine.setNumberOfArcs(arcs + 1);
            exclusiveOperations.put("start", start);
            exclusiveOperations.put("endMachine", endMachine);
        } else if (criterion.equals("twc") || criterion.equals("tc")) {

            for (int i = 1; i <= jobs.size(); i++) {
                jobs.get(i).setStartTime(operations.get(jobs.get(i).getJobOperations().getFirst()).getStartTime());
                jobs.get(i).setCompletionTime(operations.get(jobs.get(i).getJobOperations().getLast()).getCompletionTime());
                Operation last = operations.get(jobs.get(i).getJobOperations().getLast());
                Operation endByJob = exclusiveOperations.get("endByJob_" + last.getJob());
                endByJob.setNumberOfArcs(last.getNumberOfArcs() + 1);
                endByJob.setCompletionTime(last.getCompletionTime());
                exclusiveOperations.put(endByJob.getId(), endByJob);
                jobs.put(i, jobs.get(i));
                int maxArcs = last.getNumberOfArcs();
                if (maxArcs > arcs) {
                    arcs = maxArcs;
                }

                int refTmax = 0;

                if (jobs.get(i).getCompletionTime() > jobs.get(i).getDueDate()) {
                    refTmax = jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate();
                    twt = twt + (jobs.get(i).getCompletionTime() - jobs.get(i).getDueDate()) * jobs.get(i).getWeigthValue();
                    twu = twu + jobs.get(i).getWeigthValue();
                    if (refTmax > tmax) {
                        tmax = refTmax;
                    }
                }

                int ref1 = jobs.get(i).getCompletionTime();
                start.addTail(i, ref1);
                if (ref1 >= makespan) {
                    makespan = ref1;
                }
                order.add(i);

                if (criterion.equals("twc")) {
                    twft = twft + jobs.get(i).getWeigthValue() * jobs.get(i).getCompletionTime();
                    tft = tft + jobs.get(i).getCompletionTime();
                    setCriterionValue(twft);
                    setCriterionTFT(tft);
                }
                if (criterion.equals("tc")) {
                    tft = tft + jobs.get(i).getCompletionTime();
                    twft = twft + jobs.get(i).getWeigthValue() * jobs.get(i).getCompletionTime();
                    setCriterionValue(tft);
                    setCriterionTWFT(twft);
                }
            }
            setCriterionMk(makespan);
            setCriterionTmax(tmax);
            setCriterionTWT(twt);
            setCriterionTWU(twu);
            start.setTailMax(makespan);
            endMachine.setStartTime(makespan);
            endMachine.setNumberOfArcs(arcs + 1);
            exclusiveOperations.put("start", start);
            exclusiveOperations.put("endMachine", endMachine);

        }
        return order;
    }

    static void readerStructure(String type) {
        if (type.equals("type1")) {
            for (int i = 0; i < operationsTomove1.size(); i++) {
                System.out.println(operationsTomove1.get(i));
            }
        }
        if (type.equals("type2")) {
            for (int i = 0; i < operationsTomove2.size(); i++) {
                System.out.println(operationsTomove2.get(i));
            }
        }

    }
//------Feasible insertions Mista without Tabu List------

    //Hommework to Yazid.
    static void feasibleInsertionsYazid(String type, int criterionValue, String criterion, LinkedList<Integer> orderJobs) {

        // Set that Saves the operations to move
        LinkedList<String> operationsTomove = new LinkedList<>();
        //In order to protect the order of the jobs
        LinkedList<Integer> orderTemp = new LinkedList<>();
        // Real value of the criterion if a move were done
        int criterionValueTemp;
        // Best value of the move in realInsertions
        int bestMove = -Operation.MINIMUN_TAIL;

        if (type.equals("type1")) {
            //The operations to move of N1 are saved, since the graph is partially transformed and return to the same position
            for (int li = 0; li < operationsTomove1.size(); li++) {
                operationsTomove.add(operationsTomove1.get(li));
            }
        } else {
            //The operations to move of N12 are saved, since the graph is partially transformed and return to the same position
            for (int li = 0; li < operationsTomove2.size(); li++) {
                operationsTomove.add(operationsTomove2.get(li));
            }
        }
        for (int i = 0; i < operationsTomove.size(); i++) {
            //Operations related to I are invoked 
            Operation opI = operations.get(operationsTomove.get(i));

            int mach = opI.getMachineAssigned();
            //preview operation by machine
            Operation opS;
            if (opI.getPreviewOperationByMachine().equals("start")) {
                opS = exclusiveOperations.get("start");
            } else {
                opS = operations.get(opI.getPreviewOperationByMachine());
            }

            //Next operation by machine of I
            Operation opT;
            if (opI.getNextOperationByMachine().equals("endMachine")) {
                opT = exclusiveOperations.get("endMachine");
            } else {
                opT = operations.get(opI.getNextOperationByMachine());
            }

            Operation pbjT = null;

            if (!opT.getId().equals("endMachine")) {
                if (opT.getPreviewOperationByJob().equals("start")) {
                    pbjT = exclusiveOperations.get("start");
                } else {
                    pbjT = operations.get(opT.getPreviewOperationByJob());
                }
            }

            Operation nbjS;
            if (opS.getNextOperationByJob().equals("endByJob_" + opS.getJob())) {
                nbjS = exclusiveOperations.get("endByJob_" + opS.getJob());
            } else {
                nbjS = operations.get(opS.getNextOperationByJob());
            }

            int l1 = opS.getCompletionTime() + opT.getTimeMachine() + opT.getTailMax();

            //Next operation by job of I
            Operation nbjI;
            if (opI.getNextOperationByJob().equals("endByJob_" + opI.getJob())) {
                nbjI = exclusiveOperations.get("endByJob_" + opI.getJob());
            } else {
                nbjI = operations.get(opI.getNextOperationByJob());
            }
            //Preview operatioin by job of I
            Operation pbjI;
            if (opI.getPreviewOperationByJob().equals("start")) {
                pbjI = exclusiveOperations.get("start");
            } else {
                pbjI = operations.get(opI.getPreviewOperationByJob());
            }
            int l4 = Operation.MINIMUN_TAIL;

            for (int bell = 0; bell < bellmanOrder.get(opI.getNumberOfArcs() - 1).size(); bell++) {
                Operation w = operations.get(bellmanOrder.get(opI.getNumberOfArcs() - 1).get(bell));
                if (!w.getId().equals(opI.getId())) {
                    if (l4 < w.getCompletionTime() + w.getTailMax()) {
                        l4 = w.getCompletionTime() + w.getTailMax();
                    }
                }
            }

            //-----It is the resequencing process-----------//
            if (machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() > 3) {

                //-----Forward process (Case 1 is applied)-----------//
                if (opI.getOrderinMachine() >= 1 && opI.getOrderinMachine()
                        <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {

                    //The position of the operation in the machine is located then advancing in the move search
                    for (int pos = opI.getOrderinMachine(); pos <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3; pos++) {
                        Operation opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 1));
                        //If the job of J is the same of I, the cycle is broken
                        if (opJ.getJob() == opI.getJob()) {
                            break;
                        }
                        Operation nbjJ;
                        if (opJ.getNextOperationByJob().equals("endByJob_" + opJ.getJob())) {
                            nbjJ = exclusiveOperations.get("endByJob_" + opJ.getJob());
                        } else {
                            nbjJ = operations.get(opJ.getNextOperationByJob());
                        }

                        int hj = opJ.getStartTime() - opT.getStartTime() + Math.max(opS.getCompletionTime(), pbjT.getCompletionTime());
                        int hi = Math.max(hj + opJ.getTimeMachine(), pbjI.getCompletionTime());
                        // The Operation k is invoked
                        Operation opK;
                        if (pos == machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                            opK = exclusiveOperations.get("endMachine");
                        } else {
                            opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 2));
                        }

                        //Starts The test H test as soon as J and K are defined
                        if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                            if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                int l2 = hj + opJ.getTimeMachine() + nbjJ.getTimeMachine() + nbjJ.getTailMax();
                                int l3 = hi + opI.getTimeMachine() + Math.max(nbjI.getTimeMachine() + nbjI.getTailMax(), opK.getTimeMachine() + opK.getTailMax());
                                int lf = Math.max(Math.max(l2, l3), Math.max(l1, l4));
                                if (lf < criterionValue) {
                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), lf, mach);
                                    if (lf <= bestMove) {
                                        insertions.addFirst(newInsertion);
                                        bestMove = lf;
                                    } else {
                                        insertions.add(newInsertion);
                                    }
                                }

                            }
                        }
                    }
                }

                //Backward process
                if (opI.getOrderinMachine() >= 2 && opI.getOrderinMachine() <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 2) {
                    for (int pos = opI.getOrderinMachine(); pos >= 2; pos--) {
                        Operation opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 1));
                        // If opK belongs to the same job of opI is broken cycle
                        if (opK.getJob() == opI.getJob()) {
                            break;
                        }
                        Operation pbjK;
                        if (opK.getPreviewOperationByJob().equals("start")) {
                            pbjK = exclusiveOperations.get("start");
                        } else {
                            pbjK = operations.get(opK.getPreviewOperationByJob());
                        }

                        Operation opJ;
                        if (pos == 2) {
                            opJ = exclusiveOperations.get("start");
                        } else {
                            opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 2));
                        }

                        //Starts The test H test as soon as J and K are defined
                        if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                            if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                int hi = Math.max(opJ.getCompletionTime(), pbjI.getCompletionTime());
                                int hk = Math.max(hi + opI.getTimeMachine(), pbjK.getCompletionTime());
                                int qk = opK.getTailMax() - opS.getTailMax() + Math.max(nbjS.getTimeMachine() + nbjS.getTailMax(), opT.getTimeMachine() + opT.getTailMax());
                                int l2 = hi + opI.getTimeMachine() + nbjI.getTimeMachine() + nbjI.getTailMax();
                                int l3 = hk + opK.getTimeMachine() + qk;
                                int lf = Math.max(Math.max(l2, l3), Math.max(l1, l4));
                                if (lf < criterionValue) {
                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), lf, mach);
                                    if (lf <= bestMove) {
                                        insertions.addFirst(newInsertion);
                                        bestMove = lf;
                                    } else {
                                        insertions.add(newInsertion);
                                    }
                                }

                            }

                        }

                    }
                }
            }
                //-------Finish resequencing process--------

            //---------Start reasignning process---
            if (opI.getTimesInMachine().size() > 1) {
                Iterator itr = opI.getTimesInMachine().entrySet().iterator();
                while (itr.hasNext()) {
                    Map.Entry e = (Map.Entry) itr.next();
                    int mq = e.getKey().hashCode();
                    int timq = e.getValue().hashCode();
                    if (machines[mq - 1].getId() != opI.getMachineAssigned()) {
                        //If there is at least one machine which belong to M of opI / M contains only Start and End Machine
                        if (machines[mq - 1].getAssignedOperations().size() < 3) {
                            int l2 = pbjI.getCompletionTime() + timq + nbjI.getTimeMachine() + nbjI.getTailMax();
                            int lf = Math.max(l2, Math.max(l1, l4));
                            if (lf < criterionValue) {
                                Insertion newInsertion = new Insertion(opI.getId(), "start", "endMachine", lf, mq);
                                if (lf <= bestMove) {
                                    insertions.addFirst(newInsertion);
                                    bestMove = lf;
                                } else {
                                    insertions.add(newInsertion);
                                }
                            }
                        } else {
                            // In case M performs pbjI, pbjI different from start
                            if (machines[mq - 1].getId() == pbjI.getMachineAssigned() && !pbjI.getId().equals("start")) {
                                for (int w = pbjI.getOrderinMachine(); w < machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ = operations.get(machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                    if ((opJ.getJob() == opI.getJob()) && (opJ.getNumberOfArcs() > opI.getNumberOfArcs())) {
                                        break;
                                    }

                                    Operation opK;
                                    if (opJ.getNextOperationByMachine().equals("endMachine")) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(opJ.getNextOperationByMachine());
                                    }
                                    //Starts The test HTA test as soon as J and K are defined
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            int l2 = 0, l3 = 0;
                                            if (opJ.getNumberOfArcs() >= opI.getNumberOfArcs()) {
                                                int hj = 0;
                                                if (opT.getId().equals("endMachine") || (opT.getNumberOfArcs() >= opJ.getNumberOfArcs()) || (opT.getStartTime() >= opJ.getStartTime()) || (opT.getTailMax() <= opJ.getTailMax())) {
                                                    hj = opJ.getStartTime();
                                                } else {
                                                    hj = opJ.getStartTime() - opT.getStartTime() + Math.max(opS.getCompletionTime(), pbjT.getCompletionTime());
                                                }
                                                int hi = Math.max(hj + opJ.getTimeMachine(), pbjI.getCompletionTime());

                                                Operation nbjJ = exclusiveOperations.get("endByJob_" + opJ.getJob());
                                                if (!opJ.getNextOperationByJob().equals("endByJob_" + opJ.getJob())) {
                                                    nbjJ = operations.get(opJ.getNextOperationByJob());
                                                }

                                                l2 = hj + opJ.getTimeMachine() + nbjJ.getTimeMachine() + nbjJ.getTailMax();
                                                l3 = hi + timq + Math.max(nbjI.getTimeMachine() + nbjI.getTailMax(), opK.getTimeMachine() + opK.getTailMax());

                                            } else {
                                                int hi = Math.max(opJ.getCompletionTime(), pbjI.getCompletionTime());
                                                int hk = 0;
                                                int qk = 0;
                                                l2 = hi + timq + nbjI.getTimeMachine() + nbjI.getTailMax();
                                                if (!opK.getId().equals("endMachine")) {
                                                    Operation pbjK = exclusiveOperations.get("start");
                                                    if (!opK.getPreviewOperationByJob().equals("start")) {
                                                        pbjK = operations.get(opK.getPreviewOperationByJob());
                                                    }
                                                    hk = Math.max(hi + timq, pbjK.getCompletionTime());
                                                    if ((opK.getNumberOfArcs() >= opS.getNumberOfArcs()) || (opS.getTailMax() >= opK.getTailMax()) || (opS.getStartTime() <= opK.getStartTime())) {
                                                        qk = opK.getTailMax();
                                                    } else {
                                                        qk = opK.getTailMax() - opS.getTailMax() + Math.max(nbjS.getTimeMachine() + nbjS.getTailMax(), opT.getTimeMachine() + opT.getTailMax());
                                                    }
                                                }
                                                l3 = hk + opK.getTimeMachine() + qk;
                                            }

                                            int lf = Math.max(Math.max(l1, l4), Math.max(l2, l3));

                                            if (lf < criterionValue) {
                                                Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), lf, mq);
                                                if (lf <= bestMove) {
                                                    insertions.addFirst(newInsertion);
                                                    bestMove = lf;
                                                } else {
                                                    insertions.add(newInsertion);
                                                }
                                            }

                                        }
                                    }//Close Test HTA
                                }
                            } else {
                                // if m performs nbjI but not pbjI. nbjI different from endByJob
                                if (machines[mq - 1].getId() == nbjI.getMachineAssigned() && !nbjI.getId().equals("endByJob_" + opI.getJob()) && pbjI.getMachineAssigned() != machines[mq - 1].getId()) {
                                    //Determine the feasible insertions since it is a backward strategy
                                    for (int w = nbjI.getOrderinMachine(); w >= 1; w--) {
                                        Operation opK = operations.get(machines[nbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                        if (opK.getJob() == opI.getJob() && w < nbjI.getOrderinMachine()) {
                                            break;
                                        }
                                        Operation opJ;
                                        if (opK.getPreviewOperationByMachine().equals("start")) {
                                            opJ = exclusiveOperations.get("start");
                                        } else {
                                            opJ = operations.get(opK.getPreviewOperationByMachine());
                                        }
                                        //Starts The test HTA test as soon as J and K are defined
                                        if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                            if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                                int l2 = 0, l3 = 0;
                                                if (opJ.getNumberOfArcs() >= opI.getNumberOfArcs()) {
                                                    int hj = 0;
                                                    if (opT.getId().equals("endMachine") || (opT.getNumberOfArcs() >= opJ.getNumberOfArcs()) || (opT.getStartTime() >= opJ.getStartTime()) || (opT.getTailMax() <= opJ.getTailMax())) {
                                                        hj = opJ.getStartTime();
                                                    } else {
                                                        hj = opJ.getStartTime() - opT.getStartTime() + Math.max(opS.getCompletionTime(), pbjT.getCompletionTime());
                                                    }
                                                    int hi = Math.max(hj + opJ.getTimeMachine(), pbjI.getCompletionTime());

                                                    Operation nbjJ = exclusiveOperations.get("endByJob_" + opJ.getJob());
                                                    if (!opJ.getNextOperationByJob().equals("endByJob_" + opJ.getJob())) {
                                                        nbjJ = operations.get(opJ.getNextOperationByJob());
                                                    }

                                                    l2 = hj + opJ.getTimeMachine() + nbjJ.getTimeMachine() + nbjJ.getTailMax();
                                                    l3 = hi + timq + Math.max(nbjI.getTimeMachine() + nbjI.getTailMax(), opK.getTimeMachine() + opK.getTailMax());

                                                } else {
                                                    int hi = Math.max(opJ.getCompletionTime(), pbjI.getCompletionTime());
                                                    int hk = 0;
                                                    int qk = 0;
                                                    l2 = hi + timq + nbjI.getTimeMachine() + nbjI.getTailMax();
                                                    if (!opK.getId().equals("endMachine")) {
                                                        Operation pbjK = exclusiveOperations.get("start");
                                                        if (!opK.getPreviewOperationByJob().equals("start")) {
                                                            pbjK = operations.get(opK.getPreviewOperationByJob());
                                                        }
                                                        hk = Math.max(hi + timq, pbjK.getCompletionTime());
                                                        if ((opK.getNumberOfArcs() >= opS.getNumberOfArcs()) || (opS.getTailMax() >= opK.getTailMax()) || (opS.getStartTime() <= opK.getStartTime())) {
                                                            qk = opK.getTailMax();
                                                        } else {
                                                            qk = opK.getTailMax() - opS.getTailMax() + Math.max(nbjS.getTimeMachine() + nbjS.getTailMax(), opT.getTimeMachine() + opT.getTailMax());
                                                        }
                                                    }
                                                    l3 = hk + opK.getTimeMachine() + qk;
                                                }

                                                int lf = Math.max(Math.max(l1, l4), Math.max(l2, l3));

                                                if (lf < criterionValue) {
                                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), lf, mq);
                                                    if (lf <= bestMove) {
                                                        insertions.addFirst(newInsertion);
                                                        bestMove = lf;
                                                    } else {
                                                        insertions.add(newInsertion);
                                                    }
                                                }

                                            }
                                        }//Close Test HTA
                                    }
                                } else {
                                    // This part evaluates from the first operation 
                                    for (int w = 0; w < machines[mq - 1].getAssignedOperations().size() - 1; w++) {
                                        //Invoke k
                                        Operation opJ;
                                        Operation opK;
                                        if (w == 0) {
                                            opJ = exclusiveOperations.get("start");
                                        } else {
                                            opJ = operations.get(machines[mq - 1].getAssignedOperations().get(w));
                                        }
                                        //Condition to finish the search
                                        if (opJ.getJob() == opI.getJob() && opJ.getNumberOfArcs() > opI.getNumberOfArcs()) {
                                            break;
                                        }
                                        if (w == machines[mq - 1].getAssignedOperations().size() - 2) {
                                            opK = exclusiveOperations.get("endMachine");
                                        } else {
                                            opK = operations.get(machines[mq - 1].getAssignedOperations().get(w + 1));
                                        }

                                        //Starts The test HTA test as soon as J and K are defined
                                        if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                            if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                                int l2 = 0, l3 = 0;
                                                if (opJ.getNumberOfArcs() >= opI.getNumberOfArcs()) {
                                                    int hj = 0;
                                                    if (opT.getId().equals("endMachine") || (opT.getNumberOfArcs() >= opJ.getNumberOfArcs()) || (opT.getStartTime() >= opJ.getStartTime()) || (opT.getTailMax() <= opJ.getTailMax())) {
                                                        hj = opJ.getStartTime();
                                                    } else {
                                                        hj = opJ.getStartTime() - opT.getStartTime() + Math.max(opS.getCompletionTime(), pbjT.getCompletionTime());
                                                    }
                                                    int hi = Math.max(hj + opJ.getTimeMachine(), pbjI.getCompletionTime());

                                                    Operation nbjJ = exclusiveOperations.get("endByJob_" + opJ.getJob());
                                                    if (!opJ.getNextOperationByJob().equals("endByJob_" + opJ.getJob())) {
                                                        nbjJ = operations.get(opJ.getNextOperationByJob());
                                                    }

                                                    l2 = hj + opJ.getTimeMachine() + nbjJ.getTimeMachine() + nbjJ.getTailMax();
                                                    l3 = hi + timq + Math.max(nbjI.getTimeMachine() + nbjI.getTailMax(), opK.getTimeMachine() + opK.getTailMax());

                                                } else {
                                                    int hi = Math.max(opJ.getCompletionTime(), pbjI.getCompletionTime());
                                                    int hk = 0;
                                                    int qk = 0;
                                                    l2 = hi + timq + nbjI.getTimeMachine() + nbjI.getTailMax();
                                                    if (!opK.getId().equals("endMachine")) {
                                                        Operation pbjK = exclusiveOperations.get("start");
                                                        if (!opK.getPreviewOperationByJob().equals("start")) {
                                                            pbjK = operations.get(opK.getPreviewOperationByJob());
                                                        }
                                                        hk = Math.max(hi + timq, pbjK.getCompletionTime());
                                                        if ((opK.getNumberOfArcs() >= opS.getNumberOfArcs()) || (opS.getTailMax() >= opK.getTailMax()) || (opS.getStartTime() <= opK.getStartTime())) {
                                                            qk = opK.getTailMax();
                                                        } else {
                                                            qk = opK.getTailMax() - opS.getTailMax() + Math.max(nbjS.getTimeMachine() + nbjS.getTailMax(), opT.getTimeMachine() + opT.getTailMax());
                                                        }
                                                    }
                                                    l3 = hk + opK.getTimeMachine() + qk;
                                                }

                                                int lf = Math.max(Math.max(l1, l4), Math.max(l2, l3));

                                                if (lf < criterionValue) {
                                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), lf, mq);
                                                    if (lf <= bestMove) {
                                                        insertions.addFirst(newInsertion);
                                                        bestMove = lf;
                                                    } else {
                                                        insertions.add(newInsertion);
                                                    }
                                                }

                                            }
                                        }//Close Test HTA
                                    }

                                }

                            }

                        }

                    }

                }
            }

        }
        if (!insertions.isEmpty()) {
            int size = 0;
            int test = 0;
            //Recover the insertion related to bem. This insertion represents the move to perform.
            //System.out.println("Criterion Value is " + criterionValue);
            for (int ins = 0; ins < insertions.size(); ins++) {
                String j1 = insertions.get(ins).getNodej();
                String k1 = insertions.get(ins).getNodek();

                Operation x = operations.get(insertions.get(ins).getNodei());
                int macpr = x.getMachineAssigned();
                int mac = insertions.get(ins).getMachine();
                String s1 = x.getPreviewOperationByMachine();
                String t1 = x.getNextOperationByMachine();

                createSolutionForward(x.getId(), j1, k1, s1, t1, mac);
                deleteStructureTemporal(type);
                criterionValueTemp = calculateMakespan();

                if (criterionValueTemp >= criterionValue) {
                    test = 1;
                }
                if (criterionValueTemp < criterionValue) {
                    size = 1;
                    break;
                } else {
                    createSolutionForward(x.getId(), s1, t1, j1, k1, macpr);
                    deleteStructureTemporal(type);
                }
            }
            if (size == 0) {
                insertions.clear();
            }
            if (test == 1) {
                case3++;
            }
        }

    } //Close homework of Yazid. 
//----

    static int criterionStimated(int[] estimatedValues, String criterion, LinkedList<Integer> orderJobs) {
        int criterionStimated = 0;

        if (criterion.equals("makespan")) {

            for (int i = 0; i < totalJobs; i++) {
                if (estimatedValues[i] >= criterionStimated) {
                    criterionStimated = estimatedValues[i];
                }
            }
        } else if (criterion.equals("tc")) {
            for (int i = 0; i < totalJobs; i++) {
                criterionStimated = criterionStimated + estimatedValues[i];
            }
        } else if (criterion.equals("twc")) {
            for (int i = 0; i < totalJobs; i++) {
                criterionStimated = criterionStimated + estimatedValues[i] * jobs.get(i + 1).getWeigthValue();
            }
        } else if (criterion.equals("tmax")) {
            int tmax = 0;
            for (int i = 0; i < totalJobs; i++) {
                if (jobs.get(i + 1).getDueDate() < estimatedValues[i]) {
                    tmax = estimatedValues[i] - jobs.get(i + 1).getDueDate();
                }
                if (tmax > criterionStimated) {
                    criterionStimated = tmax;
                }
            }
        } else if (criterion.equals("twt")) {
            for (int i = 0; i < totalJobs; i++) {
                if (jobs.get(i + 1).getDueDate() < estimatedValues[i]) {
                    criterionStimated = criterionStimated + estimatedValues[i] - jobs.get(i + 1).getDueDate();
                }

            }
        } else if (criterion.equals("aux")) {
            for (int i = 0; i < totalJobs; i++) {
                if (orderJobs.contains(i + 1)) {
                    if (estimatedValues[i] > jobs.get(i + 1).getDueDate()) {
                        criterionStimated = criterionStimated + estimatedValues[i] - jobs.get(i + 1).getDueDate();
                    }
                }
            }
        }

        return criterionStimated;
    }

    static void bestInsertion() {

        //Escoger la mas pequeña. 
        int ref = -Operation.MINIMUN_TAIL;
        for (int i = 0; i < insertions.size(); i++) {
            if (insertions.get(i).getCriterionValue() < ref) {
                ref = insertions.get(i).getCriterionValue();
            }

        }

        for (int i = 0; i < insertions.size(); i++) {
            if (insertions.get(i).getCriterionValue() > ref) {
                insertions.remove(i);
                i--;
            }

        }

    }

    static void createNewSolutionBuilTabu(int x) {

        Operation opI = operations.get(insertions.get(x).getNodei());
        Operation opJ;
        Operation opK;
        Operation opS;
        Operation opT;
        String opj = insertions.get(x).getNodej();
        String opk = insertions.get(x).getNodek();
        String ops = opI.getPreviewOperationByMachine();
        String opt = opI.getNextOperationByMachine();

        if (opj.equals("start")) {
            opJ = exclusiveOperations.get("start");
        } else {
            opJ = operations.get(insertions.get(x).getNodej());
        }
        if (opk.equals("endMachine")) {
            opK = exclusiveOperations.get("endMachine");
        } else {
            opK = operations.get(insertions.get(x).getNodek());
        }
        if (ops.equals("start")) {
            opS = exclusiveOperations.get("start");
        } else {
            opS = operations.get(opI.getPreviewOperationByMachine());
        }
        if (opt.equals("endMachine")) {
            opT = exclusiveOperations.get("endMachine");
        } else {
            opT = operations.get(opI.getNextOperationByMachine());
        }

        opI.setNextOperationByMachine(opK.getId());
        opI.setPreviewOperationByMachine(opJ.getId());
        opI.setMachineAssigned(insertions.get(x).getMachine());
        opI.setTimeMachine(opI.getTimesInMachine().get(opI.getMachineAssigned()));
        operations.put(opI.getId(), opI);
        if (!opJ.getId().equals("start")) {
            opJ.setNextOperationByMachine(opI.getId());
            operations.put(opJ.getId(), opJ);
        }
        if (!opK.getId().equals("endMachine")) {
            opK.setPreviewOperationByMachine(opI.getId());
            operations.put(opK.getId(), opK);
        }
        if (!opS.getId().equals("start")) {
            opS.setNextOperationByMachine(opT.getId());
            operations.put(opS.getId(), opS);
        }
        if (!opT.getId().equals("endMachine")) {
            opT.setPreviewOperationByMachine(opS.getId());
            operations.put(opT.getId(), opT);
        }

    }

    static void deleteStructureandUpdateDate(String type) {
        //Delete the assigned operations to the machines and add Start
        deleteAndIntStartinMachines();
        //Delete Bellman Order
        bellmanOrder.clear();
        //Set start time, completion time. Forward Solution      
        updateOperations();
        //Add *(end Machine)
        addendMachine();
        //Delete the set of feasible insertions less than the current value
        insertions.clear();
        insertionsReal.clear();

        if (type.equals("type1")) {
            operationsTomove1.clear();
        } else {
            operationsTomove2.clear();
        }
    }

    public static void createFileBest(String fileName) {
        File f = new File(fileName);

        try {
            FileWriter w = new FileWriter(f);
            BufferedWriter bw = new BufferedWriter(w);
            PrintWriter wr = new PrintWriter(bw);

            wr.write("Results for the Schedule \n");

            for (int i = 0; i < machines.length; i++) {
                wr.append("--Machine--" + machines[i].getId() + "\n");
                for (int j = 0; j < machines[i].getAssignRecord().size(); j++) {
                    if (j <= machines[i].getAssignRecord().size() - 2) {
                        wr.append(machines[i].getAssignRecord().get(j) + ",");
                    }
                    if (j == machines[i].getAssignRecord().size() - 1) {
                        wr.append(machines[i].getAssignRecord().get(j) + ".");
                    }
                }
                wr.append("\n");
            }
            wr.close();
            bw.close();

        } catch (IOException e) {
        };

    }

    static void feasibleDiversif(String type) {

        LinkedList<String> operationsTodiversify = new LinkedList<>();
        if (type.equals("type1")) {
            //Select random two operations
            operationsTodiversify.add(operationsTomove1.get(((int) (Math.random() * (operationsTomove1.size() - 1 + 1) + 1)) - 1));
            operationsTodiversify.add(operationsTomove1.get(((int) (Math.random() * (operationsTomove1.size() - 1 + 1) + 1)) - 1));

            for (int i = 0; i < operationsTodiversify.size(); i++) {

                //Operations related to I are invoked 
                Operation opI = operations.get(operationsTodiversify.get(i));

                Operation nbjI;
                if (opI.getNextOperationByJob().equals("endByJob_" + opI.getJob())) {
                    nbjI = exclusiveOperations.get("endByJob_" + opI.getJob());
                } else {
                    nbjI = operations.get(opI.getNextOperationByJob());
                }

                Operation pbjI;
                if (opI.getPreviewOperationByJob().equals("start")) {
                    pbjI = exclusiveOperations.get("start");
                } else {
                    pbjI = operations.get(opI.getPreviewOperationByJob());
                }
                //-----It is the resequencing process-----------//
                if (machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() > 3) {

                    //-----Forward process -----------//
                    if (opI.getOrderinMachine() >= 1 && opI.getOrderinMachine()
                            <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {

                        //Control variable for escaping if an ubfeasible move is found.
                        int cont = 0;

                        for (int pos = opI.getOrderinMachine(); pos <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3; pos++) {
                            Operation opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 1));

                            if (opJ.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opK;
                            if (pos == machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                                opK = exclusiveOperations.get("endMachine");
                            } else {
                                opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 2));
                            }

                            //The test HTA
                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    cont = pos;
                                    //Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), opI.getMachineAssigned());
                                    //insertions.add(newInsertion);

                                }
                            }
                            if (cont != 0 && pos > cont) {
                                //System.out.println("----Aqui se rompio---" + opI.getId() + "---" + opJ.getId() + "---" + opK.getId());
                                break;
                            }
                        }

                    }
                    //Backward process

                    if (opI.getOrderinMachine() >= 2 && opI.getOrderinMachine() <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 2) {

                        int cont = 0;
                        for (int pos = opI.getOrderinMachine(); pos >= 2; pos--) {

                            Operation opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 1));
                            if (opK.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opJ;
                            if (pos == 2) {
                                opJ = exclusiveOperations.get("start");
                            } else {
                                opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 2));
                            }

                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    cont = pos;

                                    //Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), opI.getMachineAssigned());
                                    //insertions.add(newInsertion);
                                }
                            }

                            if (cont != 0 && pos < cont) {
                                break;
                            }

                        }

                    }
                }
                //-------Finish resequencing process--------

                //---------Start reasignning process---
                for (int m = 0; m < machines.length; m++) {

                    if (machines[m].getId() != opI.getMachineAssigned() && opI.getTimesInMachine().containsKey(machines[m].getId())) {

                        //If there is at least one machine which belong to M opI. M contains Start and End Machine 
                        if (machines[m].getAssignedOperations().size() < 3) {
                            //Insertion newInsertion = new Insertion(opI.getId(), "start", "endMachine", machines[m].getId());
                            //insertions.add(newInsertion);
                        }

                        //If there exists any machine which belong to M opI, its sequence size is greater or equal than 3.  
                        if (machines[m].getAssignedOperations().size() >= 3) {

                            // In case M performs pbjI, pbjI different from start
                            if (machines[m].getId() == pbjI.getMachineAssigned() && !pbjI.getId().equals("start")) {
                                int cont = 0;

                                for (int w = pbjI.getOrderinMachine(); w < machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ = operations.get(machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                    if ((opJ.getJob() == opI.getJob()) && (opJ.getNumberOfArcs() > opI.getNumberOfArcs())) {
                                        break;
                                    }

                                    Operation opK;
                                    if (opJ.getNextOperationByMachine().equals("endMachine")) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(opJ.getNextOperationByMachine());
                                    }

                                    //Test HTA
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            cont = w;
//                                            Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
//                                            insertions.add(newInsertion);
                                        }
                                    }

                                    if (cont != 0 && w > cont) {
                                        break;
                                    }

                                }
                            }

                            // if m performs nbjI but not pbjI. nbjI different from endByJob
                            if (machines[m].getId() == nbjI.getMachineAssigned() && !nbjI.getId().equals("endByJob_" + opI.getJob()) && pbjI.getMachineAssigned() != machines[m].getId()) {

                                int cont = 0;

                                LinkedList<String> operationsToEvaluate = new LinkedList<>();
                                operationsToEvaluate.addFirst(nbjI.getId());

                                //Determine the feasible insertions since it is a backward startegy
                                for (int w = nbjI.getOrderinMachine(); w >= 1; w--) {

                                    Operation opK = operations.get(machines[nbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));
                                    if (opK.getJob() == opI.getJob() && w < nbjI.getOrderinMachine()) {
                                        break;
                                    }

                                    Operation opJ;
                                    if (opK.getPreviewOperationByMachine().equals("start")) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(opK.getPreviewOperationByMachine());
                                    }
                                    //Test HTA
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {

                                            cont = w;
                                            operationsToEvaluate.addFirst(opJ.getId());
                                        }
                                    }
                                    //A move is unfeasible break cycle
                                    if (cont != 0 && w < cont) {
                                        break;
                                    }

                                }

                                //As soon as the operations are obtained, all are invoked
                                for (int ind = 0; ind < operationsToEvaluate.size() - 1; ind++) {

                                    Operation opJ;
                                    Operation opK;
                                    String opj = operationsToEvaluate.get(ind);
                                    if (opj.equals("start")) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(opj);
                                    }
                                    opK = operations.get(operationsToEvaluate.get(ind + 1));

//                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
                                    //                                  insertions.add(newInsertion);
                                }
                            }
                            //Here finsihes nbjI reassign (line 2745)

                            // This part evaluates from the first operation 
                            if (machines[m].getId() != pbjI.getMachineAssigned() && machines[m].getId() != nbjI.getMachineAssigned()) {

                                //Control variable for escaping as soon as a move is unfeasible
                                int cont = 0;
                                for (int w = 0; w < machines[m].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ;
                                    Operation opK;

                                    if (w == 0) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(machines[m].getAssignedOperations().get(w));
                                    }
                                    if (opJ.getJob() == opI.getJob() && opJ.getNumberOfArcs() > opI.getNumberOfArcs()) {
                                        break;
                                    }
                                    if (w == machines[m].getAssignedOperations().size() - 2) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(machines[m].getAssignedOperations().get(w + 1));
                                    }

                                    //HTA test
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            cont = w;

//                                            Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
//                                            insertions.add(newInsertion);
                                        }
                                    }

                                    if (cont != 0 && w > cont) {
                                        break;
                                    }

                                }
                            }

                        }

                    }
                }

            }

        } else if (type.equals("type2")) {

            operationsTodiversify.add(operationsTomove2.get(((int) (Math.random() * (operationsTomove2.size() - 1 + 1) + 1)) - 1));

            for (int i = 0; i < operationsTodiversify.size(); i++) {

                //Operations related to I are invoked 
                Operation opI = operations.get(operationsTodiversify.get(i));

                Operation nbjI;
                if (opI.getNextOperationByJob().equals("endByJob_" + opI.getJob())) {
                    nbjI = exclusiveOperations.get("endByJob_" + opI.getJob());
                } else {
                    nbjI = operations.get(opI.getNextOperationByJob());
                }

                Operation pbjI;
                if (opI.getPreviewOperationByJob().equals("start")) {
                    pbjI = exclusiveOperations.get("start");
                } else {
                    pbjI = operations.get(opI.getPreviewOperationByJob());
                }
                //-----It is the resequencing process-----------//
                if (machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() > 3) {

                    //-----Forward process -----------//
                    if (opI.getOrderinMachine() >= 1 && opI.getOrderinMachine()
                            <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {

                        //Control variable for escaping if an ubfeasible move is found.
                        int cont = 0;

                        for (int pos = opI.getOrderinMachine(); pos <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3; pos++) {
                            Operation opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 1));

                            if (opJ.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opK;
                            if (pos == machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                                opK = exclusiveOperations.get("endMachine");
                            } else {
                                opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 2));
                            }

                            //The test HTA
                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    cont = pos;
//                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), opI.getMachineAssigned());
//                                    insertions.add(newInsertion);

                                }
                            }
                            if (cont != 0 && pos > cont) {
                                //System.out.println("----Aqui se rompio---" + opI.getId() + "---" + opJ.getId() + "---" + opK.getId());
                                break;
                            }
                        }

                    }
                    //Backward process

                    if (opI.getOrderinMachine() >= 2 && opI.getOrderinMachine() <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 2) {

                        int cont = 0;
                        for (int pos = opI.getOrderinMachine(); pos >= 2; pos--) {

                            Operation opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 1));
                            if (opK.getJob() == opI.getJob()) {
                                break;
                            }

                            Operation opJ;
                            if (pos == 2) {
                                opJ = exclusiveOperations.get("start");
                            } else {
                                opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 2));
                            }

                            if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                    cont = pos;

//                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), opI.getMachineAssigned());
//                                    insertions.add(newInsertion);
                                }
                            }

                            if (cont != 0 && pos < cont) {
                                break;
                            }

                        }

                    }
                }
                //-------Finish resequencing process--------

                //---------Start reasignning process---
                for (int m = 0; m < machines.length; m++) {

                    if (machines[m].getId() != opI.getMachineAssigned() && opI.getTimesInMachine().containsKey(machines[m].getId())) {

                        //If there is at least one machine which belong to M opI. M contains Start and End Machine 
                        if (machines[m].getAssignedOperations().size() < 3) {
//                            Insertion newInsertion = new Insertion(opI.getId(), "start", "endMachine", machines[m].getId());
//                            insertions.add(newInsertion);
                        }

                        //If there exists any machine which belong to M opI, its sequence size is greater or equal than 3.  
                        if (machines[m].getAssignedOperations().size() >= 3) {

                            // In case M performs pbjI, pbjI different from start
                            if (machines[m].getId() == pbjI.getMachineAssigned() && !pbjI.getId().equals("start")) {
                                int cont = 0;

                                for (int w = pbjI.getOrderinMachine(); w < machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ = operations.get(machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                    if ((opJ.getJob() == opI.getJob()) && (opJ.getNumberOfArcs() > opI.getNumberOfArcs())) {
                                        break;
                                    }

                                    Operation opK;
                                    if (opJ.getNextOperationByMachine().equals("endMachine")) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(opJ.getNextOperationByMachine());
                                    }

                                    //Test HTA
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            cont = w;
                                            //                                           Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
                                            //                                           insertions.add(newInsertion);
                                        }
                                    }

                                    if (cont != 0 && w > cont) {
                                        break;
                                    }

                                }
                            }

                            // if m performs nbjI but not pbjI. nbjI different from endByJob
                            if (machines[m].getId() == nbjI.getMachineAssigned() && !nbjI.getId().equals("endByJob_" + opI.getJob()) && pbjI.getMachineAssigned() != machines[m].getId()) {

                                int cont = 0;

                                LinkedList<String> operationsToEvaluate = new LinkedList<>();
                                operationsToEvaluate.addFirst(nbjI.getId());

                                //Determine the feasible insertions since it is a backward startegy
                                for (int w = nbjI.getOrderinMachine(); w >= 1; w--) {

                                    Operation opK = operations.get(machines[nbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));
                                    if (opK.getJob() == opI.getJob() && w < nbjI.getOrderinMachine()) {
                                        break;
                                    }

                                    Operation opJ;
                                    if (opK.getPreviewOperationByMachine().equals("start")) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(opK.getPreviewOperationByMachine());
                                    }
                                    //Test HTA
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {

                                            cont = w;
                                            operationsToEvaluate.addFirst(opJ.getId());
                                        }
                                    }
                                    //A move is unfeasible break cycle
                                    if (cont != 0 && w < cont) {
                                        break;
                                    }

                                }

                                //As soon as the operations are obtained, all are invoked
                                for (int ind = 0; ind < operationsToEvaluate.size() - 1; ind++) {

                                    Operation opJ;
                                    Operation opK;
                                    String opj = operationsToEvaluate.get(ind);
                                    if (opj.equals("start")) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(opj);
                                    }
                                    opK = operations.get(operationsToEvaluate.get(ind + 1));

//                                    Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
//                                    insertions.add(newInsertion);
                                }
                            }
                            //Here finsihes nbjI reassign (line 2745)

                            // This part evaluates from the first operation 
                            if (machines[m].getId() != pbjI.getMachineAssigned() && machines[m].getId() != nbjI.getMachineAssigned()) {

                                //Control variable for escaping as soon as a move is unfeasible
                                int cont = 0;
                                for (int w = 0; w < machines[m].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ;
                                    Operation opK;

                                    if (w == 0) {
                                        opJ = exclusiveOperations.get("start");
                                    } else {
                                        opJ = operations.get(machines[m].getAssignedOperations().get(w));
                                    }
                                    if (opJ.getJob() == opI.getJob() && opJ.getNumberOfArcs() > opI.getNumberOfArcs()) {
                                        break;
                                    }
                                    if (w == machines[m].getAssignedOperations().size() - 2) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(machines[m].getAssignedOperations().get(w + 1));
                                    }

                                    //HTA test
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || opJ.getNumberOfArcs() <= nbjI.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            cont = w;

//                                            Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), machines[m].getId());
//                                            insertions.add(newInsertion);
                                        }
                                    }

                                    if (cont != 0 && w > cont) {
                                        break;
                                    }

                                }
                            }

                        }

                    }
                }

            }

        }
    }

    //Select a random number between 1 and 3.
    static int controltwo() {
        int select = 0;

        double select1 = Math.random();

        if (select1 <= 0.500) {
            select = 1;
        } else {
            select = 3;
        }

        return select;
    }

    // Draw the points of a schedule
    static void doScatterPlot(LinkedList<Schedule> schedulesP) {

        double x[] = new double[schedulesP.size()];
        double y[] = new double[schedulesP.size()];
        double z[] = new double[schedulesP.size()];

        for (int i = 0; i < schedulesP.size(); i++) {
            x[i] = schedulesP.get(i).getCriterion1();
            y[i] = schedulesP.get(i).getCriterion2();
            z[i] = schedulesP.get(i).getCriterion3();
        }

        //PlotPanelSos scatterPlot = new PlotPanelSos("SOUTH");
        //scatterPlot.addScatterPlot("-Schedules--", x, y, z);
        JFrame frame = new JFrame("Scatter plot");
        frame.setSize(800, 600);
        //frame.setContentPane(scatterPlot);
        frame.setDefaultCloseOperation(frame.EXIT_ON_CLOSE);
        frame.setVisible(true);

    }

//-----------------------Start Non-dominated-Points-sets---------------------------------
//These methods allow to update the list of non-dominated points and delete the file 
    static void nodominatedPoints(LinkedList<Schedule> schedulesP) {
        for (int i = 0; i < schedulesP.size(); i++) {
            for (int j = i + 1; j < schedulesP.size(); j++) {
                if ((schedulesP.get(i).getCriterion1() >= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() >= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() >= schedulesP.get(j).getCriterion3())) {
                    File fileDelete = new File(schedulesP.get(i).getAddresFile());
                    fileDelete.delete();
                    schedulesP.remove(i);
                    i--;
                    break;
                }
                if ((schedulesP.get(i).getCriterion1() < schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() < schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() < schedulesP.get(j).getCriterion3())) {
                    File fileDelete = new File(schedulesP.get(j).getAddresFile());
                    fileDelete.delete();
                    schedulesP.remove(j);
                    j--;
                }

            }

        }

    }

//-----------------------Finish Non-dominated-Points-sets---------------------------------    
//-----Start Method to determine the non-dominated points, it does not include the file address         
    static void nodominatedPointsTest(LinkedList<Schedule> schedulesP) {
        for (int i = 0; i < schedulesP.size(); i++) {
            for (int j = i + 1; j < schedulesP.size(); j++) {
                if ((schedulesP.get(i).getCriterion1() >= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() >= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() >= schedulesP.get(j).getCriterion3())) {
                    schedulesP.remove(i);
                    i--;
                    break;
                }
                if ((schedulesP.get(i).getCriterion1() < schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() < schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() < schedulesP.get(j).getCriterion3())) {
                    schedulesP.remove(j);
                    j--;
                }

            }

        }

    }

    //-----End Method to determine the non-dominated points, it does not include the file address only is used for final set
    //This method is used to detemine if a list enters in a list of non-dominated points
    static boolean enterToNDP(int c1, int c2, int c3, Schedule s1, Schedule s2, Schedule s3) {
        boolean enter = false;
        //S1 does not domain the new schedule
        if (s1.getCriterion1() > c1 || s1.getCriterion2() > c2 || s1.getCriterion3() > c3) {
            // S2 does not domain the new possible schedule
            if (s2.getCriterion1() > c1 || s2.getCriterion2() > c2 || s2.getCriterion3() > c3) {
                // S3 does not domain the new possible schedule
                if (s3.getCriterion1() > c1 || s3.getCriterion2() > c2 || s3.getCriterion3() > c3) {
                    enter = true;
                }
            }
        }
        return enter;

    }

    static boolean enterToNDPTotal(int c1, int c2, int c3, LinkedList<Schedule> schedulesRef) {
        boolean enter = false;
        int win = 0;
        int lost = 0;

        for (int i = 0; i < schedulesRef.size(); i++) {
            if (schedulesRef.get(i).getCriterion1() <= c1 && schedulesRef.get(i).getCriterion2() <= c2 && schedulesRef.get(i).getCriterion3() <= c3) {
                lost++;
                break;
            }
            if ((schedulesRef.get(i).getCriterion1() > c1 && schedulesRef.get(i).getCriterion2() >= c2 && schedulesRef.get(i).getCriterion3() >= c3)
                    || (schedulesRef.get(i).getCriterion1() >= c1 && schedulesRef.get(i).getCriterion2() > c2 && schedulesRef.get(i).getCriterion3() >= c3)
                    || (schedulesRef.get(i).getCriterion1() >= c1 && schedulesRef.get(i).getCriterion2() >= c2 && schedulesRef.get(i).getCriterion3() > c3)) {
                win++;
            }

        }
        if (win >= 0 && lost == 0) {
            enter = true;
        }
        return enter;
    }

    //This method determines the weakly dominance between to sets of schedules SP and SQ
    //-----1 means SP dominates to SQ
    //-----0 means SP and SQ do not have any dominance
    //----(-1) means SQ domains to SP. 
    //----2 means beetwen them there self dominance
    static int sDomainQ(LinkedList<Schedule> schedulesP, LinkedList<Schedule> schedulesQ) {
        int domain = 0;
        boolean domain1 = false;
        boolean domain2 = false;
        //S1 to S2
        for (int i = 0; i < schedulesP.size(); i++) {
            int win = 0;
            for (int j = 0; j < schedulesQ.size(); j++) {
                if ((schedulesP.get(i).getCriterion1() < schedulesQ.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesQ.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesQ.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesQ.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() < schedulesQ.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() <= schedulesQ.get(j).getCriterion3())
                        || (schedulesP.get(i).getCriterion1() <= schedulesQ.get(j).getCriterion1() && schedulesP.get(i).getCriterion2() <= schedulesQ.get(j).getCriterion2() && schedulesP.get(i).getCriterion3() < schedulesQ.get(j).getCriterion3())) {
                    domain1 = true;
                    break;
                }
            }
            if (domain1 == true) {
                break;
            }
        }

        //S2 to S1
        for (int i = 0; i < schedulesQ.size(); i++) {
            int win = 0;
            for (int j = 0; j < schedulesP.size(); j++) {
                if ((schedulesQ.get(i).getCriterion1() < schedulesP.get(j).getCriterion1() && schedulesQ.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesQ.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesQ.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesQ.get(i).getCriterion2() < schedulesP.get(j).getCriterion2() && schedulesQ.get(i).getCriterion3() <= schedulesP.get(j).getCriterion3())
                        || (schedulesQ.get(i).getCriterion1() <= schedulesP.get(j).getCriterion1() && schedulesQ.get(i).getCriterion2() <= schedulesP.get(j).getCriterion2() && schedulesQ.get(i).getCriterion3() < schedulesP.get(j).getCriterion3())) {
                    domain2 = true;
                    break;
                }
            }
            if (domain2 == true) {
                break;
            }
        }
        if (domain1 == true && domain2 == false) {
            domain = 1;
        } else if (domain1 == true && domain2 == true) {
            domain = 2;
        } else if (domain1 == false && domain2 == false) {
            domain = 0;
        } else if (domain1 == false && domain2 == true) {
            domain = -1;
        }

        return domain;
    }

    //-------------New methods for solving the quality of the estimation function----------
    //This method transforms the graph from the current to j-k
    static void createSolutionForward(String opi, String opj, String opk, String ops, String opt, int mach) {

        Operation opI = operations.get(opi);
        Operation opJ;
        Operation opK;
        Operation opS;
        Operation opT;

        if (opj.equals("start")) {
            opJ = exclusiveOperations.get("start");
        } else {
            opJ = operations.get(opj);;
        }
        if (opk.equals("endMachine")) {
            opK = exclusiveOperations.get("endMachine");
        } else {
            opK = operations.get(opk);
        }

        if (ops.equals("start")) {
            opS = exclusiveOperations.get("start");
        } else {
            opS = operations.get(opI.getPreviewOperationByMachine());
        }
        if (opt.equals("endMachine")) {
            opT = exclusiveOperations.get("endMachine");
        } else {
            opT = operations.get(opI.getNextOperationByMachine());
        }

        opI.setNextOperationByMachine(opK.getId());
        opI.setPreviewOperationByMachine(opJ.getId());
        opI.setMachineAssigned(mach);
        opI.setTimeMachine(opI.getTimesInMachine().get(opI.getMachineAssigned()));
        operations.put(opI.getId(), opI);
        if (!opJ.getId().equals("start")) {
            opJ.setNextOperationByMachine(opI.getId());
            operations.put(opJ.getId(), opJ);
        }
        if (!opK.getId().equals("endMachine")) {
            opK.setPreviewOperationByMachine(opI.getId());
            operations.put(opK.getId(), opK);
        }
        if (!opS.getId().equals("start")) {
            opS.setNextOperationByMachine(opT.getId());
            operations.put(opS.getId(), opS);
        }
        if (!opT.getId().equals("endMachine")) {
            opT.setPreviewOperationByMachine(opS.getId());
            operations.put(opT.getId(), opT);
        }

    }

    static void deleteStructureTemporal(String type) {
        //Delete the assigned operations to the machines and add Start
        deleteAndIntStartinMachines();
        //Delete Bellman
        bellmanOrder.clear();
        //Set start time, completion time.
        updateOperations();
        //Add *(end Machine)
        addendMachine();
        if (type.equals("type1")) {
            operationsTomove1.clear();
        } else {
            operationsTomove2.clear();
        }
    }

    public static LinkedList<LinkedList<String>> getBellmanOrder() {
        return bellmanOrder;
    }

    public static void setBellmanOrder(LinkedList<LinkedList<String>> bellmanOrder) {
        FJSProyect.bellmanOrder = bellmanOrder;
    }

    //This method count the improving moves in resequencing
    public static int[] getOrderOfJobs() {
        return orderOfJobs;
    }

    public static void setOrderOfJobs(int[] orderOfJobs) {
        FJSProyect.orderOfJobs = orderOfJobs;
    }

    public static int getMaxOperationPerJob() {
        return maxOperationPerJob;
    }

    public static void setMaxOperationPerJob(int maxOperationPerJob) {
        FJSProyect.maxOperationPerJob = maxOperationPerJob;
    }

    static void feasibleInsertionsYazid1(String type, int criterionValue, String criterion, LinkedList<Integer> orderJobs) {

        // Set that Saves the operations to move
        LinkedList<String> operationsTomove = new LinkedList<>();
        //In order to protect the order of the jobs
        LinkedList<Integer> orderTemp = new LinkedList<>();
        // Real value of the criterion if a move were done
        int criterionValueTemp;
        // Best value of the move in realInsertions
        int bestMove = -Operation.MINIMUN_TAIL;

        if (type.equals("type1")) {
            //The operations to move of N1 are saved, since the graph is partially transformed and return to the same position
            for (int li = 0; li < operationsTomove1.size(); li++) {
                operationsTomove.add(operationsTomove1.get(li));
            }
        } else {
            //The operations to move of N12 are saved, since the graph is partially transformed and return to the same position
            for (int li = 0; li < operationsTomove2.size(); li++) {
                operationsTomove.add(operationsTomove2.get(li));
            }
        }
        for (int i = 0; i < operationsTomove.size(); i++) {
            //Operations related to I are invoked 
            Operation opI = operations.get(operationsTomove.get(i));
            int mach = opI.getMachineAssigned();
            //preview operation by machine
            Operation opS;
            if (opI.getPreviewOperationByMachine().equals("start")) {
                opS = exclusiveOperations.get("start");
            } else {
                opS = operations.get(opI.getPreviewOperationByMachine());
            }
            //Next operation by machine of I
            Operation opT;
            if (opI.getNextOperationByMachine().equals("endMachine")) {
                opT = exclusiveOperations.get("endMachine");
            } else {
                opT = operations.get(opI.getNextOperationByMachine());
            }

            //Next operation by job of I
            Operation nbjI;
            if (opI.getNextOperationByJob().equals("endByJob_" + opI.getJob())) {
                nbjI = exclusiveOperations.get("endByJob_" + opI.getJob());
            } else {
                nbjI = operations.get(opI.getNextOperationByJob());
            }
            //Preview operatioin by job of I
            Operation pbjI;
            if (opI.getPreviewOperationByJob().equals("start")) {
                pbjI = exclusiveOperations.get("start");
            } else {
                pbjI = operations.get(opI.getPreviewOperationByJob());
            }

            //-----It is the resequencing process-----------//
            if (machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() > 3) {

                //-----Forward process (Case 1 is applied)-----------//
                if (opI.getOrderinMachine() >= 1 && opI.getOrderinMachine()
                        <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                    //The position of the operation in the machine is located then advancing in the move search
                    for (int pos = opI.getOrderinMachine(); pos <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3; pos++) {
                        Operation opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 1));
                        //If the job of J is the same of I, the cycle is broken
                        if (opJ.getJob() == opI.getJob()) {
                            break;
                        }
                        // The Operation k is invoked
                        Operation opK;
                        if (pos == machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 3) {
                            opK = exclusiveOperations.get("endMachine");
                        } else {
                            opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos + 2));
                        }

                        //Starts The test H test as soon as J and K are defined
                        if (opJ.getStartTime() < nbjI.getCompletionTime()) {
                            if (opK.getCompletionTime() > pbjI.getStartTime()) {
                                Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), mach);
                                insertions.add(newInsertion);
                            }
                        }
                    }
                }

                //Backward process
                if (opI.getOrderinMachine() >= 2 && opI.getOrderinMachine() <= machines[opI.getMachineAssigned() - 1].getAssignedOperations().size() - 2) {
                    for (int pos = opI.getOrderinMachine(); pos >= 2; pos--) {
                        Operation opK = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 1));
                        // If opK belongs to the same job of opI is broken cycle
                        if (opK.getJob() == opI.getJob()) {
                            break;
                        }

                        Operation opJ;
                        if (pos == 2) {
                            opJ = exclusiveOperations.get("start");
                        } else {
                            opJ = operations.get(machines[opI.getMachineAssigned() - 1].getAssignedOperations().get(pos - 2));
                        }

                        //Starts The test H test as soon as J and K are defined
                        if (opJ.getStartTime() < nbjI.getCompletionTime()) {
                            if (opK.getCompletionTime() > pbjI.getStartTime()) {
                                Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), mach);
                                insertions.add(newInsertion);
                            }
                        }
                    }
                }
            }
                //-------Finish resequencing process--------

            //---------Start reasignning process---
            if (opI.getTimesInMachine().size() > 1) {
                Iterator itr = opI.getTimesInMachine().entrySet().iterator();
                while (itr.hasNext()) {
                    Map.Entry e = (Map.Entry) itr.next();
                    int mq = e.getKey().hashCode();
                    int timq = e.getValue().hashCode();
                    if (machines[mq - 1].getId() != opI.getMachineAssigned()) {
                        //If there is at least one machine which belong to M of opI / M contains only Start and End Machine
                        if (machines[mq - 1].getAssignedOperations().size() < 3) {
                            Insertion newInsertion = new Insertion(opI.getId(), "start", "endMachine", mq);
                            insertions.add(newInsertion);
                        } else {
                            // In case M performs pbjI, pbjI different from start
                            if (machines[mq - 1].getId() == pbjI.getMachineAssigned() && !pbjI.getId().equals("start")) {
                                for (int w = pbjI.getOrderinMachine(); w < machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().size() - 1; w++) {
                                    Operation opJ = operations.get(machines[pbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                    if ((opJ.getJob() == opI.getJob()) && (opJ.getNumberOfArcs() > opI.getNumberOfArcs())) {
                                        break;
                                    }

                                    Operation opK;
                                    if (opJ.getNextOperationByMachine().equals("endMachine")) {
                                        opK = exclusiveOperations.get("endMachine");
                                    } else {
                                        opK = operations.get(opJ.getNextOperationByMachine());
                                    }
                                    //Starts The test HTA test as soon as J and K are defined
                                    if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                        if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                            Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), mq);
                                            insertions.add(newInsertion);
                                        }
                                    }//Close Test HTA
                                }
                            } else {
                                // if m performs nbjI but not pbjI. nbjI different from endByJob
                                if (machines[mq - 1].getId() == nbjI.getMachineAssigned() && !nbjI.getId().equals("endByJob_" + opI.getJob()) && pbjI.getMachineAssigned() != machines[mq - 1].getId()) {
                                    //Determine the feasible insertions since it is a backward strategy
                                    for (int w = nbjI.getOrderinMachine(); w >= 1; w--) {
                                        Operation opK = operations.get(machines[nbjI.getMachineAssigned() - 1].getAssignedOperations().get(w));

                                        if (opK.getJob() == opI.getJob() && w < nbjI.getOrderinMachine()) {
                                            break;
                                        }
                                        Operation opJ;
                                        if (opK.getPreviewOperationByMachine().equals("start")) {
                                            opJ = exclusiveOperations.get("start");
                                        } else {
                                            opJ = operations.get(opK.getPreviewOperationByMachine());
                                        }
                                        //Starts The test HTA test as soon as J and K are defined
                                        if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                            if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                                Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), mq);
                                                insertions.add(newInsertion);
                                            }
                                        }//Close Test HTA
                                    }
                                } else {
                                    // This part evaluates from the first operation 
                                    for (int w = 0; w < machines[mq - 1].getAssignedOperations().size() - 1; w++) {
                                        //Invoke k
                                        Operation opJ;
                                        Operation opK;
                                        if (w == 0) {
                                            opJ = exclusiveOperations.get("start");
                                        } else {
                                            opJ = operations.get(machines[mq - 1].getAssignedOperations().get(w));
                                        }
                                        //Condition to finish the search
                                        if (opJ.getJob() == opI.getJob() && opJ.getNumberOfArcs() > opI.getNumberOfArcs()) {
                                            break;
                                        }
                                        if (w == machines[mq - 1].getAssignedOperations().size() - 2) {
                                            opK = exclusiveOperations.get("endMachine");
                                        } else {
                                            opK = operations.get(machines[mq - 1].getAssignedOperations().get(w + 1));
                                        }

                                        //Starts The test HTA test as soon as J and K are defined
                                        if (opJ.getStartTime() < nbjI.getCompletionTime() || nbjI.getTailMax() < opJ.getTailMax() + opJ.getTimeMachine() || nbjI.getNumberOfArcs() >= opJ.getNumberOfArcs()) {
                                            if (opK.getCompletionTime() > pbjI.getStartTime() || pbjI.getTailMax() + pbjI.getTimeMachine() > opK.getTailMax() || opK.getNumberOfArcs() >= pbjI.getNumberOfArcs()) {
                                                Insertion newInsertion = new Insertion(opI.getId(), opJ.getId(), opK.getId(), mq);
                                                insertions.add(newInsertion);
                                            }
                                        }//Close Test HTA
                                    }

                                }

                            }

                        }

                    }

                }
            }

        }

        if (!insertions.isEmpty()) {
            int sel = (int) (Math.random() * (insertions.size()));
            String j1 = insertions.get(sel).getNodej();
            String x1 = insertions.get(sel).getNodei();
            String k1 = insertions.get(sel).getNodek();
            int macSel = insertions.get(sel).getMachine();
            Operation opI = operations.get(x1);
            createSolutionForward(x1, j1, k1, opI.getPreviewOperationByMachine(), opI.getNextOperationByMachine(), macSel);
            deleteStructureTemporal(type);
            insertions.clear();
        }
    } //Close homework of Yazid diversification

    static int calculateMakespan() {
        int makespan = 0;
        for (int order = 1; order <= jobs.size(); order++) {
            Operation last = operations.get(jobs.get(order).getJobOperations().getLast());
            int ref = last.getCompletionTime();
            if (ref > makespan) {
                makespan = ref;
            }
        }
        return makespan;
    }

    public static int getCase3() {
        return case3;
    }

    public static void setCase3(int case3) {
        FJSProyect.case3 = case3;
    }

}
