/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package fjsproyect;

import java.util.LinkedList;

/**
 *
 * @author Andres_Garcia
 */
public class Machine {
    //Identification of the machine
    private int id;
    //Operations assigned to the machine
    private LinkedList<String> assignedOperations;
    //Highest time of the machine
    private LinkedList<String> assignRecord;
    // Acumulative time of the machine
    private int timeClock;
    private LinkedList<String> operationsToperform;

    public Machine() {
        this.id = 0;
        this.assignedOperations = new LinkedList<String>() ;
        this.assignRecord = new LinkedList<String>();
        this.operationsToperform = new LinkedList<String>();
        this.timeClock=0;
    }

    public int getTimeClock() {
        return timeClock;
    }

    public void setTimeClock(int timeClock) {
        this.timeClock = timeClock;
    }
 public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public LinkedList<String> getAssignedOperations() {
        return assignedOperations;
    }

    public void setAssignedOperations(LinkedList<String> assignedOperations) {
        this.assignedOperations = assignedOperations;
    }

    public LinkedList<String> getAssignRecord() {
        return assignRecord;
    }

    public void setAssignRecord(LinkedList<String> assignRecord) {
        this.assignRecord = assignRecord;
    }
    
    public void addNewOperation(String operation) {
        assignedOperations.add(operation);
    }
    
    public void addRecord(String record) {
        assignRecord.add(record);
    }

    public void addOperationToPerform(String operation) {
        operationsToperform.add(operation);
    }
    
    
    public LinkedList<String> getOperationsToperform() {
        return operationsToperform;
    }

    public void setOperationsToperform(LinkedList<String> operationsToperform) {
        this.operationsToperform = operationsToperform;
    }
    
    
    
    
    
    
}
